/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/addrregistry.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_addrregistry.h"
#include "pmc_default.h"
#include "addrregistry.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/addrregistry.pmc"
/*
Copyright (C) 2005-2014, Parrot Foundation.

=head1 NAME

src/pmc/addrregistry.pmc - AddrRegistry PMC

=head1 DESCRIPTION

The AddrRegistry class provides the equivalence of reference counts
mainly for extenders and embedders of Parrot. The hash keys are the
addresses of the key PMC, values are reference counts, i.e. the
difference of (set_pmc_keyed - delete_pmc_keyed). If the reference
goes to zero, the entry is deleted physically.

Please note that you have to anchor an instance of AddrRegistry yourself with
C<Parrot_register_pmc> if it isn't visible to Parrot.

=head2 Functions

=over 4

=cut

*/

#include "parrot/hash.h"
#include "pmc/pmc_hash.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */
#line 55 "./src/pmc/addrregistry.c"
static  void  Parrot_AddrRegistry_delete_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  void  Parrot_AddrRegistry_delete_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key);
static  void  Parrot_AddrRegistry_destroy(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_AddrRegistry_elements(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_AddrRegistry_get_bool(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_AddrRegistry_get_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  void  Parrot_AddrRegistry_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_AddrRegistry_mark(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_AddrRegistry_set_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, INTVAL value);
static  void  Parrot_AddrRegistry_set_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, SHIM(PMC *value));
static  void  Parrot_AddrRegistry_set_pmc_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, SHIM(PMC *value));
void    Parrot_AddrRegistry_class_init(PARROT_INTERP, int, int);
void    Parrot_AddrRegistry_ro_class_init(PARROT_INTERP, int, int);
static  void 
Parrot_AddrRegistry_delete_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 223 "./src/pmc/addrregistry.pmc"

    Hash       *hash;
    void       *value;

    GETATTR_AddrRegistry_pmc_registry(interp, _self, hash);
    value = Parrot_hash_get(interp, hash, key);

    /* these casts look bad, but they avoid type punning warnings with -O */
    if (value) {
        ptrcast_t val = (ptrcast_t)value;
        if (val == 1)
            Parrot_hash_delete(interp, hash, key);
        else {
            value = (void *)(--val);
            Parrot_hash_put(interp, hash, key, value);
        }
    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 91 "./src/pmc/addrregistry.c"
}
static  void 
Parrot_AddrRegistry_delete_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key)
{
#line 242 "./src/pmc/addrregistry.pmc"

    Hash       *hash;
    void       *value;

    GETATTR_AddrRegistry_str_registry(interp, _self, hash);
    value = Parrot_hash_get(interp, hash, key);

    /* these casts look bad, but they avoid type punning warnings with -O */
    if (value) {
        ptrcast_t val = (ptrcast_t)value;
        if (val == 1)
            Parrot_hash_delete(interp, hash, key);
        else {
            value = (void *)(--val);
            Parrot_hash_put(interp, hash, key, value);
        }
    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 115 "./src/pmc/addrregistry.c"
}
static  void 
Parrot_AddrRegistry_destroy(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 96 "./src/pmc/addrregistry.pmc"

    Hash *str_registry, *pmc_registry;

    GETATTR_AddrRegistry_str_registry(interp, _self, str_registry);
    GETATTR_AddrRegistry_pmc_registry(interp, _self, pmc_registry);

    Parrot_hash_destroy(interp, pmc_registry);
    Parrot_hash_destroy(interp, str_registry);

    SETATTR_AddrRegistry_str_registry(interp, _self, NULL);
    SETATTR_AddrRegistry_pmc_registry(interp, _self, NULL);

#line 133 "./src/pmc/addrregistry.c"
}
static  INTVAL 
Parrot_AddrRegistry_elements(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 143 "./src/pmc/addrregistry.pmc"

    const Hash *pmc_registry, *str_registry;

    GETATTR_AddrRegistry_pmc_registry(interp, _self, pmc_registry);
    GETATTR_AddrRegistry_str_registry(interp, _self, str_registry);

    return Parrot_hash_size(interp, pmc_registry) +
           Parrot_hash_size(interp, str_registry);
#line 147 "./src/pmc/addrregistry.c"
}
static  INTVAL 
Parrot_AddrRegistry_get_bool(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 153 "./src/pmc/addrregistry.pmc"

    const Hash *pmc_registry, *str_registry;

    GETATTR_AddrRegistry_pmc_registry(interp, _self, pmc_registry);
    GETATTR_AddrRegistry_str_registry(interp, _self, str_registry);

    return (Parrot_hash_size(interp, pmc_registry) +
            Parrot_hash_size(interp, str_registry)) != 0;
#line 161 "./src/pmc/addrregistry.c"
}
static  INTVAL 
Parrot_AddrRegistry_get_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 130 "./src/pmc/addrregistry.pmc"

    Hash       *hash;
    const void *value;

    GETATTR_AddrRegistry_pmc_registry(interp, _self, hash);
    value = Parrot_hash_get(interp, hash, key);

    if (value)
        return (INTVAL)value;

    return 0;
#line 178 "./src/pmc/addrregistry.c"
}
static  void 
Parrot_AddrRegistry_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 48 "./src/pmc/addrregistry.pmc"

    Hash * const pmc_registry = Parrot_hash_create(interp,
            enum_type_int,
            Hash_key_type_PMC_ptr);

    Hash * const str_registry = Parrot_hash_create(interp,
            enum_type_int,
            Hash_key_type_STRING);

    SETATTR_AddrRegistry_pmc_registry(interp, _self, pmc_registry);
    SETATTR_AddrRegistry_str_registry(interp, _self, str_registry);
    PObj_custom_mark_destroy_SETALL(_self);

    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 198 "./src/pmc/addrregistry.c"
}
static  void 
Parrot_AddrRegistry_mark(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 74 "./src/pmc/addrregistry.pmc"

    Hash *str_registry, *pmc_registry;

    GETATTR_AddrRegistry_str_registry(interp, _self, str_registry);
    GETATTR_AddrRegistry_pmc_registry(interp, _self, pmc_registry);

    Parrot_hash_mark(interp, pmc_registry);
    Parrot_hash_mark(interp, str_registry);

#line 213 "./src/pmc/addrregistry.c"
}
static  void 
Parrot_AddrRegistry_set_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, INTVAL value)
{
#line 217 "./src/pmc/addrregistry.pmc"

    Hash *hash;
    GETATTR_AddrRegistry_pmc_registry(interp, _self, hash);
    Parrot_hash_put(interp, hash, key, (void *)value);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 224 "./src/pmc/addrregistry.c"
}
static  void 
Parrot_AddrRegistry_set_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, SHIM(PMC *value))
{
#line 185 "./src/pmc/addrregistry.pmc"
    const void *oldval;
    ptrcast_t   newval = 1;
    Hash       *hash;

    GETATTR_AddrRegistry_pmc_registry(interp, _self, hash);

    oldval = Parrot_hash_get(interp, hash, key);

    if (oldval)
        newval += (ptrcast_t)oldval;

    Parrot_hash_put(interp, hash, key, (void *)newval);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 243 "./src/pmc/addrregistry.c"
}
static  void 
Parrot_AddrRegistry_set_pmc_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, SHIM(PMC *value))
{
#line 201 "./src/pmc/addrregistry.pmc"
    const void *oldval;
    ptrcast_t   newval = 1;
    Hash       *hash;

    GETATTR_AddrRegistry_str_registry(interp, _self, hash);

    oldval = Parrot_hash_get(interp, hash, key);

    if (oldval)
        newval += (ptrcast_t)oldval;

    Parrot_hash_put(interp, hash, key, (void *)newval);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 262 "./src/pmc/addrregistry.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_AddrRegistry_update_vtable(VTABLE *vt) {
    vt->delete_keyed = Parrot_AddrRegistry_delete_keyed;
    vt->delete_keyed_str = Parrot_AddrRegistry_delete_keyed_str;
    vt->destroy = Parrot_AddrRegistry_destroy;
    vt->elements = Parrot_AddrRegistry_elements;
    vt->get_bool = Parrot_AddrRegistry_get_bool;
    vt->get_integer_keyed = Parrot_AddrRegistry_get_integer_keyed;
    vt->init = Parrot_AddrRegistry_init;
    vt->mark = Parrot_AddrRegistry_mark;
    vt->set_integer_keyed = Parrot_AddrRegistry_set_integer_keyed;
    vt->set_pmc_keyed = Parrot_AddrRegistry_set_pmc_keyed;
    vt->set_pmc_keyed_str = Parrot_AddrRegistry_set_pmc_keyed_str;
    vt->attr_size = sizeof(Parrot_AddrRegistry_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_AddrRegistry_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->destroy = Parrot_AddrRegistry_destroy;
    vt->elements = Parrot_AddrRegistry_elements;
    vt->get_bool = Parrot_AddrRegistry_get_bool;
    vt->get_integer_keyed = Parrot_AddrRegistry_get_integer_keyed;
    vt->mark = Parrot_AddrRegistry_mark;
    vt->attr_size = sizeof(Parrot_AddrRegistry_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_AddrRegistry_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_AddrRegistry_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_AddrRegistry_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_AddrRegistry_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_AddrRegistry_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "AddrRegistry"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_AddrRegistry_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "AddrRegistry")), PMCNULL);
    return isa;
}

void
Parrot_AddrRegistry_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":pmc_registry :str_registry ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_AddrRegistry_get_vtable(interp);
        vt->base_type      = enum_class_AddrRegistry;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "AddrRegistry");
        vt->provides_str = CONST_STRING_GEN(interp, "hash");
        vt->isa_hash     = Parrot_AddrRegistry_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_AddrRegistry_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_AddrRegistry;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_AddrRegistry_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_AddrRegistry_class_init */

#line 260 "./src/pmc/addrregistry.pmc"


/*

=back

=head1 SEE ALSO

F<src/pmc.c:gc_register_pmc()>

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
