/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/arrayiterator.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_arrayiterator.h"
#include "pmc_iterator.h"
#include "pmc_default.h"
#include "arrayiterator.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/arrayiterator.pmc"
/*
Copyright (C) 2001-2014, Parrot Foundation.

=head1 NAME

src/pmc/arrayiterator.pmc - ArrayIterator PMC

=head1 DESCRIPTION

Generic iterator for traversing arrays.

=head1 SYNOPSIS

=head2 default usage

    .local pmc iterator, array, entry
    iterator = iter array
  iter_loop:
    unless iterator, iter_end  # while (more values)
    entry = shift iterator     # get an entry
    ...
    goto iter_loop
  iter_end:


=head2 iterate from the end, for arrays

    .local pmc iterator, array, entry
    iterator = iter array
    iterator = .ITERATE_FROM_END
  iter_loop:
    unless iterator, iter_end  # while (more values)
    entry = pop iterator     # get an entry
    ...
    goto iter_loop
  iter_end:

=head2 Warning!

NB: for different direction you have to use different ops!

TODO: Discuss idea of having separate get_iter/get_reverse_iter VTABLEs
to avoid this caveat.

=head1 Vtable functions

=over 4

=cut

*/

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

PARROT_DOES_NOT_RETURN
static void out_of_bounds(PARROT_INTERP)
        __attribute__nonnull__(1);

#define ASSERT_ARGS_out_of_bounds __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */
#line 88 "./src/pmc/arrayiterator.c"
static  PMC*  Parrot_ArrayIterator_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_ArrayIterator_defined_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  INTVAL  Parrot_ArrayIterator_defined_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx);
static  INTVAL  Parrot_ArrayIterator_elements(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_ArrayIterator_exists_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  INTVAL  Parrot_ArrayIterator_exists_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx);
static  INTVAL  Parrot_ArrayIterator_get_bool(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_ArrayIterator_get_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_ArrayIterator_get_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  INTVAL  Parrot_ArrayIterator_get_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx);
static  FLOATVAL  Parrot_ArrayIterator_get_number_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  FLOATVAL  Parrot_ArrayIterator_get_number_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx);
static  PMC  * Parrot_ArrayIterator_get_pmc(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_ArrayIterator_get_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  PMC  * Parrot_ArrayIterator_get_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx);
static  STRING  * Parrot_ArrayIterator_get_string_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  STRING  * Parrot_ArrayIterator_get_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx);
static  void  Parrot_ArrayIterator_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ArrayIterator_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *array);
static  void  Parrot_ArrayIterator_mark(PARROT_INTERP, ARGMOD(PMC *_self));
static  FLOATVAL  Parrot_ArrayIterator_pop_float(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_ArrayIterator_pop_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_ArrayIterator_pop_pmc(PARROT_INTERP, ARGMOD(PMC *_self));
static  STRING  * Parrot_ArrayIterator_pop_string(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ArrayIterator_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  FLOATVAL  Parrot_ArrayIterator_shift_float(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_ArrayIterator_shift_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_ArrayIterator_shift_pmc(PARROT_INTERP, ARGMOD(PMC *_self));
static  STRING  * Parrot_ArrayIterator_shift_string(PARROT_INTERP, ARGMOD(PMC *_self));
void    Parrot_ArrayIterator_class_init(PARROT_INTERP, int, int);
void    Parrot_ArrayIterator_ro_class_init(PARROT_INTERP, int, int);
static  PMC* 
Parrot_ArrayIterator_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 134 "./src/pmc/arrayiterator.pmc"

    INTVAL pos, reverse;
    PMC   *array;
    PMC   *clone;

    GETATTR_ArrayIterator_array(interp, _self, array);
    GETATTR_ArrayIterator_pos(interp, _self, pos);
    GETATTR_ArrayIterator_reverse(interp, _self, reverse);

    clone = Parrot_pmc_new_init(interp, enum_class_ArrayIterator, array);
    PARROT_GC_WRITE_BARRIER(interp, _self);

    SETATTR_ArrayIterator_pos(interp, clone, pos);
    SETATTR_ArrayIterator_reverse(interp, clone, reverse);

    return clone;
#line 140 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_defined_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 632 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_defined_keyed_int(interp, _self, VTABLE_get_integer(interp, key));
#line 148 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_defined_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx)
{
#line 646 "./src/pmc/arrayiterator.pmc"

    INTVAL pos, reverse, final_pos;
    PMC   *array;

    GETATTR_ArrayIterator_pos(interp, _self, pos);
    GETATTR_ArrayIterator_reverse(interp, _self, reverse);
    GETATTR_ArrayIterator_array(interp, _self, array);

    /* Cheat! */
    final_pos = pos + idx - reverse;

    return VTABLE_defined_keyed_int(interp, array, final_pos);
#line 166 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_elements(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 176 "./src/pmc/arrayiterator.pmc"

    INTVAL reverse;

    GETATTR_ArrayIterator_reverse(interp, _self, reverse);

    if (reverse) {
        INTVAL pos;
        GETATTR_ArrayIterator_pos(interp, _self, pos);
        return pos;
    }
    else {
        INTVAL pos, length;
        GETATTR_ArrayIterator_length(interp, _self, length);
        GETATTR_ArrayIterator_pos(interp, _self, pos);
        return length - pos;
    }
#line 188 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_exists_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 596 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_exists_keyed_int(interp, _self, VTABLE_get_integer(interp, key));
#line 196 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_exists_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx)
{
#line 610 "./src/pmc/arrayiterator.pmc"

    INTVAL pos, reverse, final_pos;
    PMC   *array;

    GETATTR_ArrayIterator_pos(interp, _self, pos);
    GETATTR_ArrayIterator_reverse(interp, _self, reverse);
    GETATTR_ArrayIterator_array(interp, _self, array);

    /* Cheat! */
    final_pos = pos + idx - reverse;

    return VTABLE_exists_keyed_int(interp, array, final_pos);
#line 214 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_get_bool(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 162 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_elements(interp, _self) > 0;
#line 222 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_get_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 194 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_elements(interp, _self);
#line 230 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_get_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 499 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_get_integer_keyed_int(interp, _self, VTABLE_get_integer(interp, key));
#line 238 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_get_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx)
{
#line 513 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;

    GETATTR_ArrayIterator_pos(interp, _self, pos);

    return VTABLE_get_integer_keyed_int(interp, Parrot_ArrayIterator_get_pmc(interp, _self),
            pos + idx);
#line 251 "./src/pmc/arrayiterator.c"
}
static  FLOATVAL 
Parrot_ArrayIterator_get_number_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 530 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_get_number_keyed_int(interp, _self, VTABLE_get_integer(interp, key));
#line 259 "./src/pmc/arrayiterator.c"
}
static  FLOATVAL 
Parrot_ArrayIterator_get_number_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx)
{
#line 544 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;

    GETATTR_ArrayIterator_pos(interp, _self, pos);

    return VTABLE_get_number_keyed_int(interp, Parrot_ArrayIterator_get_pmc(interp, _self),
            pos + idx);
#line 272 "./src/pmc/arrayiterator.c"
}
static  PMC  *
Parrot_ArrayIterator_get_pmc(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 244 "./src/pmc/arrayiterator.pmc"

    PMC *array;
    GETATTR_ArrayIterator_array(interp, _self, array);
    return array ? array : PMCNULL;
#line 282 "./src/pmc/arrayiterator.c"
}
static  PMC  *
Parrot_ArrayIterator_get_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 469 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_get_pmc_keyed_int(interp, _self, VTABLE_get_integer(interp, key));
#line 290 "./src/pmc/arrayiterator.c"
}
static  PMC  *
Parrot_ArrayIterator_get_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx)
{
#line 483 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;

    GETATTR_ArrayIterator_pos(interp, _self, pos);

    return VTABLE_get_pmc_keyed_int(interp, Parrot_ArrayIterator_get_pmc(interp, _self),
            pos + idx);
#line 303 "./src/pmc/arrayiterator.c"
}
static  STRING  *
Parrot_ArrayIterator_get_string_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 563 "./src/pmc/arrayiterator.pmc"

    return Parrot_ArrayIterator_get_string_keyed_int(interp, _self, VTABLE_get_integer(interp, key));
#line 311 "./src/pmc/arrayiterator.c"
}
static  STRING  *
Parrot_ArrayIterator_get_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx)
{
#line 577 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;

    GETATTR_ArrayIterator_pos(interp, _self, pos);

    return VTABLE_get_string_keyed_int(interp, Parrot_ArrayIterator_get_pmc(interp, _self),
            pos + idx);
#line 324 "./src/pmc/arrayiterator.c"
}
static  void 
Parrot_ArrayIterator_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 83 "./src/pmc/arrayiterator.pmc"

    /**/UNUSED(_self)
    Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_INVALID_OPERATION,
            "ArrayIterator init without aggregate");
#line 334 "./src/pmc/arrayiterator.c"
}
static  void 
Parrot_ArrayIterator_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *array)
{
#line 100 "./src/pmc/arrayiterator.pmc"


    SETATTR_ArrayIterator_array(interp, _self, array);

    PObj_custom_mark_SET(_self);

    /* by default, iterate from start */
    Parrot_ArrayIterator_set_integer_native(interp, _self, ITERATE_FROM_START);
#line 348 "./src/pmc/arrayiterator.c"
}
static  void 
Parrot_ArrayIterator_mark(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 120 "./src/pmc/arrayiterator.pmc"

    PMC *array;

    GETATTR_ArrayIterator_array(interp, _self, array);
    Parrot_gc_mark_PMC_alive(interp, array);
#line 359 "./src/pmc/arrayiterator.c"
}
static  FLOATVAL 
Parrot_ArrayIterator_pop_float(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 391 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;
    PMC   *array;

    GETATTR_ArrayIterator_pos(interp, _self, pos);

    if (!Parrot_ArrayIterator_get_bool(interp, _self))
        out_of_bounds(interp);

    GETATTR_ArrayIterator_array(interp, _self, array);
    SETATTR_ArrayIterator_pos(interp, _self, --pos);

    PARROT_GC_WRITE_BARRIER(interp, _self);
    return VTABLE_get_number_keyed_int(interp, array, pos);
#line 379 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_pop_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 366 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;
    PMC   *array;

    GETATTR_ArrayIterator_pos(interp, _self, pos);


    if (!Parrot_ArrayIterator_get_bool(interp, _self))
        out_of_bounds(interp);

    GETATTR_ArrayIterator_array(interp, _self, array);
    SETATTR_ArrayIterator_pos(interp, _self, --pos);

    PARROT_GC_WRITE_BARRIER(interp, _self);
    return VTABLE_get_integer_keyed_int(interp, array, pos);
#line 400 "./src/pmc/arrayiterator.c"
}
static  PMC  *
Parrot_ArrayIterator_pop_pmc(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 443 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;
    PMC   *array;

    GETATTR_ArrayIterator_pos(interp, _self, pos);

    if (!Parrot_ArrayIterator_get_bool(interp, _self))
        out_of_bounds(interp);

    GETATTR_ArrayIterator_array(interp, _self, array);
    SETATTR_ArrayIterator_pos(interp, _self, --pos);

    PARROT_GC_WRITE_BARRIER(interp, _self);
    return VTABLE_get_pmc_keyed_int(interp, array, pos);
#line 420 "./src/pmc/arrayiterator.c"
}
static  STRING  *
Parrot_ArrayIterator_pop_string(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 416 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;
    PMC   *array;

    GETATTR_ArrayIterator_pos(interp, _self, pos);

    if (!Parrot_ArrayIterator_get_bool(interp, _self))
        out_of_bounds(interp);

    GETATTR_ArrayIterator_array(interp, _self, array);
    SETATTR_ArrayIterator_pos(interp, _self, --pos);

    PARROT_GC_WRITE_BARRIER(interp, _self);
    return VTABLE_get_string_keyed_int(interp, array, pos);
#line 440 "./src/pmc/arrayiterator.c"
}
static  void 
Parrot_ArrayIterator_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 211 "./src/pmc/arrayiterator.pmc"

    PMC *array;
    INTVAL element;
    GETATTR_ArrayIterator_array(interp, _self, array);
    element = VTABLE_elements(interp, array);

    switch (value) {
      case ITERATE_FROM_START:
        SETATTR_ArrayIterator_reverse(interp, _self, 0);
        SETATTR_ArrayIterator_pos(interp, _self, 0);
        SETATTR_ArrayIterator_length(interp, _self, element);
        break;
      case ITERATE_FROM_END:
        SETATTR_ArrayIterator_reverse(interp, _self, 1);
        SETATTR_ArrayIterator_length(interp, _self, element);
        SETATTR_ArrayIterator_pos(interp, _self, element);
        break;
      default:
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_INVALID_OPERATION,
                "Wrong direction for ArrayIterator");
    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 468 "./src/pmc/arrayiterator.c"
}
static  FLOATVAL 
Parrot_ArrayIterator_shift_float(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 286 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;
    PMC   *array;

    GETATTR_ArrayIterator_pos(interp, _self, pos);

    if (!Parrot_ArrayIterator_get_bool(interp, _self))
        out_of_bounds(interp);

    GETATTR_ArrayIterator_array(interp, _self, array);
    SETATTR_ArrayIterator_pos(interp, _self, pos+1);

    PARROT_GC_WRITE_BARRIER(interp, _self);
    return VTABLE_get_number_keyed_int(interp, array, pos);
#line 488 "./src/pmc/arrayiterator.c"
}
static  INTVAL 
Parrot_ArrayIterator_shift_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 261 "./src/pmc/arrayiterator.pmc"

    INTVAL pos, length;
    PMC   *array;

    GETATTR_ArrayIterator_pos(interp, _self, pos);
    GETATTR_ArrayIterator_length(interp, _self, length);

    if (pos >= length)
        out_of_bounds(interp);

    GETATTR_ArrayIterator_array(interp, _self, array);
    SETATTR_ArrayIterator_pos(interp, _self, pos+1);

    PARROT_GC_WRITE_BARRIER(interp, _self);
    return VTABLE_get_integer_keyed_int(interp, array, pos);
#line 509 "./src/pmc/arrayiterator.c"
}
static  PMC  *
Parrot_ArrayIterator_shift_pmc(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 338 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;
    PMC   *array;

    GETATTR_ArrayIterator_pos(interp, _self, pos);

    if (!Parrot_ArrayIterator_get_bool(interp, _self))
        out_of_bounds(interp);

    GETATTR_ArrayIterator_array(interp, _self, array);
    SETATTR_ArrayIterator_pos(interp, _self, pos+1);

    PARROT_GC_WRITE_BARRIER(interp, _self);
    return VTABLE_get_pmc_keyed_int(interp, array, pos);
#line 529 "./src/pmc/arrayiterator.c"
}
static  STRING  *
Parrot_ArrayIterator_shift_string(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 311 "./src/pmc/arrayiterator.pmc"

    INTVAL pos;
    PMC   *array;

    GETATTR_ArrayIterator_pos(interp, _self, pos);

    if (!Parrot_ArrayIterator_get_bool(interp, _self))
        out_of_bounds(interp);

    GETATTR_ArrayIterator_array(interp, _self, array);
    SETATTR_ArrayIterator_pos(interp, _self, pos+1);

    PARROT_GC_WRITE_BARRIER(interp, _self);
    return VTABLE_get_string_keyed_int(interp, array, pos);
#line 549 "./src/pmc/arrayiterator.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_ArrayIterator_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_ArrayIterator_clone;
    vt->defined_keyed = Parrot_ArrayIterator_defined_keyed;
    vt->defined_keyed_int = Parrot_ArrayIterator_defined_keyed_int;
    vt->elements = Parrot_ArrayIterator_elements;
    vt->exists_keyed = Parrot_ArrayIterator_exists_keyed;
    vt->exists_keyed_int = Parrot_ArrayIterator_exists_keyed_int;
    vt->get_bool = Parrot_ArrayIterator_get_bool;
    vt->get_integer = Parrot_ArrayIterator_get_integer;
    vt->get_integer_keyed = Parrot_ArrayIterator_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_ArrayIterator_get_integer_keyed_int;
    vt->get_number_keyed = Parrot_ArrayIterator_get_number_keyed;
    vt->get_number_keyed_int = Parrot_ArrayIterator_get_number_keyed_int;
    vt->get_pmc = Parrot_ArrayIterator_get_pmc;
    vt->get_pmc_keyed = Parrot_ArrayIterator_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_ArrayIterator_get_pmc_keyed_int;
    vt->get_string_keyed = Parrot_ArrayIterator_get_string_keyed;
    vt->get_string_keyed_int = Parrot_ArrayIterator_get_string_keyed_int;
    vt->init = Parrot_ArrayIterator_init;
    vt->init_pmc = Parrot_ArrayIterator_init_pmc;
    vt->mark = Parrot_ArrayIterator_mark;
    vt->pop_float = Parrot_ArrayIterator_pop_float;
    vt->pop_integer = Parrot_ArrayIterator_pop_integer;
    vt->pop_pmc = Parrot_ArrayIterator_pop_pmc;
    vt->pop_string = Parrot_ArrayIterator_pop_string;
    vt->set_integer_native = Parrot_ArrayIterator_set_integer_native;
    vt->shift_float = Parrot_ArrayIterator_shift_float;
    vt->shift_integer = Parrot_ArrayIterator_shift_integer;
    vt->shift_pmc = Parrot_ArrayIterator_shift_pmc;
    vt->shift_string = Parrot_ArrayIterator_shift_string;
    vt->attr_size = sizeof(Parrot_ArrayIterator_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_ArrayIterator_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_ArrayIterator_clone;
    vt->defined_keyed = Parrot_ArrayIterator_defined_keyed;
    vt->defined_keyed_int = Parrot_ArrayIterator_defined_keyed_int;
    vt->elements = Parrot_ArrayIterator_elements;
    vt->exists_keyed = Parrot_ArrayIterator_exists_keyed;
    vt->exists_keyed_int = Parrot_ArrayIterator_exists_keyed_int;
    vt->get_bool = Parrot_ArrayIterator_get_bool;
    vt->get_integer = Parrot_ArrayIterator_get_integer;
    vt->get_integer_keyed = Parrot_ArrayIterator_get_integer_keyed;
    vt->get_integer_keyed_int = Parrot_ArrayIterator_get_integer_keyed_int;
    vt->get_number_keyed = Parrot_ArrayIterator_get_number_keyed;
    vt->get_number_keyed_int = Parrot_ArrayIterator_get_number_keyed_int;
    vt->get_pmc = Parrot_ArrayIterator_get_pmc;
    vt->get_pmc_keyed = Parrot_ArrayIterator_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_ArrayIterator_get_pmc_keyed_int;
    vt->get_string_keyed = Parrot_ArrayIterator_get_string_keyed;
    vt->get_string_keyed_int = Parrot_ArrayIterator_get_string_keyed_int;
    vt->mark = Parrot_ArrayIterator_mark;
    vt->attr_size = sizeof(Parrot_ArrayIterator_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ArrayIterator_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Iterator_get_vtable(interp);
    Parrot_ArrayIterator_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ArrayIterator_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Iterator_ro_get_vtable(interp);
    Parrot_ArrayIterator_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_ArrayIterator_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Iterator_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "ArrayIterator"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_ArrayIterator_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    isa = Parrot_Iterator_get_isa(interp, isa);
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "ArrayIterator")), PMCNULL);
    return isa;
}

void
Parrot_ArrayIterator_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Farray Ipos Ilength Ireverse ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_ArrayIterator_get_vtable(interp);
        vt->base_type      = enum_class_ArrayIterator;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "ArrayIterator");
        vt->provides_str = CONST_STRING_GEN(interp, "iterator");
        vt->isa_hash     = Parrot_ArrayIterator_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_ArrayIterator_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_ArrayIterator;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_ArrayIterator_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_ArrayIterator_class_init */

#line 658 "./src/pmc/arrayiterator.pmc"



/*

=back

=head1 Auxiliar functions

=over 4

=item C<static void out_of_bounds(PARROT_INTERP)>

Throw out-of-bounds exception.

=cut

*/

PARROT_DOES_NOT_RETURN
static void
out_of_bounds(PARROT_INTERP)
{
    ASSERT_ARGS(out_of_bounds)
    Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
            "StopIteration");
}

/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
