/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/bigint.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_bigint.h"
#include "pmc_default.h"
#include "bigint.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/bigint.pmc"
/*
Copyright (C) 2004-2014, Parrot Foundation.

=head1 NAME

src/pmc/bigint.pmc - BigInt PMC

=head1 DESCRIPTION

C<BigInt> provides arbitrary precision integer mathematic functions.

=head2 Functions

=over 4

=item C<static void bigint_set_long(PARROT_INTERP, PMC *self, long value)>

Set the value of the BigInt to C<value>.

=item C<static void bigint_set_double(PARROT_INTERP, PMC *self, double value)>

Set the value of the BigInt to C<value>.

=cut

*/

/* TODO split that out into a separate file */

#ifdef S_SPLINT_S
#  undef PARROT_HAS_GMP /* splint barfs on the gmp.h header */
#endif /* S_SPLINT_S */

#define NO_MULTIPLE_DISPATCH(name)                \
    Parrot_ex_throw_from_c_args(interp, NULL,     \
            EXCEPTION_INTERNAL_NOT_IMPLEMENTED,   \
            "BigInt: no multiple dispatch variant '%s' for %Ss", \
            (name), VTABLE_name(interp, value))
#define NO_MULTIPLE_DISPATCH_FLOAT(name)          \
    Parrot_ex_throw_from_c_args(interp, NULL,     \
            EXCEPTION_INTERNAL_NOT_IMPLEMENTED,   \
            "BigInt: no multiple dispatch variant '%s' for FLOATVAL", \
            (name))

#ifdef PARROT_HAS_GMP
#  include <gmp.h>
typedef struct BIGINT {
    mpz_t b;
} BIGINT;

/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

static void bigint_abs(PARROT_INTERP, ARGIN(PMC *self), ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        FUNC_MODIFIES(*dest);

static void bigint_add_bigint(PARROT_INTERP,
    ARGIN(PMC *self),
    ARGIN(PMC *value),
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bigint_add_bigint_int(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bigint_check_divide_zero(PARROT_INTERP, ARGIN(PMC *value))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void bigint_clear(PARROT_INTERP, ARGIN(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

PARROT_WARN_UNUSED_RESULT
static INTVAL bigint_cmp(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *value))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3);

PARROT_WARN_UNUSED_RESULT
static INTVAL bigint_cmp_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void bigint_div_bigint(PARROT_INTERP,
    ARGIN(PMC *self),
    ARGIN(PMC *value),
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bigint_div_bigint_int(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bigint_fdiv_bigint(PARROT_INTERP,
    ARGIN(PMC *self),
    ARGMOD(PMC *value),
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*value)
        FUNC_MODIFIES(*dest);

static void bigint_fdiv_bigint_int(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

PARROT_WARN_UNUSED_RESULT
static int bigint_get_bool(PARROT_INTERP, ARGIN(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

PARROT_WARN_UNUSED_RESULT
static double bigint_get_double(PARROT_INTERP, ARGIN(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

PARROT_WARN_UNUSED_RESULT
static long bigint_get_long(PARROT_INTERP, ARGIN(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
static BIGINT* bigint_get_self(PARROT_INTERP, ARGIN(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

PARROT_WARN_UNUSED_RESULT
PARROT_CANNOT_RETURN_NULL
static char * bigint_get_string(PARROT_INTERP, ARGIN(PMC *self), int base)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void bigint_init(PARROT_INTERP, ARGIN(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void bigint_mod_bigint(PARROT_INTERP,
    ARGIN(PMC *self),
    ARGMOD(PMC *value),
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*value)
        FUNC_MODIFIES(*dest);

static void bigint_mod_bigint_int(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bigint_mul_bigint(PARROT_INTERP,
    ARGIN(PMC *self),
    ARGIN(PMC *value),
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bigint_mul_bigint_int(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bigint_neg(PARROT_INTERP, ARGIN(PMC *self), ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        FUNC_MODIFIES(*dest);

static void bigint_pow_bigint_int(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bigint_set(PARROT_INTERP, ARGMOD(PMC *dest), ARGIN(PMC *src))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        FUNC_MODIFIES(*dest);

static void bigint_set_double(PARROT_INTERP,
    ARGMOD(PMC *self),
    double value)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        FUNC_MODIFIES(*self);

static void bigint_set_long(PARROT_INTERP, ARGMOD(PMC *self), long value)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        FUNC_MODIFIES(*self);

static void bigint_set_self(PARROT_INTERP,
    ARGMOD(PMC *self),
    ARGIN(BIGINT *value))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        FUNC_MODIFIES(*self);

static void bigint_set_str(PARROT_INTERP,
    ARGMOD(PMC *self),
    ARGIN(const STRING *value),
    int base)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        FUNC_MODIFIES(*self);

static void bigint_sub_bigint(PARROT_INTERP,
    ARGIN(PMC *self),
    ARGIN(PMC *value),
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bigint_sub_bigint_int(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void int_check_divide_zero(PARROT_INTERP, INTVAL value)
        __attribute__nonnull__(1);

#define ASSERT_ARGS_bigint_abs __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bigint_add_bigint __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bigint_add_bigint_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bigint_check_divide_zero __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(value))
#define ASSERT_ARGS_bigint_clear __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bigint_cmp __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value))
#define ASSERT_ARGS_bigint_cmp_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bigint_div_bigint __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bigint_div_bigint_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bigint_fdiv_bigint __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bigint_fdiv_bigint_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bigint_get_bool __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bigint_get_double __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bigint_get_long __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bigint_get_self __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bigint_get_string __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bigint_init __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bigint_mod_bigint __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bigint_mod_bigint_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bigint_mul_bigint __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bigint_mul_bigint_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bigint_neg __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bigint_pow_bigint_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bigint_set __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(dest) \
    , PARROT_ASSERT_ARG(src))
#define ASSERT_ARGS_bigint_set_double __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bigint_set_long __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bigint_set_self __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value))
#define ASSERT_ARGS_bigint_set_str __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value))
#define ASSERT_ARGS_bigint_sub_bigint __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bigint_sub_bigint_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_int_check_divide_zero __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */
/* HEADERIZER HFILE: none */

/*

=item C<static void bigint_init(PARROT_INTERP, PMC *self)>

Initialize a BigInt

=cut

*/

static void
bigint_init(PARROT_INTERP, ARGIN(PMC *self))
{
    ASSERT_ARGS(bigint_init)
    BIGINT * const bi = mem_gc_allocate_zeroed_typed(interp, BIGINT);
    SETATTR_BigInt_bi(interp, self, bi);
    mpz_init(bi->b);
}

/*

=item C<static void bigint_clear(PARROT_INTERP, PMC *self)>

Clear the BigInt memory.

=cut

*/

static void
bigint_clear(PARROT_INTERP, ARGIN(PMC *self))
{
    ASSERT_ARGS(bigint_clear)
    BIGINT * bi;
    GETATTR_BigInt_bi(interp, self, bi);
    mpz_clear(bi->b);
    mem_gc_free(interp, bi);
}

/*

=item C<static void bigint_set(PARROT_INTERP, PMC *dest, PMC *src)>

Set the BigInt value C<dest> to the same value as C<src>.

=cut

*/

static void
bigint_set(PARROT_INTERP, ARGMOD(PMC *dest), ARGIN(PMC *src))
{
    ASSERT_ARGS(bigint_set)
    BIGINT *bi_dest;
    const BIGINT *bi_src;
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    GETATTR_BigInt_bi(interp, src,  bi_src);
    mpz_clear(bi_dest->b);
    mpz_init(bi_dest->b);
    mpz_set(bi_dest->b, bi_src->b);
}

/*

=item C<static void bigint_set_long(PARROT_INTERP, PMC *self, long value)>

Initialize the BigInt value from a C<long>

=cut

*/

static void
bigint_set_long(PARROT_INTERP, ARGMOD(PMC *self), long value)
{
    ASSERT_ARGS(bigint_set_long)
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    mpz_set_si(bi->b, value);
}

/*

=item C<static void bigint_set_double(PARROT_INTERP, PMC *self, double value)>

Initialize the BigInt value from a C<double>

=cut

*/

static void
bigint_set_double(PARROT_INTERP, ARGMOD(PMC *self), double value)
{
    ASSERT_ARGS(bigint_set_double)
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    mpz_set_d(bi->b, value);
}

/*

=item C<static void bigint_set_str(PARROT_INTERP, PMC *self, const STRING
*value, int base)>

Initialize the BigInt value from a C<STRING>

=cut

*/

static void
bigint_set_str(PARROT_INTERP, ARGMOD(PMC *self), ARGIN(const STRING *value), int base)
{
    ASSERT_ARGS(bigint_set_str)
    char * const s = Parrot_str_to_cstring(interp, value);
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    mpz_set_str(bi->b, s, base);
    Parrot_str_free_cstring(s);
}

/*

=item C<static BIGINT* bigint_get_self(PARROT_INTERP, PMC *self)>

Get the C<BIGINT*> pointer from C<self>

=cut

*/

PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
static BIGINT*
bigint_get_self(PARROT_INTERP, ARGIN(PMC *self))
{
    ASSERT_ARGS(bigint_get_self)
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    return bi;
}

/*

=item C<static void bigint_set_self(PARROT_INTERP, PMC *self, BIGINT *value)>

Set the C<BIGINT*> pointer from C<value> PMC

=cut

*/

static void
bigint_set_self(PARROT_INTERP, ARGMOD(PMC *self), ARGIN(BIGINT *value))
{
    ASSERT_ARGS(bigint_set_self)
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    mpz_set(bi->b, (mpz_srcptr)((BIGINT*)value)->b);
}

/*

=item C<static long bigint_get_long(PARROT_INTERP, PMC *self)>

Convert the BigInt value to a C<long>

=cut

*/

PARROT_WARN_UNUSED_RESULT
static long
bigint_get_long(PARROT_INTERP, ARGIN(PMC *self))
{
    ASSERT_ARGS(bigint_get_long)
    const BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    if (mpz_fits_slong_p(bi->b))
        return mpz_get_si(bi->b);
    Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_ERR_OVERFLOW,
            "bigint_get_long: number too big");
}

/*

=item C<static int bigint_get_bool(PARROT_INTERP, PMC *self)>

Get a boolean representation of the BigInt

=cut

*/

PARROT_WARN_UNUSED_RESULT
static int
bigint_get_bool(PARROT_INTERP, ARGIN(PMC *self))
{
    ASSERT_ARGS(bigint_get_bool)
    const BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    if (mpz_sgn(bi->b) != 0)
        return 1;
    else
        return 0;
}

/*

=item C<static char * bigint_get_string(PARROT_INTERP, PMC *self, int base)>

Get a STRING representation of the BigInt.

=cut

*/

PARROT_WARN_UNUSED_RESULT
PARROT_CANNOT_RETURN_NULL
static char *
bigint_get_string(PARROT_INTERP, ARGIN(PMC *self), int base)
{
    ASSERT_ARGS(bigint_get_string)
    const BIGINT *bi;
    size_t  n;
    char   *s;
    GETATTR_BigInt_bi(interp, self, bi);
    n = mpz_sizeinbase(bi->b, base) + 2;
    s = mem_gc_allocate_n_typed(interp, n, char);
    return mpz_get_str(s, base, bi->b);
}

/*

=item C<static double bigint_get_double(PARROT_INTERP, PMC *self)>

Get a C<double> value from the BigInt.

=cut

*/

PARROT_WARN_UNUSED_RESULT
static double
bigint_get_double(PARROT_INTERP, ARGIN(PMC *self))
{
    ASSERT_ARGS(bigint_get_double)
    const BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    return mpz_get_d(bi->b);
}


/*

=item C<static void bigint_add_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC
*dest)>

Add C<self> and C<value> and store the result in C<dest>.

=cut

*/

static void
bigint_add_bigint(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *value), ARGMOD(PMC *dest))
{
    ASSERT_ARGS(bigint_add_bigint)
    const BIGINT *bi_self;
    const BIGINT *bi_value;
    BIGINT *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_add(bi_dest->b, bi_self->b, bi_value->b);
}

/*

=item C<static void bigint_add_bigint_int(PARROT_INTERP, PMC *self, INTVAL
value, PMC *dest)>

Add an INTVAL to the BigInt.

=cut

*/

static void
bigint_add_bigint_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest))
{
    ASSERT_ARGS(bigint_add_bigint_int)
    const BIGINT *bi_self;
    BIGINT *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    if (value < 0)
        mpz_sub_ui(bi_dest->b, bi_self->b, (unsigned long int)-value);
    else
        mpz_add_ui(bi_dest->b, bi_self->b, (unsigned long int)value);
}

/*

=item C<static void bigint_sub_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC
*dest)>

Subtract C<value> from C<self> and store the result in C<dest>.

=cut

*/

static void
bigint_sub_bigint(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *value), ARGMOD(PMC *dest))
{
    ASSERT_ARGS(bigint_sub_bigint)
    const BIGINT *bi_self;
    const BIGINT *bi_value;
    BIGINT *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_sub(bi_dest->b, bi_self->b, bi_value->b);
}

/*

=item C<static void bigint_sub_bigint_int(PARROT_INTERP, PMC *self, INTVAL
value, PMC *dest)>

Subtract C<value> from C<self> and store the result in C<dest>.

=cut

*/

static void
bigint_sub_bigint_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest))
{
    ASSERT_ARGS(bigint_sub_bigint_int)
    const BIGINT *bi_self;
    BIGINT *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    if (value < 0)
        mpz_add_ui(bi_dest->b, bi_self->b, (unsigned long int)-value);
    else
        mpz_sub_ui(bi_dest->b, bi_self->b, (unsigned long int)value);
}

/*

=item C<static void bigint_mul_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC
*dest)>

Multiply C<self> by C<value> and store the result in C<dest>.

=cut

*/

static void
bigint_mul_bigint(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *value), ARGMOD(PMC *dest))
{
    ASSERT_ARGS(bigint_mul_bigint)
    const BIGINT *bi_self;
    const BIGINT *bi_value;
    BIGINT *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_mul(bi_dest->b, bi_self->b, bi_value->b);
}

/*

=item C<static void bigint_mul_bigint_int(PARROT_INTERP, PMC *self, INTVAL
value, PMC *dest)>

Multiply C<self> by C<value> and store the result in C<dest>.

=cut

*/

static void
bigint_mul_bigint_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest))
{
    ASSERT_ARGS(bigint_mul_bigint_int)
    const BIGINT *bi_self;
    BIGINT *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_mul_si(bi_dest->b, bi_self->b, value);
}

/*

=item C<static void bigint_pow_bigint_int(PARROT_INTERP, PMC *self, INTVAL
value, PMC *dest)>

Raise C<self> to the power C<value> and store the result in C<dest>.

=cut

*/

static void
bigint_pow_bigint_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest))
{
    ASSERT_ARGS(bigint_pow_bigint_int)
    const BIGINT *bi_self;
    BIGINT *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_pow_ui(bi_dest->b, bi_self->b, (unsigned long int)value);
}

/*

=item C<static void int_check_divide_zero(PARROT_INTERP, INTVAL value)>

If C<value> is C<0>, throw an exception.

=cut

*/

static void
int_check_divide_zero(PARROT_INTERP, INTVAL value)
{
    if (value == 0)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
}

/*

=item C<static void bigint_check_divide_zero(PARROT_INTERP, PMC *value)>

If C<value> is C<0>, throw an exception.

=cut

*/

static void
bigint_check_divide_zero(PARROT_INTERP, ARGIN(PMC *value))
{
    ASSERT_ARGS(bigint_check_divide_zero)
    /* Throw an exception if we are dividing by zero. */
    const BIGINT *bi;
    GETATTR_BigInt_bi(interp, value, bi);
    if (mpz_cmp_si(bi->b, 0) == 0)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
}

/*

=item C<static void bigint_div_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC
*dest)>

Divide C<self> by C<value> and store the result in C<dest>.

=cut

*/

static void
bigint_div_bigint(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *value), ARGMOD(PMC *dest))
{
    ASSERT_ARGS(bigint_div_bigint)
    const BIGINT *bi_self;
    const BIGINT *bi_value;
    BIGINT *bi_dest;
    bigint_check_divide_zero(interp, value);
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    /* this is mpz_fdiv_q */
    mpz_div(bi_dest->b, bi_self->b, bi_value->b);
}

/*

=item C<static void bigint_div_bigint_int(PARROT_INTERP, PMC *self, INTVAL
value, PMC *dest)>

Divide C<self> by C<value> and store the result in C<dest>.

=cut

*/

static void
bigint_div_bigint_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest))
{
    ASSERT_ARGS(bigint_div_bigint_int)
    const BIGINT *bi_self;
    BIGINT *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    int_check_divide_zero(interp, value);

    /* this is mpz_fdiv_q */
    if (value < 0) {
        mpz_div_ui(bi_dest->b, bi_self->b, (unsigned long int)-value);
        mpz_neg(bi_dest->b, bi_dest->b);
    }
    else {
        mpz_div_ui(bi_dest->b, bi_self->b, (unsigned long int)value);
    }
}

/*

=item C<static void bigint_fdiv_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC
*dest)>

Floating-point divide C<self> by C<value> and store the result in C<dest>.

=cut

*/

static void
bigint_fdiv_bigint(PARROT_INTERP, ARGIN(PMC *self), ARGMOD(PMC *value), ARGMOD(PMC *dest))
{
    ASSERT_ARGS(bigint_fdiv_bigint)
    const BIGINT *bi_self;
    const BIGINT *bi_value;
    BIGINT *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    bigint_check_divide_zero(interp, value);
    mpz_fdiv_q(bi_dest->b, bi_self->b, bi_value->b);
}

/*

=item C<static void bigint_fdiv_bigint_int(PARROT_INTERP, PMC *self, INTVAL
value, PMC *dest)>

Floating-point divide C<self> by C<value> and store the result in C<dest>.

=cut

*/

static void
bigint_fdiv_bigint_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest))
{
    ASSERT_ARGS(bigint_fdiv_bigint_int)
    const BIGINT *bi_self;
    BIGINT *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    int_check_divide_zero(interp, value);

    if (value < 0) {
        mpz_fdiv_q_ui(bi_dest->b, bi_self->b, (unsigned long int)-value);
        mpz_neg(bi_dest->b, bi_dest->b);
    }
    else {
        mpz_fdiv_q_ui(bi_dest->b, bi_self->b, (unsigned long int)value);
    }
}

/*

=item C<static void bigint_mod_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC
*dest)>

Modulo C<self> by C<value> and store the result in C<dest>.

=cut

*/

static void
bigint_mod_bigint(PARROT_INTERP, ARGIN(PMC *self), ARGMOD(PMC *value), ARGMOD(PMC *dest))
{
    ASSERT_ARGS(bigint_mod_bigint)
    const BIGINT *bi_self;
    const BIGINT *bi_value;
    BIGINT *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    bigint_check_divide_zero(interp, value);
    mpz_mod(bi_dest->b, bi_self->b, bi_value->b);
}

/*

=item C<static void bigint_mod_bigint_int(PARROT_INTERP, PMC *self, INTVAL
value, PMC *dest)>

Modulo C<self> by C<value> and store the result in C<dest>.

=cut

*/

static void
bigint_mod_bigint_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest))
{
    ASSERT_ARGS(bigint_mod_bigint_int)
    const BIGINT *bi_self;
    BIGINT *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    int_check_divide_zero(interp, value);

    if (value < 0) {
        mpz_mod_ui(bi_dest->b, bi_self->b, (unsigned long int)-value);
    }
    else {
        mpz_mod_ui(bi_dest->b, bi_self->b, (unsigned long int)value);
    }
}

/*

=item C<static INTVAL bigint_cmp(PARROT_INTERP, PMC *self, PMC *value)>

Compare C<self> and C<value>, returning 1, 0 or -1 depending on the relation.

=cut

*/

PARROT_WARN_UNUSED_RESULT
static INTVAL
bigint_cmp(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *value))
{
    ASSERT_ARGS(bigint_cmp)
    const BIGINT *bi_self;
    const BIGINT *bi_value;
    GETATTR_BigInt_bi(interp, self,  bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    return mpz_cmp(bi_self->b, bi_value->b);
}

/*

=item C<static INTVAL bigint_cmp_int(PARROT_INTERP, PMC *self, INTVAL value)>

Compare C<self> and C<value>, returning 1, 0 or -1 depending on the relation.

=cut

*/

PARROT_WARN_UNUSED_RESULT
static INTVAL
bigint_cmp_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value)
{
    ASSERT_ARGS(bigint_cmp_int)
    const BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    return mpz_cmp_si(bi->b, value);
}

/*

=item C<static void bigint_abs(PARROT_INTERP, PMC *self, PMC *dest)>

Take the absolute value of C<self>. Store the result in C<dest>.

=cut

*/

static void
bigint_abs(PARROT_INTERP, ARGIN(PMC *self), ARGMOD(PMC *dest))
{
    ASSERT_ARGS(bigint_abs)
    const BIGINT *bi_self;
    BIGINT *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_abs(bi_dest->b, bi_self->b);
}

/*

=item C<static void bigint_neg(PARROT_INTERP, PMC *self, PMC *dest)>

Take the negative value of C<self>. Store the result in C<dest>.

=cut

*/

static void
bigint_neg(PARROT_INTERP, ARGIN(PMC *self), ARGMOD(PMC *dest))
{
    ASSERT_ARGS(bigint_neg)
    const BIGINT *bi_self;
    BIGINT *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_neg(bi_dest->b, bi_self->b);
}

/* HEADERIZER STOP */

#else /* ifdef PARROT_HAS_GMP */

typedef struct BIGINT {
    INTVAL b; /* bogus definition for users without libgmp*/
} BIGINT;

#  define THROW_NOGMP Parrot_ex_throw_from_c_noargs(interp, \
                        EXCEPTION_LIBRARY_ERROR, "no bigint lib loaded")

static void
bigint_init(PARROT_INTERP, ARGIN(PMC *self)) {
    UNUSED(self)
    THROW_NOGMP;
}

static void
bigint_clear(PARROT_INTERP, ARGIN(PMC *self)) {
    UNUSED(self)
    THROW_NOGMP;
}

static void
bigint_set_long(PARROT_INTERP, ARGIN(PMC *self), long value) {
    UNUSED(self)
    UNUSED(value)
    THROW_NOGMP;
}

static void
bigint_set(PARROT_INTERP, PMC *dest, PMC *src) {
    UNUSED(dest)
    UNUSED(src)
    THROW_NOGMP;
}

static void
bigint_set_double(PARROT_INTERP, ARGIN(PMC *self), double value) {
    UNUSED(self)
    UNUSED(value)
    THROW_NOGMP;
}

static void
bigint_set_str(PARROT_INTERP, ARGIN(PMC *self), ARGIN(const STRING *value), int base) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(base)
    THROW_NOGMP;
}

static void
bigint_set_self(PARROT_INTERP, ARGIN(PMC *self), BIGINT *value) {
    UNUSED(self)
    UNUSED(value)
    THROW_NOGMP;
}

static BIGINT*
bigint_get_self(PARROT_INTERP, ARGIN(PMC *self)) {
    UNUSED(self)
    THROW_NOGMP;
}

static char *
bigint_get_string(PARROT_INTERP, ARGIN(PMC *self), int base) {
    UNUSED(self)
    UNUSED(base)
    THROW_NOGMP;
}

static long
bigint_get_long(PARROT_INTERP, ARGIN(PMC *self)) {
    UNUSED(self)
    THROW_NOGMP;
}

static int
bigint_get_bool(PARROT_INTERP, ARGIN(PMC *self)) {
    UNUSED(self)
    THROW_NOGMP;
}

static double
bigint_get_double(PARROT_INTERP, ARGIN(PMC *self)) {
    UNUSED(self)
    THROW_NOGMP;
}

static void
bigint_add_bigint(PARROT_INTERP, ARGIN(PMC *self), PMC *value, PMC *dest) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bigint_add_bigint_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, PMC *dest) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bigint_sub_bigint(PARROT_INTERP, ARGIN(PMC *self), PMC *value, PMC *dest) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bigint_sub_bigint_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, PMC *dest) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bigint_mul_bigint(PARROT_INTERP, ARGIN(PMC *self), PMC *value, PMC *dest) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bigint_mul_bigint_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, PMC *dest) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bigint_pow_bigint_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, PMC *dest) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bigint_div_bigint(PARROT_INTERP, ARGIN(PMC *self), PMC *value, PMC *dest) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bigint_div_bigint_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, PMC *dest) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bigint_fdiv_bigint(PARROT_INTERP, ARGIN(PMC *self), PMC *value, PMC *dest) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bigint_fdiv_bigint_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, PMC *dest) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bigint_mod_bigint(PARROT_INTERP, ARGIN(PMC *self), PMC *value, PMC *dest) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bigint_mod_bigint_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, PMC *dest) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static INTVAL
bigint_cmp(PARROT_INTERP, ARGIN(PMC *self), PMC *value) {
    UNUSED(self)
    UNUSED(value)
    THROW_NOGMP;
}

static INTVAL
bigint_cmp_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value) {
    UNUSED(self)
    UNUSED(value)
    THROW_NOGMP;
}

static void
bigint_abs(PARROT_INTERP, ARGIN(PMC *self), PMC *dest) {
    UNUSED(self)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bigint_neg(PARROT_INTERP, ARGIN(PMC *self), PMC *dest) {
    UNUSED(self)
    UNUSED(dest)
    THROW_NOGMP;
}

#endif /* ifdef PARROT_HAS_GMP */
#line 1356 "./src/pmc/bigint.c"
static  PMC  * Parrot_BigInt_absolute(PARROT_INTERP, ARGMOD(PMC *_self), PMC *dest);
static  PMC * Parrot_BigInt_add(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_add_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest);
static  PMC  * Parrot_BigInt_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL Parrot_BigInt_cmp(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigInt_decrement(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_BigInt_destroy(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC * Parrot_BigInt_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest);
static  PMC * Parrot_BigInt_floor_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_floor_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest);
static  INTVAL  Parrot_BigInt_get_bool(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_BigInt_get_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  FLOATVAL  Parrot_BigInt_get_number(PARROT_INTERP, ARGMOD(PMC *_self));
static  STRING  * Parrot_BigInt_get_repr(PARROT_INTERP, ARGMOD(PMC *_self));
static  STRING  * Parrot_BigInt_get_string(PARROT_INTERP, ARGMOD(PMC *_self));
static  STRING  * Parrot_BigInt_get_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL base);
static  void  Parrot_BigInt_i_absolute(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_i_add(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigInt_i_add_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_BigInt_i_add_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void Parrot_BigInt_i_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigInt_i_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void Parrot_BigInt_i_floor_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigInt_i_floor_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void Parrot_BigInt_i_modulus(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void Parrot_BigInt_i_multiply(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigInt_i_multiply_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_BigInt_i_multiply_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_BigInt_i_neg(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_i_subtract(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigInt_i_subtract_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_BigInt_i_subtract_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_BigInt_increment(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_BigInt_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_BigInt_init_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL iv);
static  INTVAL Parrot_BigInt_is_equal(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  PMC * Parrot_BigInt_modulus(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC * Parrot_BigInt_multiply(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multiply_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest);
static  PMC  * Parrot_BigInt_neg(PARROT_INTERP, ARGMOD(PMC *_self), PMC *dest);
static  void  Parrot_BigInt_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_BigInt_set_number_native(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_BigInt_set_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigInt_set_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL base, STRING *value);
static  void  Parrot_BigInt_set_string_native(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value);
static  PMC * Parrot_BigInt_subtract(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_subtract_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest);
static  void Parrot_BigInt_nci_version(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_BigInt_multi_add_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_add_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_add_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest));
static  void  Parrot_BigInt_multi_i_add_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigInt_multi_i_add_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigInt_multi_i_add_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value);
static  PMC  * Parrot_BigInt_multi_subtract_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_subtract_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_subtract_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest));
static  void  Parrot_BigInt_multi_i_subtract_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigInt_multi_i_subtract_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigInt_multi_i_subtract_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value);
static  PMC  * Parrot_BigInt_multi_multiply_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_multiply_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_multiply_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest));
static  void  Parrot_BigInt_multi_i_multiply_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigInt_multi_i_multiply_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigInt_multi_i_multiply_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value);
static  void Parrot_BigInt_nci_pow(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_BigInt_multi_divide_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_divide_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_divide_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest));
static  void  Parrot_BigInt_multi_i_divide_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigInt_multi_i_divide_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigInt_multi_i_divide_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value);
static  PMC  * Parrot_BigInt_multi_floor_divide_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_floor_divide_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest));
static  void  Parrot_BigInt_multi_i_floor_divide_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigInt_multi_i_floor_divide_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigInt_multi_i_floor_divide_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value);
static  PMC  * Parrot_BigInt_multi_modulus_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_modulus_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigInt_multi_modulus_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest));
static  void  Parrot_BigInt_multi_i_modulus_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigInt_multi_i_modulus_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigInt_multi_i_modulus_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value);
static  INTVAL  Parrot_BigInt_multi_cmp_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_BigInt_multi_cmp_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_BigInt_multi_cmp_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value);
static  INTVAL  Parrot_BigInt_multi_is_equal_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_BigInt_multi_is_equal_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_BigInt_multi_is_equal_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value);
static  void Parrot_BigInt_multi_add_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_add_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_add_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_i_add_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_i_add_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_i_add_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_subtract_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_subtract_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_subtract_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_i_subtract_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_i_subtract_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_i_subtract_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_multiply_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_multiply_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_multiply_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_i_multiply_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_i_multiply_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_i_multiply_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_divide_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_divide_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_divide_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_i_divide_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_i_divide_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_i_divide_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_floor_divide_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_floor_divide_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_floor_divide_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_i_floor_divide_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_i_floor_divide_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_i_floor_divide_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_modulus_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_modulus_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_modulus_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_i_modulus_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_i_modulus_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_i_modulus_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_cmp_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_cmp_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_cmp_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_is_equal_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_is_equal_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigInt_multi_is_equal_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
void    Parrot_BigInt_class_init(PARROT_INTERP, int, int);
void    Parrot_BigInt_ro_class_init(PARROT_INTERP, int, int);
static  PMC  *
Parrot_BigInt_absolute(PARROT_INTERP, ARGMOD(PMC *_self), PMC *dest)
{
#line 1857 "./src/pmc/bigint.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    bigint_abs(interp, _self, dest);
    return dest;
#line 1501 "./src/pmc/bigint.c"
}
static  PMC *
Parrot_BigInt_add(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_BigInt_multi_add_BigInt_PMC(interp, _self, value, dest);
            break;
        case enum_class_Integer:
            return Parrot_BigInt_multi_add_Integer_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "add", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_BigInt_multi_add_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC  *
Parrot_BigInt_add_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest)
{
#line 1577 "./src/pmc/bigint.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    bigint_add_bigint_int(interp, _self, value, dest);
    return dest;
#line 1538 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1374 "./src/pmc/bigint.pmc"

    PMC * const res = Parrot_pmc_new(interp, _self->vtable->base_type);
    bigint_set(interp, res, _self);
    return res;
#line 1548 "./src/pmc/bigint.c"
}
static  INTVAL
Parrot_BigInt_cmp(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_BigInt_multi_cmp_BigInt(interp, _self, value);
            break;
        case enum_class_Integer:
            return Parrot_BigInt_multi_cmp_Integer(interp, _self, value);
            break;
        case enum_class_core_max:
            {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "cmp", "PP->I", _self, value, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_BigInt_multi_cmp_DEFAULT(interp, _self, value);
            break;

    }
}
static  void 
Parrot_BigInt_decrement(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1555 "./src/pmc/bigint.pmc"

    bigint_sub_bigint_int(interp, _self, 1, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 1584 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_destroy(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1380 "./src/pmc/bigint.pmc"

    bigint_clear(interp, _self);
#line 1592 "./src/pmc/bigint.c"
}
static  PMC *
Parrot_BigInt_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_BigInt_multi_divide_BigInt_PMC(interp, _self, value, dest);
            break;
        case enum_class_Integer:
            return Parrot_BigInt_multi_divide_Integer_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "divide", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_BigInt_multi_divide_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC  *
Parrot_BigInt_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest)
{
#line 1728 "./src/pmc/bigint.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    bigint_div_bigint_int(interp, _self, value, dest);
    return dest;
#line 1629 "./src/pmc/bigint.c"
}
static  PMC *
Parrot_BigInt_floor_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_BigInt_multi_floor_divide_BigInt_PMC(interp, _self, value, dest);
            break;
        case enum_class_Integer:
            return Parrot_BigInt_multi_floor_divide_Integer_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "floor_divide", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_BigInt_multi_floor_divide_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC  *
Parrot_BigInt_floor_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest)
{
#line 1767 "./src/pmc/bigint.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    bigint_fdiv_bigint_int(interp, _self, value, dest);
    return dest;
#line 1666 "./src/pmc/bigint.c"
}
static  INTVAL 
Parrot_BigInt_get_bool(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1490 "./src/pmc/bigint.pmc"

    return bigint_get_bool(interp, _self);
#line 1674 "./src/pmc/bigint.c"
}
static  INTVAL 
Parrot_BigInt_get_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1476 "./src/pmc/bigint.pmc"

    return bigint_get_long(interp, _self);
#line 1682 "./src/pmc/bigint.c"
}
static  FLOATVAL 
Parrot_BigInt_get_number(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1462 "./src/pmc/bigint.pmc"

    return bigint_get_double(interp, _self);
#line 1690 "./src/pmc/bigint.c"
}
static  STRING  *
Parrot_BigInt_get_repr(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1527 "./src/pmc/bigint.pmc"

    STRING * const s = VTABLE_get_string(interp, _self);
    return Parrot_str_concat(interp, s, CONST_STRING(interp, "L"));
#line 1699 "./src/pmc/bigint.c"
}
static  STRING  *
Parrot_BigInt_get_string(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1513 "./src/pmc/bigint.pmc"

    char   * const s  = bigint_get_string(interp, _self, 10);
    STRING * const ps = Parrot_str_new(interp, s, 0);
    mem_gc_free(interp, s);
    return ps;
#line 1710 "./src/pmc/bigint.c"
}
static  STRING  *
Parrot_BigInt_get_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL base)
{
#line 1520 "./src/pmc/bigint.pmc"

    char   * const s  = bigint_get_string(interp, _self, base);
    STRING * const ps = Parrot_str_new(interp, s, 0);
    mem_gc_free(interp, s);
    return ps;
#line 1721 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_i_absolute(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1863 "./src/pmc/bigint.pmc"

    bigint_abs(interp, _self, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 1730 "./src/pmc/bigint.c"
}
static  void
Parrot_BigInt_i_add(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_BigInt_multi_i_add_BigInt(interp, _self, value);
            break;
        case enum_class_Integer:
            Parrot_BigInt_multi_i_add_Integer(interp, _self, value);
            break;
        case enum_class_core_max:
            Parrot_mmd_multi_dispatch_from_c_args(interp, "i_add", "PP->", _self, value);
            break;
        default:
            Parrot_BigInt_multi_i_add_DEFAULT(interp, _self, value);
            break;

    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_BigInt_i_add_float(PARROT_INTERP, ARGMOD(PMC *_self), SHIM(FLOATVAL value))
{
#line 1600 "./src/pmc/bigint.pmc"

    /**/UNUSED(_self)
    NO_MULTIPLE_DISPATCH_FLOAT("i_add_float");
#line 1763 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_i_add_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 1596 "./src/pmc/bigint.pmc"

    bigint_add_bigint_int(interp, _self, value, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 1772 "./src/pmc/bigint.c"
}
static  void
Parrot_BigInt_i_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_BigInt_multi_i_divide_BigInt(interp, _self, value);
            break;
        case enum_class_Integer:
            Parrot_BigInt_multi_i_divide_Integer(interp, _self, value);
            break;
        case enum_class_core_max:
            Parrot_mmd_multi_dispatch_from_c_args(interp, "i_divide", "PP->", _self, value);
            break;
        default:
            Parrot_BigInt_multi_i_divide_DEFAULT(interp, _self, value);
            break;

    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_BigInt_i_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 1745 "./src/pmc/bigint.pmc"

    bigint_div_bigint_int(interp, _self, value, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 1805 "./src/pmc/bigint.c"
}
static  void
Parrot_BigInt_i_floor_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_BigInt_multi_i_floor_divide_BigInt(interp, _self, value);
            break;
        case enum_class_Integer:
            Parrot_BigInt_multi_i_floor_divide_Integer(interp, _self, value);
            break;
        case enum_class_core_max:
            Parrot_mmd_multi_dispatch_from_c_args(interp, "i_floor_divide", "PP->", _self, value);
            break;
        default:
            Parrot_BigInt_multi_i_floor_divide_DEFAULT(interp, _self, value);
            break;

    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_BigInt_i_floor_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 1786 "./src/pmc/bigint.pmc"

    bigint_fdiv_bigint_int(interp, _self, value, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 1838 "./src/pmc/bigint.c"
}
static  void
Parrot_BigInt_i_modulus(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_BigInt_multi_i_modulus_BigInt(interp, _self, value);
            break;
        case enum_class_Integer:
            Parrot_BigInt_multi_i_modulus_Integer(interp, _self, value);
            break;
        case enum_class_core_max:
            Parrot_mmd_multi_dispatch_from_c_args(interp, "i_modulus", "PP->", _self, value);
            break;
        default:
            Parrot_BigInt_multi_i_modulus_DEFAULT(interp, _self, value);
            break;

    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void
Parrot_BigInt_i_multiply(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_BigInt_multi_i_multiply_BigInt(interp, _self, value);
            break;
        case enum_class_Integer:
            Parrot_BigInt_multi_i_multiply_Integer(interp, _self, value);
            break;
        case enum_class_core_max:
            Parrot_mmd_multi_dispatch_from_c_args(interp, "i_multiply", "PP->", _self, value);
            break;
        default:
            Parrot_BigInt_multi_i_multiply_DEFAULT(interp, _self, value);
            break;

    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_BigInt_i_multiply_float(PARROT_INTERP, ARGMOD(PMC *_self), SHIM(FLOATVAL value))
{
#line 1696 "./src/pmc/bigint.pmc"

    /**/UNUSED(_self)
    NO_MULTIPLE_DISPATCH_FLOAT("i_multiply_float");
#line 1895 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_i_multiply_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 1692 "./src/pmc/bigint.pmc"

    bigint_mul_bigint_int(interp, _self, value, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 1904 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_i_neg(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1886 "./src/pmc/bigint.pmc"

    bigint_neg(interp, _self, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 1913 "./src/pmc/bigint.c"
}
static  void
Parrot_BigInt_i_subtract(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            Parrot_BigInt_multi_i_subtract_BigInt(interp, _self, value);
            break;
        case enum_class_Integer:
            Parrot_BigInt_multi_i_subtract_Integer(interp, _self, value);
            break;
        case enum_class_core_max:
            Parrot_mmd_multi_dispatch_from_c_args(interp, "i_subtract", "PP->", _self, value);
            break;
        default:
            Parrot_BigInt_multi_i_subtract_DEFAULT(interp, _self, value);
            break;

    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_BigInt_i_subtract_float(PARROT_INTERP, ARGMOD(PMC *_self), SHIM(FLOATVAL value))
{
#line 1647 "./src/pmc/bigint.pmc"

    /**/UNUSED(_self)
    NO_MULTIPLE_DISPATCH_FLOAT("i_subtract_float");
#line 1946 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_i_subtract_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 1643 "./src/pmc/bigint.pmc"

    bigint_sub_bigint_int(interp, _self, value, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 1955 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_increment(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1541 "./src/pmc/bigint.pmc"

    bigint_add_bigint_int(interp, _self, 1, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 1964 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1363 "./src/pmc/bigint.pmc"

    bigint_init(interp, _self);
    PObj_custom_destroy_SET(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 1974 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_init_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL iv)
{
#line 1368 "./src/pmc/bigint.pmc"

    bigint_init(interp, _self);
    bigint_set_long(interp, _self, (long)iv);
    PObj_custom_destroy_SET(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 1985 "./src/pmc/bigint.c"
}
static  INTVAL
Parrot_BigInt_is_equal(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_BigInt_multi_is_equal_BigInt(interp, _self, value);
            break;
        case enum_class_Integer:
            return Parrot_BigInt_multi_is_equal_Integer(interp, _self, value);
            break;
        case enum_class_core_max:
            {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "is_equal", "PP->I", _self, value, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_BigInt_multi_is_equal_DEFAULT(interp, _self, value);
            break;

    }
}
static  PMC *
Parrot_BigInt_modulus(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_BigInt_multi_modulus_BigInt_PMC(interp, _self, value, dest);
            break;
        case enum_class_Integer:
            return Parrot_BigInt_multi_modulus_Integer_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "modulus", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_BigInt_multi_modulus_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC *
Parrot_BigInt_multiply(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_BigInt_multi_multiply_BigInt_PMC(interp, _self, value, dest);
            break;
        case enum_class_Integer:
            return Parrot_BigInt_multi_multiply_Integer_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "multiply", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_BigInt_multi_multiply_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC  *
Parrot_BigInt_multiply_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest)
{
#line 1672 "./src/pmc/bigint.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    bigint_mul_bigint_int(interp, _self, value, dest);
    return dest;
#line 2076 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_neg(PARROT_INTERP, ARGMOD(PMC *_self), PMC *dest)
{
#line 1880 "./src/pmc/bigint.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    bigint_neg(interp, _self, dest);
    return dest;
#line 2086 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 1392 "./src/pmc/bigint.pmc"

    bigint_set_long(interp, _self, (long)value);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 2095 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_set_number_native(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 1406 "./src/pmc/bigint.pmc"

    bigint_set_double(interp, _self, (double)value);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 2104 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_set_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1442 "./src/pmc/bigint.pmc"

    if (value->vtable->base_type == enum_class_BigInt) {
        bigint_set_self(interp, _self, bigint_get_self(interp, value));
    }
    else {
        const INTVAL i = VTABLE_get_integer(interp, value);
        bigint_set_long(interp, _self, (long)i);
    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 2119 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_set_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL base, STRING *value)
{
#line 1429 "./src/pmc/bigint.pmc"

    bigint_set_str(interp, _self, value, base);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 2128 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_set_string_native(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value)
{
#line 1425 "./src/pmc/bigint.pmc"

    bigint_set_str(interp, _self, value, 10);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 2137 "./src/pmc/bigint.c"
}
static  PMC *
Parrot_BigInt_subtract(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigInt:
            return Parrot_BigInt_multi_subtract_BigInt_PMC(interp, _self, value, dest);
            break;
        case enum_class_Integer:
            return Parrot_BigInt_multi_subtract_Integer_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "subtract", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_BigInt_multi_subtract_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC  *
Parrot_BigInt_subtract_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest)
{
#line 1624 "./src/pmc/bigint.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    bigint_sub_bigint_int(interp, _self, value, dest);
    return dest;
#line 2174 "./src/pmc/bigint.c"
}
static  void
Parrot_BigInt_nci_version(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 1353 "./src/pmc/bigint.pmc"

    STRING *version;
#ifdef PARROT_HAS_GMP
    version = Parrot_str_new(interp, gmp_version, 0);
#else
    version = CONST_STRING(interp, "0.0.0");
#endif
    #line 2202 "./src/pmc/bigint.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)version);
        
        return;
     }
#line 1360 "./src/pmc/bigint.pmc"

#line 2210 "./src/pmc/bigint.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  PMC  *
Parrot_BigInt_multi_add_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1559 "./src/pmc/bigint.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    bigint_add_bigint(interp, _self, value, dest);
    return dest;
#line 2227 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_add_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1565 "./src/pmc/bigint.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    bigint_add_bigint_int(interp, _self, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 2237 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_add_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest))
{
#line 1571 "./src/pmc/bigint.pmc"
    NO_MULTIPLE_DISPATCH("add");
#line 2244 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_add_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1583 "./src/pmc/bigint.pmc"

    bigint_add_bigint(interp, _self, value, _self);
#line 2252 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_add_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1587 "./src/pmc/bigint.pmc"

    bigint_add_bigint_int(interp, _self, VTABLE_get_integer(interp, value), _self);
#line 2260 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_add_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value)
{
#line 1591 "./src/pmc/bigint.pmc"
    NO_MULTIPLE_DISPATCH("i_add");
#line 2267 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_subtract_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1606 "./src/pmc/bigint.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    bigint_sub_bigint(interp, _self, value, dest);
    return dest;
#line 2277 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_subtract_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1612 "./src/pmc/bigint.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    bigint_sub_bigint_int(interp, _self, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 2287 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_subtract_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest))
{
#line 1618 "./src/pmc/bigint.pmc"
    NO_MULTIPLE_DISPATCH("subtract");
#line 2294 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_subtract_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1630 "./src/pmc/bigint.pmc"

    bigint_sub_bigint(interp, _self, value, _self);
#line 2302 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_subtract_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1634 "./src/pmc/bigint.pmc"

    bigint_sub_bigint_int(interp, _self, VTABLE_get_integer(interp, value), _self);
#line 2310 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_subtract_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value)
{
#line 1638 "./src/pmc/bigint.pmc"
    NO_MULTIPLE_DISPATCH("i_subtract");
#line 2317 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_multiply_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1654 "./src/pmc/bigint.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    bigint_mul_bigint(interp, _self, value, dest);
    return dest;
#line 2327 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_multiply_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1660 "./src/pmc/bigint.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    bigint_mul_bigint_int(interp, _self, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 2337 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_multiply_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest))
{
#line 1666 "./src/pmc/bigint.pmc"
    NO_MULTIPLE_DISPATCH("multiply");
#line 2344 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_multiply_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1678 "./src/pmc/bigint.pmc"

    bigint_mul_bigint(interp, _self, value, _self);
#line 2352 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_multiply_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1681 "./src/pmc/bigint.pmc"

    bigint_mul_bigint_int(interp, _self, VTABLE_get_integer(interp, value), _self);
#line 2360 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_multiply_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value)
{
#line 1684 "./src/pmc/bigint.pmc"
    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant '%s' for %Ss",
        "i_multiply", VTABLE_name(interp, value));
#line 2370 "./src/pmc/bigint.c"
}
static  void
Parrot_BigInt_nci_pow(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    PMC* value;
    
    const INTVAL arity = 2; /* "PiP" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    value = VTABLE_get_pmc_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 1702 "./src/pmc/bigint.pmc"

    /* XXX only Integer RHS currently */
    const INTVAL r = VTABLE_get_integer(interp, value);
    PMC * const dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    bigint_pow_bigint_int(interp, _self, r, dest);
    #line 2398 "./src/pmc/bigint.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)dest);
        
        return;
     }
#line 1707 "./src/pmc/bigint.pmc"

#line 2406 "./src/pmc/bigint.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  PMC  *
Parrot_BigInt_multi_divide_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1710 "./src/pmc/bigint.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    bigint_div_bigint(interp, _self, value, dest);
    return dest;
#line 2423 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_divide_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1716 "./src/pmc/bigint.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    bigint_div_bigint_int(interp, _self, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 2433 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_divide_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest))
{
#line 1722 "./src/pmc/bigint.pmc"
    NO_MULTIPLE_DISPATCH("divide");
#line 2440 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_divide_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1734 "./src/pmc/bigint.pmc"

    bigint_div_bigint(interp, _self, value, _self);
#line 2448 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_divide_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1737 "./src/pmc/bigint.pmc"

    bigint_div_bigint_int(interp, _self, VTABLE_get_integer(interp, value), _self);
#line 2456 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_divide_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value)
{
#line 1740 "./src/pmc/bigint.pmc"
    NO_MULTIPLE_DISPATCH("i_divide");
#line 2463 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_floor_divide_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1749 "./src/pmc/bigint.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    bigint_fdiv_bigint(interp, _self, value, dest);
    return dest;
#line 2473 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_floor_divide_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1755 "./src/pmc/bigint.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    bigint_fdiv_bigint_int(interp, _self, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 2483 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest))
{
#line 1761 "./src/pmc/bigint.pmc"
    NO_MULTIPLE_DISPATCH("floor_divide");
#line 2490 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_floor_divide_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1773 "./src/pmc/bigint.pmc"

    bigint_fdiv_bigint(interp, _self, value, _self);
#line 2498 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_floor_divide_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1777 "./src/pmc/bigint.pmc"

    bigint_fdiv_bigint_int(interp, _self, VTABLE_get_integer(interp, value), _self);
#line 2506 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_floor_divide_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value)
{
#line 1781 "./src/pmc/bigint.pmc"
    NO_MULTIPLE_DISPATCH("i_floor_divide");
#line 2513 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_modulus_BigInt_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1790 "./src/pmc/bigint.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    bigint_mod_bigint(interp, _self, value, dest);
    return dest;
#line 2523 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_modulus_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1796 "./src/pmc/bigint.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    bigint_mod_bigint_int(interp, _self, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 2533 "./src/pmc/bigint.c"
}
static  PMC  *
Parrot_BigInt_multi_modulus_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest))
{
#line 1802 "./src/pmc/bigint.pmc"
    NO_MULTIPLE_DISPATCH("modulus");
#line 2540 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_modulus_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1808 "./src/pmc/bigint.pmc"

    bigint_mod_bigint(interp, _self, value, _self);
#line 2548 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_modulus_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1811 "./src/pmc/bigint.pmc"

    bigint_mod_bigint_int(interp, _self, VTABLE_get_integer(interp, value), _self);
#line 2556 "./src/pmc/bigint.c"
}
static  void 
Parrot_BigInt_multi_i_modulus_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value)
{
#line 1814 "./src/pmc/bigint.pmc"
    NO_MULTIPLE_DISPATCH("i_modulus");
#line 2563 "./src/pmc/bigint.c"
}
static  INTVAL 
Parrot_BigInt_multi_cmp_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1819 "./src/pmc/bigint.pmc"

    return bigint_cmp(interp, _self, value);
#line 2571 "./src/pmc/bigint.c"
}
static  INTVAL 
Parrot_BigInt_multi_cmp_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1823 "./src/pmc/bigint.pmc"

    return bigint_cmp_int(interp, _self, VTABLE_get_integer(interp, value));
#line 2579 "./src/pmc/bigint.c"
}
static  INTVAL 
Parrot_BigInt_multi_cmp_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value)
{
#line 1827 "./src/pmc/bigint.pmc"
    NO_MULTIPLE_DISPATCH("cmp");
#line 2586 "./src/pmc/bigint.c"
}
static  INTVAL 
Parrot_BigInt_multi_is_equal_BigInt(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1832 "./src/pmc/bigint.pmc"

    return bigint_cmp(interp, _self, value) == 0;
#line 2594 "./src/pmc/bigint.c"
}
static  INTVAL 
Parrot_BigInt_multi_is_equal_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1836 "./src/pmc/bigint.pmc"

    return bigint_cmp_int(interp, _self, VTABLE_get_integer(interp, value)) == 0;
#line 2602 "./src/pmc/bigint.c"
}
static  INTVAL 
Parrot_BigInt_multi_is_equal_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value)
{
#line 1840 "./src/pmc/bigint.pmc"
    NO_MULTIPLE_DISPATCH("is_equal");
#line 2609 "./src/pmc/bigint.c"
}
static  void
Parrot_BigInt_multi_add_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigInt_multi_add_BigInt_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigInt_multi_add_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigInt_multi_add_Integer_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigInt_multi_add_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigInt_multi_add_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigInt_multi_i_add_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigInt_multi_i_add_BigInt(interp, _self, value);
}
static  void
Parrot_BigInt_multi_i_add_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigInt_multi_i_add_Integer(interp, _self, value);
}
static  void
Parrot_BigInt_multi_i_add_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigInt_multi_i_add_DEFAULT(interp, _self, value);
}
static  void
Parrot_BigInt_multi_subtract_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigInt_multi_subtract_BigInt_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigInt_multi_subtract_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigInt_multi_subtract_Integer_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigInt_multi_subtract_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigInt_multi_subtract_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigInt_multi_i_subtract_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigInt_multi_i_subtract_BigInt(interp, _self, value);
}
static  void
Parrot_BigInt_multi_i_subtract_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigInt_multi_i_subtract_Integer(interp, _self, value);
}
static  void
Parrot_BigInt_multi_i_subtract_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigInt_multi_i_subtract_DEFAULT(interp, _self, value);
}
static  void
Parrot_BigInt_multi_multiply_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigInt_multi_multiply_BigInt_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigInt_multi_multiply_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigInt_multi_multiply_Integer_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigInt_multi_multiply_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigInt_multi_multiply_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigInt_multi_i_multiply_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigInt_multi_i_multiply_BigInt(interp, _self, value);
}
static  void
Parrot_BigInt_multi_i_multiply_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigInt_multi_i_multiply_Integer(interp, _self, value);
}
static  void
Parrot_BigInt_multi_i_multiply_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigInt_multi_i_multiply_DEFAULT(interp, _self, value);
}
static  void
Parrot_BigInt_multi_divide_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigInt_multi_divide_BigInt_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigInt_multi_divide_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigInt_multi_divide_Integer_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigInt_multi_divide_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigInt_multi_divide_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigInt_multi_i_divide_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigInt_multi_i_divide_BigInt(interp, _self, value);
}
static  void
Parrot_BigInt_multi_i_divide_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigInt_multi_i_divide_Integer(interp, _self, value);
}
static  void
Parrot_BigInt_multi_i_divide_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigInt_multi_i_divide_DEFAULT(interp, _self, value);
}
static  void
Parrot_BigInt_multi_floor_divide_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigInt_multi_floor_divide_BigInt_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigInt_multi_floor_divide_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigInt_multi_floor_divide_Integer_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigInt_multi_floor_divide_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigInt_multi_floor_divide_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigInt_multi_i_floor_divide_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigInt_multi_i_floor_divide_BigInt(interp, _self, value);
}
static  void
Parrot_BigInt_multi_i_floor_divide_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigInt_multi_i_floor_divide_Integer(interp, _self, value);
}
static  void
Parrot_BigInt_multi_i_floor_divide_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigInt_multi_i_floor_divide_DEFAULT(interp, _self, value);
}
static  void
Parrot_BigInt_multi_modulus_BigInt_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigInt_multi_modulus_BigInt_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigInt_multi_modulus_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigInt_multi_modulus_Integer_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigInt_multi_modulus_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigInt_multi_modulus_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigInt_multi_i_modulus_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigInt_multi_i_modulus_BigInt(interp, _self, value);
}
static  void
Parrot_BigInt_multi_i_modulus_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigInt_multi_i_modulus_Integer(interp, _self, value);
}
static  void
Parrot_BigInt_multi_i_modulus_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigInt_multi_i_modulus_DEFAULT(interp, _self, value);
}
static  void
Parrot_BigInt_multi_cmp_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_BigInt_multi_cmp_BigInt(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
static  void
Parrot_BigInt_multi_cmp_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_BigInt_multi_cmp_Integer(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
static  void
Parrot_BigInt_multi_cmp_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_BigInt_multi_cmp_DEFAULT(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
static  void
Parrot_BigInt_multi_is_equal_BigInt_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_BigInt_multi_is_equal_BigInt(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
static  void
Parrot_BigInt_multi_is_equal_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_BigInt_multi_is_equal_Integer(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
static  void
Parrot_BigInt_multi_is_equal_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_BigInt_multi_is_equal_DEFAULT(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_BigInt_update_vtable(VTABLE *vt) {
    vt->absolute = Parrot_BigInt_absolute;
    vt->add = Parrot_BigInt_add;
    vt->add_int = Parrot_BigInt_add_int;
    vt->clone = Parrot_BigInt_clone;
    vt->cmp = Parrot_BigInt_cmp;
    vt->decrement = Parrot_BigInt_decrement;
    vt->destroy = Parrot_BigInt_destroy;
    vt->divide = Parrot_BigInt_divide;
    vt->divide_int = Parrot_BigInt_divide_int;
    vt->floor_divide = Parrot_BigInt_floor_divide;
    vt->floor_divide_int = Parrot_BigInt_floor_divide_int;
    vt->get_bool = Parrot_BigInt_get_bool;
    vt->get_integer = Parrot_BigInt_get_integer;
    vt->get_number = Parrot_BigInt_get_number;
    vt->get_repr = Parrot_BigInt_get_repr;
    vt->get_string = Parrot_BigInt_get_string;
    vt->get_string_keyed_int = Parrot_BigInt_get_string_keyed_int;
    vt->i_absolute = Parrot_BigInt_i_absolute;
    vt->i_add = Parrot_BigInt_i_add;
    vt->i_add_float = Parrot_BigInt_i_add_float;
    vt->i_add_int = Parrot_BigInt_i_add_int;
    vt->i_divide = Parrot_BigInt_i_divide;
    vt->i_divide_int = Parrot_BigInt_i_divide_int;
    vt->i_floor_divide = Parrot_BigInt_i_floor_divide;
    vt->i_floor_divide_int = Parrot_BigInt_i_floor_divide_int;
    vt->i_modulus = Parrot_BigInt_i_modulus;
    vt->i_multiply = Parrot_BigInt_i_multiply;
    vt->i_multiply_float = Parrot_BigInt_i_multiply_float;
    vt->i_multiply_int = Parrot_BigInt_i_multiply_int;
    vt->i_neg = Parrot_BigInt_i_neg;
    vt->i_subtract = Parrot_BigInt_i_subtract;
    vt->i_subtract_float = Parrot_BigInt_i_subtract_float;
    vt->i_subtract_int = Parrot_BigInt_i_subtract_int;
    vt->increment = Parrot_BigInt_increment;
    vt->init = Parrot_BigInt_init;
    vt->init_int = Parrot_BigInt_init_int;
    vt->is_equal = Parrot_BigInt_is_equal;
    vt->modulus = Parrot_BigInt_modulus;
    vt->multiply = Parrot_BigInt_multiply;
    vt->multiply_int = Parrot_BigInt_multiply_int;
    vt->neg = Parrot_BigInt_neg;
    vt->set_integer_native = Parrot_BigInt_set_integer_native;
    vt->set_number_native = Parrot_BigInt_set_number_native;
    vt->set_pmc = Parrot_BigInt_set_pmc;
    vt->set_string_keyed_int = Parrot_BigInt_set_string_keyed_int;
    vt->set_string_native = Parrot_BigInt_set_string_native;
    vt->subtract = Parrot_BigInt_subtract;
    vt->subtract_int = Parrot_BigInt_subtract_int;
    vt->attr_size = sizeof(Parrot_BigInt_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_BigInt_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->absolute = Parrot_BigInt_absolute;
    vt->add = Parrot_BigInt_add;
    vt->add_int = Parrot_BigInt_add_int;
    vt->clone = Parrot_BigInt_clone;
    vt->cmp = Parrot_BigInt_cmp;
    vt->destroy = Parrot_BigInt_destroy;
    vt->divide = Parrot_BigInt_divide;
    vt->divide_int = Parrot_BigInt_divide_int;
    vt->floor_divide = Parrot_BigInt_floor_divide;
    vt->floor_divide_int = Parrot_BigInt_floor_divide_int;
    vt->get_bool = Parrot_BigInt_get_bool;
    vt->get_integer = Parrot_BigInt_get_integer;
    vt->get_number = Parrot_BigInt_get_number;
    vt->get_repr = Parrot_BigInt_get_repr;
    vt->get_string = Parrot_BigInt_get_string;
    vt->get_string_keyed_int = Parrot_BigInt_get_string_keyed_int;
    vt->is_equal = Parrot_BigInt_is_equal;
    vt->modulus = Parrot_BigInt_modulus;
    vt->multiply = Parrot_BigInt_multiply;
    vt->multiply_int = Parrot_BigInt_multiply_int;
    vt->neg = Parrot_BigInt_neg;
    vt->subtract = Parrot_BigInt_subtract;
    vt->subtract_int = Parrot_BigInt_subtract_int;
    vt->attr_size = sizeof(Parrot_BigInt_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_BigInt_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_BigInt_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_BigInt_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_BigInt_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_BigInt_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "BigInt"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_BigInt_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "BigInt")), PMCNULL);
    return isa;
}

void
Parrot_BigInt_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":bi ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_BigInt_get_vtable(interp);
        vt->base_type      = enum_class_BigInt;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "BigInt");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_BigInt_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_BigInt_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_BigInt;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_BigInt_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "version");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_BigInt_nci_version),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "pow");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_BigInt_nci_pow),
                method_name, signature);
        }
        {
            STRING * const mfl_0 = CONST_STRING_GEN(interp, "add");
            STRING * const mfl_1 = CONST_STRING_GEN(interp, "BigInt,BigInt,PMC");
            STRING * const mfl_2 = CONST_STRING_GEN(interp, "BigInt");
            STRING * const mfl_3 = CONST_STRING_GEN(interp, "BigInt,Integer,PMC");
            STRING * const mfl_4 = CONST_STRING_GEN(interp, "BigInt,DEFAULT,PMC");
            STRING * const mfl_5 = CONST_STRING_GEN(interp, "i_add");
            STRING * const mfl_6 = CONST_STRING_GEN(interp, "BigInt,BigInt");
            STRING * const mfl_7 = CONST_STRING_GEN(interp, "BigInt,Integer");
            STRING * const mfl_8 = CONST_STRING_GEN(interp, "BigInt,DEFAULT");
            STRING * const mfl_9 = CONST_STRING_GEN(interp, "subtract");
            STRING * const mfl_10 = CONST_STRING_GEN(interp, "i_subtract");
            STRING * const mfl_11 = CONST_STRING_GEN(interp, "multiply");
            STRING * const mfl_12 = CONST_STRING_GEN(interp, "i_multiply");
            STRING * const mfl_13 = CONST_STRING_GEN(interp, "divide");
            STRING * const mfl_14 = CONST_STRING_GEN(interp, "i_divide");
            STRING * const mfl_15 = CONST_STRING_GEN(interp, "floor_divide");
            STRING * const mfl_16 = CONST_STRING_GEN(interp, "i_floor_divide");
            STRING * const mfl_17 = CONST_STRING_GEN(interp, "modulus");
            STRING * const mfl_18 = CONST_STRING_GEN(interp, "i_modulus");
            STRING * const mfl_19 = CONST_STRING_GEN(interp, "cmp");
            STRING * const mfl_20 = CONST_STRING_GEN(interp, "is_equal");
        PMC *_temp_func;
_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_add_BigInt_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_add_Integer_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_add_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_i_add_BigInt_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_5, mfl_6, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_i_add_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_5, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_i_add_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_5, mfl_8, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_subtract_BigInt_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_9, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_subtract_Integer_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_9, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_subtract_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_9, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_i_subtract_BigInt_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_10, mfl_6, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_i_subtract_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_10, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_i_subtract_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_10, mfl_8, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_multiply_BigInt_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_11, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_multiply_Integer_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_11, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_multiply_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_11, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_i_multiply_BigInt_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_12, mfl_6, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_i_multiply_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_12, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_i_multiply_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_12, mfl_8, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_divide_BigInt_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_13, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_divide_Integer_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_13, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_divide_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_13, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_i_divide_BigInt_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_14, mfl_6, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_i_divide_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_14, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_i_divide_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_14, mfl_8, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_floor_divide_BigInt_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_15, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_floor_divide_Integer_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_15, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_floor_divide_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_15, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_i_floor_divide_BigInt_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_16, mfl_6, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_i_floor_divide_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_16, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_i_floor_divide_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_16, mfl_8, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_modulus_BigInt_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_17, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_modulus_Integer_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_17, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_modulus_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_17, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_i_modulus_BigInt_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_18, mfl_6, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_i_modulus_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_18, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_i_modulus_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_18, mfl_8, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_cmp_BigInt_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_19, mfl_6, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_cmp_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_19, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_cmp_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_19, mfl_8, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_is_equal_BigInt_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_20, mfl_6, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_is_equal_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_20, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigInt_multi_is_equal_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_20, mfl_8, _temp_func);

        }
    } /* pass */
} /* Parrot_BigInt_class_init */

#line 1888 "./src/pmc/bigint.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
