/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/bignum.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_bignum.h"
#include "pmc_default.h"
#include "bignum.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/bignum.pmc"
/*
Copyright (C) 2004-2014, Parrot Foundation.

=head1 NAME

src/pmc/bignum.pmc - BigNum PMC

=head1 DESCRIPTION

C<BigNum> provides arbitrary precision floating point mathematic
functions, based on the GMP mpf library.

=head1 SYNOPSIS

Make mixing of classes work, like in:

        new $P0 ['BigInt']
        new $P1 ['BigNum']
        set $P0, 10
        set $P1, 2
        div P2, P0, P1  # $P2 = $P0 / $P1; (BigNum) 5.0

Make auto-upgrading/downgrading work.

        set $N1, $P0
        set $N1, $P1
        set $I1, $P0
        set $I1, $P1
        set $P0, $I1
        set $P0, $N1
        set $P1, $I1
        set $P1, $N1

  BigNum
    => BigInt => Integer
    => Number: float (can be long double) and double
    => Integer (unsigned long)

=head2 Functions

=over 4

=item C<static void bignum_init(PARROT_INTERP, PMC *self)>

=item C<static void bignum_clear(PARROT_INTERP, PMC *self)>

=item C<static void bignum_set(PARROT_INTERP, PMC *dest, PMC *src)>

=item C<static void bignum_set_si(PARROT_INTERP, PMC *self, long value)>

=item C<static void bignum_set_ui(PARROT_INTERP, PMC *self, unsigned long
value)>

=item C<static void bignum_set_float(PARROT_INTERP, PMC *self, FLOATVAL value)>

=item C<static void bignum_set_double(PARROT_INTERP, PMC *self, double value)>

=item C<static void bignum_set_str(PARROT_INTERP, PMC *self, const STRING
*value, int base)>

=item C<static void bignum_set_bigint(PARROT_INTERP, PMC *self, struct BIGINT
*value)>

=item C<static BIGNUM* bignum_get_self(PARROT_INTERP, PMC *self)>

=item C<static void bignum_set_self(PARROT_INTERP, PMC *self, BIGNUM *value)>

=item C<static long bignum_get_si(PARROT_INTERP, PMC *self)>

=item C<static unsigned long bignum_get_ui(PARROT_INTERP, PMC *self)>

=item C<static INTVAL bignum_get_bool(PARROT_INTERP, ARGIN(PMC *self))>

=item C<static char * bignum_get_string(PARROT_INTERP, PMC *self, int base)>

=item C<static char * bignum_get_string_size(PARROT_INTERP, PMC *self, int base,
int digits)>

=item C<static double bignum_get_double(PARROT_INTERP, PMC *self)>

=item C<static FLOATVAL bignum_get_float(PARROT_INTERP, PMC *self)>

=item C<static BIGINT bignum_get_bigint(Interp*, ARGIN(PMC *self))>

=item C<static void bignum_add_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC
*dest)>

=item C<static void bignum_add_bignum_int(PARROT_INTERP, PMC *self, INTVAL
value, PMC *dest)>

=item C<static void bignum_add_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL
value, PMC *dest)>

=item C<static void bignum_sub_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC
*dest)>

=item C<static void bignum_sub_bignum_int(PARROT_INTERP, PMC *self, INTVAL
value, PMC *dest)>

=item C<static void bignum_sub_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL
value, PMC *dest)>

=item C<static void bignum_mul_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC
*dest)>

=item C<static void bignum_mul_bignum_int(PARROT_INTERP, PMC *self, INTVAL
value, PMC *dest)>

=item C<static void bignum_mul_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL
value, PMC *dest)>

=item C<static void bignum_pow_bignum_int(PARROT_INTERP, PMC *self, INTVAL
value, PMC *dest)>

=item C<static void bignum_check_divide_zero(Interp*, PMC *value)>

=item C<static void bignum_div_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC
*dest)>

=item C<static void bignum_div_bignum_int(PARROT_INTERP, PMC *self, INTVAL
value, PMC *dest)>

=item C<static void bignum_div_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL
value, PMC *dest)>

=item C<static void bignum_fdiv_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC
*dest)>

=item C<static void bignum_fdiv_bignum_int(PARROT_INTERP, PMC *self, INTVAL
value, PMC *dest)>

=item C<static INTVAL bignum_cmp(PARROT_INTERP, PMC *self, PMC *value)>

=item C<static INTVAL bignum_cmp_double(PARROT_INTERP, PMC *self, double value)>

=item C<static INTVAL bignum_cmp_int(PARROT_INTERP, PMC *self, INTVAL value)>

=item C<static INTVAL bignum_cmp_ulong(PARROT_INTERP, PMC *self, unsigned long
value)>

=item C<static void bignum_abs(PARROT_INTERP, PMC *self, PMC *dest)>

=item C<static void bignum_neg(PARROT_INTERP, PMC *self, PMC *dest)>

=item C<static INTVAL bignum_get_default_prec(PARROT_INTERP, PMC *self)>

=item C<static void bignum_set_default_prec(PARROT_INTERP, PMC *self, INTVAL
prec)>

All the above functions are local to the bignum pmc and are there to provide
interface functions to The GNU MP Bignum Library (GMP)

If GMP is not available, at present these functions will throw a NYI exception.

(It would be appreciated if maintainers/implementors could improve the
 documentation here at some stage. possibly adding documentation for
 individual functions - at least the less obvious ones.)

=cut

*/

#ifdef S_SPLINT_S
#  undef PARROT_HAS_GMP /* splint barfs on the gmp.h header */
#endif /* S_SPLINT_S */


#ifdef PARROT_HAS_GMP
#  include "pmc/pmc_bigint.h"
#  include <gmp.h>
typedef struct BIGNUM {
    mpf_t b;
} BIGNUM;
#endif

#define NO_MULTIPLE_DISPATCH(name)                \
    Parrot_ex_throw_from_c_args(interp, NULL,     \
            EXCEPTION_INTERNAL_NOT_IMPLEMENTED,   \
            "BigNum: no multiple dispatch variant '%s' for %Ss", \
            (name), VTABLE_name(interp, value))

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

static void bignum_abs(PARROT_INTERP, ARGIN(PMC *self), ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        FUNC_MODIFIES(*dest);

static void bignum_add_bignum(PARROT_INTERP,
    ARGIN(PMC *self),
    ARGIN(PMC *value),
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_add_bignum_float(PARROT_INTERP,
    ARGIN(PMC *self),
    FLOATVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_add_bignum_int(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_clear(PARROT_INTERP, ARGIN(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static INTVAL bignum_cmp(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *value))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3);

static INTVAL bignum_cmp_double(PARROT_INTERP,
    ARGIN(PMC *self),
    double value)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static INTVAL bignum_cmp_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static INTVAL bignum_cmp_ulong(PARROT_INTERP,
    ARGIN(PMC *self),
    unsigned long value)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void bignum_div_bignum(PARROT_INTERP,
    ARGIN(PMC *self),
    ARGIN(PMC *value),
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_div_bignum_float(PARROT_INTERP,
    ARGIN(PMC *self),
    FLOATVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_div_bignum_int(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_fdiv_bignum(PARROT_INTERP,
    ARGIN(PMC *self),
    ARGIN(PMC *value),
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_fdiv_bignum_int(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static INTVAL bignum_get_default_prec(PARROT_INTERP, ARGIN(PMC *self))
        __attribute__nonnull__(2);

PARROT_WARN_UNUSED_RESULT
static double bignum_get_double(PARROT_INTERP, ARGIN(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

PARROT_WARN_UNUSED_RESULT
static FLOATVAL bignum_get_float(PARROT_INTERP, ARGIN(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

PARROT_WARN_UNUSED_RESULT
static long bignum_get_si(PARROT_INTERP, ARGIN(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

PARROT_WARN_UNUSED_RESULT
PARROT_CANNOT_RETURN_NULL
static char * bignum_get_string(PARROT_INTERP, ARGIN(PMC *self), int base)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

PARROT_WARN_UNUSED_RESULT
PARROT_CANNOT_RETURN_NULL
static char * bignum_get_string_size(PARROT_INTERP,
    ARGIN(PMC *self),
    int base,
    int digits)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

PARROT_WARN_UNUSED_RESULT
static unsigned long bignum_get_ui(PARROT_INTERP, ARGIN(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void bignum_init(PARROT_INTERP, ARGIN(PMC *self))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void bignum_mul_bignum(PARROT_INTERP,
    ARGIN(PMC *self),
    ARGIN(PMC *value),
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_mul_bignum_float(PARROT_INTERP,
    ARGIN(PMC *self),
    FLOATVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_mul_bignum_int(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_neg(PARROT_INTERP, ARGIN(PMC *self), ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        FUNC_MODIFIES(*dest);

static void bignum_pow_bignum_int(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_set(PARROT_INTERP, ARGMOD(PMC *dest), ARGIN(PMC *src))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        FUNC_MODIFIES(*dest);

static void bignum_set_default_prec(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL prec)
        __attribute__nonnull__(2);

static void bignum_set_double(PARROT_INTERP, ARGIN(PMC *self), double value)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void bignum_set_float(PARROT_INTERP,
    ARGIN(PMC *self),
    FLOATVAL value)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void bignum_set_si(PARROT_INTERP, ARGIN(PMC *self), long value)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void bignum_set_str(PARROT_INTERP,
    ARGIN(PMC *self),
    ARGIN(const STRING *value),
    int base)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3);

static void bignum_set_ui(PARROT_INTERP,
    ARGIN(PMC *self),
    unsigned long value)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void bignum_sub_bignum(PARROT_INTERP,
    ARGIN(PMC *self),
    ARGIN(PMC *value),
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_sub_bignum_float(PARROT_INTERP,
    ARGIN(PMC *self),
    FLOATVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

static void bignum_sub_bignum_int(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL value,
    ARGMOD(PMC *dest))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*dest);

#define ASSERT_ARGS_bignum_abs __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_add_bignum __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_add_bignum_float __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_add_bignum_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_clear __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_cmp __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value))
#define ASSERT_ARGS_bignum_cmp_double __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_cmp_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_cmp_ulong __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_div_bignum __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_div_bignum_float __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_div_bignum_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_fdiv_bignum __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_fdiv_bignum_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_get_default_prec __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_get_double __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_get_float __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_get_si __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_get_string __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_get_string_size __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_get_ui __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_init __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_mul_bignum __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_mul_bignum_float __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_mul_bignum_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_neg __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_pow_bignum_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_set __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(dest) \
    , PARROT_ASSERT_ARG(src))
#define ASSERT_ARGS_bignum_set_default_prec __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_set_double __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_set_float __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_set_si __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_set_str __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value))
#define ASSERT_ARGS_bignum_set_ui __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_bignum_sub_bignum __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(value) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_sub_bignum_float __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
#define ASSERT_ARGS_bignum_sub_bignum_int __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(dest))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/* Uncomment to easily disable it */
/*
#ifdef PARROT_HAS_GMP
#  undef PARROT_HAS_GMP
#endif
*/
#undef PARROT_BIGNUM_CAN_BIGINT

static void
bignum_init(PARROT_INTERP, ARGIN(PMC *self)) {
    ASSERT_ARGS(bignum_init)

#ifdef PARROT_HAS_GMP
    BIGNUM * const bn = mem_gc_allocate_zeroed_typed(interp, BIGNUM);
    SETATTR_BigNum_bn(interp, self, bn);
    mpf_clear(bn->b);
    mpf_init(bn->b);
#else
    SETATTR_BigNum_bn(interp, self, NULL);
#endif
}


static void
bignum_clear(PARROT_INTERP, ARGIN(PMC *self)) {
    ASSERT_ARGS(bignum_clear)

#ifdef PARROT_HAS_GMP
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_clear(bn->b);
    mem_gc_free(interp, bn);
#else
    UNUSED(self)
#endif
}


#ifdef PARROT_HAS_GMP

static void
bignum_set(PARROT_INTERP, ARGMOD(PMC *dest), ARGIN(PMC *src)) {
    ASSERT_ARGS(bignum_set)

    const BIGNUM *bn_src;
    BIGNUM *bn_dest;
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    GETATTR_BigNum_bn(interp, src,  bn_src);
    mpf_set(bn_dest->b, bn_src->b);
}

static void
bignum_set_si(PARROT_INTERP, ARGIN(PMC *self), long value) {
    ASSERT_ARGS(bignum_set_si)

    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set_si(bn->b, value);
}

static void
bignum_set_ui(PARROT_INTERP, ARGIN(PMC *self), unsigned long value) {
    ASSERT_ARGS(bignum_set_ui)

    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set_ui(bn->b, value);
}

static void
bignum_set_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value) {
    ASSERT_ARGS(bignum_set_float)

    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set_d(bn->b, (double)value);
}

static void
bignum_set_double(PARROT_INTERP, ARGIN(PMC *self), double value) {
    ASSERT_ARGS(bignum_set_double)

    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set_d(bn->b, value);
}

static void
bignum_set_str(PARROT_INTERP, ARGIN(PMC *self), ARGIN(const STRING *value), int base) {
    ASSERT_ARGS(bignum_set_str)

    char * const s = Parrot_str_to_cstring(interp, value);
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set_str(bn->b, s, base);
    Parrot_str_free_cstring(s);
}


PARROT_WARN_UNUSED_RESULT
static long
bignum_get_si(PARROT_INTERP, ARGIN(PMC *self)) {
    ASSERT_ARGS(bignum_get_si)

    const BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    if (mpf_fits_slong_p(bn->b))
        return mpf_get_si(bn->b);

    Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_ERR_OVERFLOW,
            "BigNum: number too big");
}

PARROT_WARN_UNUSED_RESULT
static unsigned long
bignum_get_ui(PARROT_INTERP, ARGIN(PMC *self)) {
    ASSERT_ARGS(bignum_get_ui)

    const BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    if (mpf_fits_slong_p(bn->b))
        return mpf_get_ui(bn->b);

    Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_ERR_OVERFLOW,
            "BigNum: number too big");
}

PARROT_WARN_UNUSED_RESULT
static INTVAL
bignum_get_bool(PARROT_INTERP, ARGIN(PMC *self)) {
    const BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    if (mpf_sgn(bn->b) != 0)
        return 1;
    else
        return 0;
}

PARROT_WARN_UNUSED_RESULT
PARROT_CANNOT_RETURN_NULL
static char *
bignum_get_string(PARROT_INTERP, ARGIN(PMC *self), int base) {
    ASSERT_ARGS(bignum_get_string)

    const BIGNUM *bn;
    size_t  n;
    char   *s;
    mp_exp_t exponent;

    GETATTR_BigNum_bn(interp, self, bn);
    n = (mpf_get_prec(bn->b)) / log(base) * log(2);
    s = mem_gc_allocate_n_typed(interp, n + 5, char);
    return mpf_get_str(s, &exponent, base, 0, bn->b);
}

PARROT_WARN_UNUSED_RESULT
PARROT_CANNOT_RETURN_NULL
static char *
bignum_get_string_size(PARROT_INTERP, ARGIN(PMC *self), int base, int digits) {
    ASSERT_ARGS(bignum_get_string_size)

    const BIGNUM *bn;
    char   *s;
    mp_exp_t exponent;

    GETATTR_BigNum_bn(interp, self, bn);
    s = mem_gc_allocate_n_typed(interp, digits + 5, char);
    return mpf_get_str(s, &exponent, base, digits, bn->b);
}

PARROT_WARN_UNUSED_RESULT
static double
bignum_get_double(PARROT_INTERP, ARGIN(PMC *self)) {
    ASSERT_ARGS(bignum_get_double)

    const BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return mpf_get_d(bn->b);
}

PARROT_WARN_UNUSED_RESULT
static FLOATVAL
bignum_get_float(PARROT_INTERP, ARGIN(PMC *self)) {
    ASSERT_ARGS(bignum_get_float)

    const BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return mpf_get_d(bn->b);
}

static void
bignum_add_bignum(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *value), ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_add_bignum)

    const BIGNUM *bn_self;
    const BIGNUM *bn_value;
    BIGNUM *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_add(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_add_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_add_bignum_int)

    const BIGNUM *bn_self;
    BIGNUM *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    if (value < 0)
        mpf_sub_ui(bn_dest->b, bn_self->b, (unsigned long int)-value);
    else
        mpf_add_ui(bn_dest->b, bn_self->b, (unsigned long int)value);
}

static void
bignum_add_bignum_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value, ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_add_bignum_float)

    const BIGNUM *bn_self;
    BIGNUM *bn_value;
    BIGNUM *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_value);
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_set_d(bn_value->b, value);
    mpf_add(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_sub_bignum(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *value), ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_sub_bignum)

    const BIGNUM *bn_self;
    const BIGNUM *bn_value;
    BIGNUM *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_sub(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_sub_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_sub_bignum_int)

    const BIGNUM *bn_self;
    BIGNUM *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    if (value < 0)
        mpf_add_ui(bn_dest->b, bn_self->b, (unsigned long int)-value);
    else
        mpf_sub_ui(bn_dest->b, bn_self->b, (unsigned long int)value);
}

static void
bignum_sub_bignum_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value, ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_sub_bignum_float)

    const BIGNUM *bn_self;
    BIGNUM *bn_tmp;
    BIGNUM *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_tmp);
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_set_d(bn_tmp->b, value);
    mpf_sub(bn_dest->b, bn_self->b, bn_tmp->b);
}

static void
bignum_mul_bignum(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *value), ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_mul_bignum)

    const BIGNUM *bn_self;
    const BIGNUM *bn_value;
    BIGNUM *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_mul(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_mul_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_mul_bignum_int)

    const BIGNUM *bn_self;
    BIGNUM *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_mul_ui(bn_dest->b, bn_self->b, (unsigned long)value);
}

static void
bignum_mul_bignum_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value, ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_mul_bignum_float)

    const BIGNUM *bn_self;
    BIGNUM *bn_tmp;
    BIGNUM *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_tmp);
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_set_d(bn_tmp->b, value);
    mpf_mul(bn_dest->b, bn_self->b, bn_tmp->b);
}

static void
bignum_pow_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_pow_bignum_int)

    const BIGNUM *bn_self;
    BIGNUM *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_pow_ui(bn_dest->b, bn_self->b, (unsigned long int)value);
}

static void
int_check_divide_zero(PARROT_INTERP, INTVAL value) {
    if (value == 0)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
}

static void
bignum_check_divide_zero(PARROT_INTERP, ARGIN(PMC *value)) {
    /* Throw an exception if we are dividing by zero. */
    const BIGNUM *bn;
    GETATTR_BigNum_bn(interp, value, bn);
    if (mpf_cmp_si(bn->b, 0) == 0)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
}

static void
bignum_div_bignum(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *value), ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_div_bignum)

    const BIGNUM *bn_self;
    const BIGNUM *bn_value;
    BIGNUM *bn_dest;
    bignum_check_divide_zero(interp, value);
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_div(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_div_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_div_bignum_int)

    const BIGNUM *bn_self;
    BIGNUM *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    int_check_divide_zero(interp, value);

    /* this is mpz_fdiv_q */
    if (value < 0) {
        mpf_div_ui(bn_dest->b, bn_self->b, (unsigned long int)-value);
        mpf_neg(bn_dest->b, bn_dest->b);
    }
    else
        mpf_div_ui(bn_dest->b, bn_self->b, (unsigned long int)value);
}

static void
bignum_div_bignum_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value, ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_div_bignum_float)

    const BIGNUM *bn_self;
    BIGNUM *bn_dest;
    BIGNUM bn;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    int_check_divide_zero(interp, value);
    mpf_init(bn.b);

    if (value < 0) {
        mpf_set_d(bn.b, -value);
        mpf_div(bn_dest->b, bn_self->b, bn.b);
        mpf_neg(bn_dest->b, bn_dest->b);
    }
    else {
        mpf_set_d(bn.b, value);
        mpf_div(bn_dest->b, bn_self->b, bn.b);
    }
    mpf_clear(bn.b);
}

/* There's no such mpf_fdiv, only mpz_fdiv and mpf_div */
static void
bignum_fdiv_bignum(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *value), ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_fdiv_bignum)

    const BIGNUM *bn_self;
    const BIGNUM *bn_value;
    BIGNUM *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    bignum_check_divide_zero(interp, value);
    mpf_div(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_fdiv_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_fdiv_bignum_int)

    const BIGNUM *bn_self;
    BIGNUM *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    int_check_divide_zero(interp, value);

    if (value < 0) {
        mpf_div_ui(bn_dest->b, bn_self->b, (unsigned long int)-value);
        mpf_neg(bn_dest->b, bn_dest->b);
    }
    else
        mpf_div_ui(bn_dest->b, bn_self->b, (unsigned long int)value);
}

static INTVAL
bignum_cmp(PARROT_INTERP, ARGIN(PMC *self), ARGIN(PMC *value)) {
    ASSERT_ARGS(bignum_cmp)

    const BIGNUM *bn_self;
    BIGNUM *bn_value;
    GETATTR_BigNum_bn(interp, self,  bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    return mpf_cmp(bn_self->b, bn_value->b);
}

static INTVAL
bignum_cmp_double(PARROT_INTERP, ARGIN(PMC *self), double value) {
    ASSERT_ARGS(bignum_cmp_double)

    const BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return mpf_cmp_d(bn->b, value);
}

static INTVAL
bignum_cmp_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value) {
    ASSERT_ARGS(bignum_cmp_int)

    const BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return mpf_cmp_si(bn->b, value);
}

static INTVAL
bignum_cmp_ulong(PARROT_INTERP, ARGIN(PMC *self), unsigned long value) {
    ASSERT_ARGS(bignum_cmp_ulong)

    const BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return mpf_cmp_ui(bn->b, value);
}

static void
bignum_abs(PARROT_INTERP, ARGIN(PMC *self), ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_abs)

    const BIGNUM *bn_self;
    BIGNUM *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_abs(bn_dest->b, bn_self->b);
}

static void
bignum_neg(PARROT_INTERP, ARGIN(PMC *self), ARGMOD(PMC *dest)) {
    ASSERT_ARGS(bignum_neg)

    const BIGNUM *bn_self;
    BIGNUM *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_neg(bn_dest->b, bn_self->b);
}

static INTVAL
bignum_get_default_prec(SHIM_INTERP, ARGIN(PMC *self)) {
    ASSERT_ARGS(bignum_get_default_prec)
    UNUSED(self)

    return mpf_get_default_prec();
}

static void
bignum_set_default_prec(SHIM_INTERP, ARGIN(PMC *self), INTVAL prec) {
    ASSERT_ARGS(bignum_set_default_prec)
    UNUSED(self)

    mpf_set_default_prec(prec);
}

/* HEADERIZER STOP */
/* Don't headerize these BIGINT and BIGNUM funcs */

PARROT_WARN_UNUSED_RESULT
PARROT_CANNOT_RETURN_NULL
static BIGNUM*
bignum_get_self(PARROT_INTERP, ARGIN(PMC *self)) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return bn;
}

static void
bignum_set_self(PARROT_INTERP, ARGIN(PMC *self), ARGIN(BIGNUM *value)) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set(bn->b, (mpf_srcptr)(value)->b);
}


#  ifdef PARROT_BIGNUM_CAN_BIGINT
PARROT_WARN_UNUSED_RESULT
static struct BIGINT
bignum_get_bigint(PARROT_INTERP, ARGIN(PMC *self)) {
    const BIGNUM *bn;
    struct BIGINT *bi_dest;
    GETATTR_BigNum_bn(interp, self, bn);
    mpz_clear(bi_dest->b);
    mpz_init(bi_dest->b);
    if (mpf_fits_slong_p(bn->b)) {
        bi_dest->b = mpf_get_ui(bn->b);
    }
    else {
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_LOSSY_CONVERSION,
            "BigNum: Precision loss");
    }
    return bi_dest;
}

static void
bignum_set_bigint(PARROT_INTERP, ARGIN(PMC *self), ARGIN(struct BIGINT *value)) {
    const BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set(bn->b, (mpf_srcptr)value->b);
}
#  endif

#else /* ifdef PARROT_HAS_GMP */

typedef struct BIGNUM {
    FLOATVAL b; /* bogus definition for users without libgmp*/
} BIGNUM;

#  define THROW_NOGMP Parrot_ex_throw_from_c_noargs(interp, \
                        EXCEPTION_LIBRARY_ERROR, "no bignum lib loaded")

static void
bignum_set(PARROT_INTERP, ARGMOD(PMC *dest), PMC *src) {
    UNUSED(dest)
    UNUSED(src)
    THROW_NOGMP;
}

static void
bignum_set_si(PARROT_INTERP, ARGIN(PMC *self), long value) {
    UNUSED(self)
    UNUSED(value)
    THROW_NOGMP;
}

static void
bignum_set_double(PARROT_INTERP, ARGIN(PMC *self), double value) {
    UNUSED(self)
    UNUSED(value)
    THROW_NOGMP;
}

static void
bignum_set_str(PARROT_INTERP, ARGIN(PMC *self), ARGIN(const STRING *value), int base) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(base)
    THROW_NOGMP;
}

static void
bignum_set_self(PARROT_INTERP, ARGIN(PMC *self), BIGNUM *value) {
    UNUSED(self)
    UNUSED(value)
    THROW_NOGMP;
}

static BIGNUM*
bignum_get_self(PARROT_INTERP, ARGIN(PMC *self)) {
    UNUSED(self)
    THROW_NOGMP;
}

static char *
bignum_get_string(PARROT_INTERP, ARGIN(PMC *self), int base) {
    UNUSED(self)
    UNUSED(base)
    THROW_NOGMP;
}

static char *
bignum_get_string_size(PARROT_INTERP, ARGIN(PMC *self), int base, int digits) {
    UNUSED(self)
    UNUSED(base)
    UNUSED(digits)
    THROW_NOGMP;
}

static unsigned long
bignum_get_ui(PARROT_INTERP, ARGIN(PMC *self)) {
    UNUSED(self)
    THROW_NOGMP;
}

static long
bignum_get_si(PARROT_INTERP, ARGIN(PMC *self)) {
    UNUSED(self)
    THROW_NOGMP;
}

static INTVAL
bignum_get_bool(PARROT_INTERP, ARGIN(PMC *self)) {
    UNUSED(self)
    THROW_NOGMP;
}

static double
bignum_get_double(PARROT_INTERP, ARGIN(PMC *self)) {
    UNUSED(self)
    THROW_NOGMP;
}

static void
bignum_add_bignum(PARROT_INTERP, ARGIN(PMC *self), PMC *value, ARGMOD(PMC *dest)) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bignum_add_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bignum_add_bignum_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value, ARGMOD(PMC *dest)) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bignum_sub_bignum(PARROT_INTERP, ARGIN(PMC *self), PMC *value, ARGMOD(PMC *dest)) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bignum_sub_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bignum_sub_bignum_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value, ARGMOD(PMC *dest)) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bignum_mul_bignum(PARROT_INTERP, ARGIN(PMC *self), PMC *value, ARGMOD(PMC *dest)) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bignum_mul_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bignum_mul_bignum_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value, ARGMOD(PMC *dest)) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bignum_pow_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bignum_pow_bignum_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value, ARGMOD(PMC *dest)) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bignum_div_bignum(PARROT_INTERP, ARGIN(PMC *self), PMC *value, ARGMOD(PMC *dest)) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bignum_div_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bignum_div_bignum_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value, ARGMOD(PMC *dest)) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bignum_fdiv_bignum(PARROT_INTERP, ARGIN(PMC *self), PMC *value, ARGMOD(PMC *dest)) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bignum_fdiv_bignum_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value, ARGMOD(PMC *dest)) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bignum_fdiv_bignum_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value, ARGMOD(PMC *dest)) {
    UNUSED(self)
    UNUSED(value)
    UNUSED(dest)
    THROW_NOGMP;
}

static INTVAL
bignum_cmp(PARROT_INTERP, ARGIN(PMC *self), PMC *value) {
    UNUSED(self)
    UNUSED(value)
    THROW_NOGMP;
}

static INTVAL
bignum_cmp_int(PARROT_INTERP, ARGIN(PMC *self), INTVAL value) {
    UNUSED(self)
    UNUSED(value)
    THROW_NOGMP;
}

static INTVAL
bignum_cmp_float(PARROT_INTERP, ARGIN(PMC *self), FLOATVAL value) {
    UNUSED(self)
    UNUSED(value)
    THROW_NOGMP;
}

static void
bignum_abs(PARROT_INTERP, ARGIN(PMC *self), ARGMOD(PMC *dest)) {
    UNUSED(self)
    UNUSED(dest)
    THROW_NOGMP;
}

static void
bignum_neg(PARROT_INTERP, ARGIN(PMC *self), ARGMOD(PMC *dest)) {
    UNUSED(self)
    UNUSED(dest)
    THROW_NOGMP;
}

static INTVAL
bignum_get_default_prec(PARROT_INTERP, ARGIN(PMC *self)) {
    UNUSED(self)
    THROW_NOGMP;
}

static void
bignum_set_default_prec(PARROT_INTERP, ARGIN(PMC *self), INTVAL prec) {
    UNUSED(self)
    UNUSED(prec)
    THROW_NOGMP;
}

#  undef THROW_NOGMP

#endif /* ifdef PARROT_HAS_GMP */
#line 1432 "./src/pmc/bignum.c"
static  PMC  * Parrot_BigNum_absolute(PARROT_INTERP, ARGMOD(PMC *_self), PMC *dest);
static  PMC * Parrot_BigNum_add(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_add_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest);
static  PMC  * Parrot_BigNum_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL Parrot_BigNum_cmp(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_decrement(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_BigNum_destroy(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC * Parrot_BigNum_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_divide_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, PMC *dest);
static  PMC  * Parrot_BigNum_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest);
static  PMC * Parrot_BigNum_floor_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_floor_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest);
static  INTVAL  Parrot_BigNum_get_bool(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_BigNum_get_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  FLOATVAL  Parrot_BigNum_get_number(PARROT_INTERP, ARGMOD(PMC *_self));
static  STRING  * Parrot_BigNum_get_repr(PARROT_INTERP, ARGMOD(PMC *_self));
static  STRING  * Parrot_BigNum_get_string(PARROT_INTERP, ARGMOD(PMC *_self));
static  STRING  * Parrot_BigNum_get_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL base);
static  void  Parrot_BigNum_i_absolute(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_i_add(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_i_add_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_BigNum_i_add_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void Parrot_BigNum_i_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_i_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void Parrot_BigNum_i_floor_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_i_floor_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void Parrot_BigNum_i_multiply(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_i_multiply_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_BigNum_i_multiply_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_BigNum_i_neg(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_i_subtract(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_i_subtract_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_BigNum_i_subtract_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_BigNum_increment(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_BigNum_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL Parrot_BigNum_is_equal(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  PMC * Parrot_BigNum_multiply(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multiply_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest);
static  PMC  * Parrot_BigNum_neg(PARROT_INTERP, ARGMOD(PMC *_self), PMC *dest);
static  void  Parrot_BigNum_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_BigNum_set_number_native(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_BigNum_set_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_set_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL base, STRING *value);
static  void  Parrot_BigNum_set_string_native(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value);
static  PMC * Parrot_BigNum_subtract(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_subtract_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest);
static  void Parrot_BigNum_nci_version(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_BigNum_multi_add_BigNum_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_add_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_add_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest));
static  void  Parrot_BigNum_multi_i_add_BigNum(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_multi_i_add_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_multi_i_add_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_multi_i_add_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value);
static  PMC  * Parrot_BigNum_multi_subtract_BigNum_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_subtract_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_subtract_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest));
static  void  Parrot_BigNum_multi_i_subtract_BigNum(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_multi_i_subtract_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_multi_i_subtract_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_multi_i_subtract_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value);
static  PMC  * Parrot_BigNum_multi_multiply_BigNum_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_multiply_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_multiply_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest));
static  void  Parrot_BigNum_multi_i_multiply_BigNum(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_multi_i_multiply_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_multi_i_multiply_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_multi_i_multiply_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value);
static  void Parrot_BigNum_nci_pow(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_BigNum_multi_divide_BigNum_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_divide_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_divide_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest));
static  void  Parrot_BigNum_multi_i_divide_BigNum(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_multi_i_divide_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_multi_i_divide_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_multi_i_divide_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value);
static  PMC  * Parrot_BigNum_multi_floor_divide_BigNum_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_floor_divide_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_BigNum_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest));
static  void  Parrot_BigNum_multi_i_floor_divide_BigNum(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_multi_i_floor_divide_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_BigNum_multi_i_floor_divide_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value);
static  INTVAL  Parrot_BigNum_multi_cmp_BigNum(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_BigNum_multi_cmp_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_BigNum_multi_cmp_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value);
static  INTVAL  Parrot_BigNum_multi_is_equal_BigNum(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_BigNum_multi_is_equal_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_BigNum_multi_is_equal_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value);
static  void Parrot_BigNum_multi_add_BigNum_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_add_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_add_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_i_add_BigNum_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_i_add_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_i_add_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_i_add_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_subtract_BigNum_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_subtract_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_subtract_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_i_subtract_BigNum_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_i_subtract_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_i_subtract_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_i_subtract_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_multiply_BigNum_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_multiply_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_multiply_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_i_multiply_BigNum_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_i_multiply_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_i_multiply_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_i_multiply_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_divide_BigNum_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_divide_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_divide_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_i_divide_BigNum_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_i_divide_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_i_divide_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_i_divide_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_floor_divide_BigNum_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_floor_divide_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_floor_divide_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_i_floor_divide_BigNum_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_i_floor_divide_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_i_floor_divide_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_cmp_BigNum_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_cmp_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_cmp_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_is_equal_BigNum_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_is_equal_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_BigNum_multi_is_equal_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
void    Parrot_BigNum_class_init(PARROT_INTERP, int, int);
void    Parrot_BigNum_ro_class_init(PARROT_INTERP, int, int);
static  PMC  *
Parrot_BigNum_absolute(PARROT_INTERP, ARGMOD(PMC *_self), PMC *dest)
{
#line 2039 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    bignum_abs(interp, _self, dest);
    return dest;
#line 1572 "./src/pmc/bignum.c"
}
static  PMC *
Parrot_BigNum_add(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_add_BigNum_PMC(interp, _self, value, dest);
            break;
        case enum_class_Integer:
            return Parrot_BigNum_multi_add_Integer_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "add", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_BigNum_multi_add_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC  *
Parrot_BigNum_add_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest)
{
#line 1698 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    bignum_add_bignum_int(interp, _self, value, dest);
    return dest;
#line 1610 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1445 "./src/pmc/bignum.pmc"

    PMC * const res = Parrot_pmc_new(interp, _self->vtable->base_type);
    bignum_set(interp, res, _self);
    return res;
#line 1620 "./src/pmc/bignum.c"
}
static  INTVAL
Parrot_BigNum_cmp(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_cmp_BigNum(interp, _self, value);
            break;
        case enum_class_Integer:
            return Parrot_BigNum_multi_cmp_Integer(interp, _self, value);
            break;
        case enum_class_core_max:
            {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "cmp", "PP->I", _self, value, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_BigNum_multi_cmp_DEFAULT(interp, _self, value);
            break;

    }
}
static  void 
Parrot_BigNum_decrement(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1666 "./src/pmc/bignum.pmc"

    bignum_sub_bignum_int(interp, _self, 1, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 1656 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_destroy(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1451 "./src/pmc/bignum.pmc"

    bignum_clear(interp, _self);
#line 1664 "./src/pmc/bignum.c"
}
static  PMC *
Parrot_BigNum_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_divide_BigNum_PMC(interp, _self, value, dest);
            break;
        case enum_class_Integer:
            return Parrot_BigNum_multi_divide_Integer_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "divide", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_BigNum_multi_divide_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC  *
Parrot_BigNum_divide_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, PMC *dest)
{
#line 1908 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    bignum_div_bignum_float(interp, _self, value, dest);
    return dest;
#line 1702 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest)
{
#line 1901 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    bignum_div_bignum_int(interp, _self, value, dest);
    return dest;
#line 1713 "./src/pmc/bignum.c"
}
static  PMC *
Parrot_BigNum_floor_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_floor_divide_BigNum_PMC(interp, _self, value, dest);
            break;
        case enum_class_Integer:
            return Parrot_BigNum_multi_floor_divide_Integer_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "floor_divide", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_BigNum_multi_floor_divide_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC  *
Parrot_BigNum_floor_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest)
{
#line 1961 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    bignum_fdiv_bignum_int(interp, _self, value, dest);
    return dest;
#line 1751 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_get_bool(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1589 "./src/pmc/bignum.pmc"

    return bignum_get_bool(interp, _self);
#line 1759 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_get_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1541 "./src/pmc/bignum.pmc"

    return bignum_get_si(interp, _self);
#line 1767 "./src/pmc/bignum.c"
}
static  FLOATVAL 
Parrot_BigNum_get_number(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1527 "./src/pmc/bignum.pmc"

    return bignum_get_double(interp, _self);
#line 1775 "./src/pmc/bignum.c"
}
static  STRING  *
Parrot_BigNum_get_repr(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1638 "./src/pmc/bignum.pmc"

    STRING * const s = VTABLE_get_string(interp, _self);
    return Parrot_str_concat(interp, s, Parrot_str_new(interp, "N", 1));
#line 1784 "./src/pmc/bignum.c"
}
static  STRING  *
Parrot_BigNum_get_string(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1617 "./src/pmc/bignum.pmc"

    char   * const s  = bignum_get_string(interp, _self, 10);
    STRING * const ps = Parrot_str_new(interp, s, 0);
    mem_gc_free(interp, s);
    return ps;
#line 1795 "./src/pmc/bignum.c"
}
static  STRING  *
Parrot_BigNum_get_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL base)
{
#line 1624 "./src/pmc/bignum.pmc"

    char   * const s  = bignum_get_string(interp, _self, base);
    STRING * const ps = Parrot_str_new(interp, s, 0);
    mem_gc_free(interp, s);
    return ps;
#line 1806 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_i_absolute(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 2046 "./src/pmc/bignum.pmc"

    bignum_abs(interp, _self, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 1815 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_i_add(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            Parrot_BigNum_multi_i_add_BigNum(interp, _self, value);
            break;
        case enum_class_Integer:
            Parrot_BigNum_multi_i_add_Integer(interp, _self, value);
            break;
        case enum_class_Float:
            Parrot_BigNum_multi_i_add_Float(interp, _self, value);
            break;
        case enum_class_core_max:
            Parrot_mmd_multi_dispatch_from_c_args(interp, "i_add", "PP->", _self, value);
            break;
        default:
            Parrot_BigNum_multi_i_add_DEFAULT(interp, _self, value);
            break;

    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_BigNum_i_add_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 1726 "./src/pmc/bignum.pmc"

    bignum_add_bignum_float(interp, _self, value, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 1851 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_i_add_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 1722 "./src/pmc/bignum.pmc"

    bignum_add_bignum_int(interp, _self, value, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 1860 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_i_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            Parrot_BigNum_multi_i_divide_BigNum(interp, _self, value);
            break;
        case enum_class_Integer:
            Parrot_BigNum_multi_i_divide_Integer(interp, _self, value);
            break;
        case enum_class_Float:
            Parrot_BigNum_multi_i_divide_Float(interp, _self, value);
            break;
        case enum_class_core_max:
            Parrot_mmd_multi_dispatch_from_c_args(interp, "i_divide", "PP->", _self, value);
            break;
        default:
            Parrot_BigNum_multi_i_divide_DEFAULT(interp, _self, value);
            break;

    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_BigNum_i_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 1929 "./src/pmc/bignum.pmc"

    bignum_div_bignum_int(interp, _self, value, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 1896 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_i_floor_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            Parrot_BigNum_multi_i_floor_divide_BigNum(interp, _self, value);
            break;
        case enum_class_Integer:
            Parrot_BigNum_multi_i_floor_divide_Integer(interp, _self, value);
            break;
        case enum_class_core_max:
            Parrot_mmd_multi_dispatch_from_c_args(interp, "i_floor_divide", "PP->", _self, value);
            break;
        default:
            Parrot_BigNum_multi_i_floor_divide_DEFAULT(interp, _self, value);
            break;

    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_BigNum_i_floor_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 1981 "./src/pmc/bignum.pmc"

    bignum_fdiv_bignum_int(interp, _self, value, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 1929 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_i_multiply(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            Parrot_BigNum_multi_i_multiply_BigNum(interp, _self, value);
            break;
        case enum_class_Float:
            Parrot_BigNum_multi_i_multiply_Float(interp, _self, value);
            break;
        case enum_class_Integer:
            Parrot_BigNum_multi_i_multiply_Integer(interp, _self, value);
            break;
        case enum_class_core_max:
            Parrot_mmd_multi_dispatch_from_c_args(interp, "i_multiply", "PP->", _self, value);
            break;
        default:
            Parrot_BigNum_multi_i_multiply_DEFAULT(interp, _self, value);
            break;

    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_BigNum_i_multiply_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 1846 "./src/pmc/bignum.pmc"

    bignum_mul_bignum_float(interp, _self, value, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 1965 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_i_multiply_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 1842 "./src/pmc/bignum.pmc"

    bignum_mul_bignum_int(interp, _self, value, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 1974 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_i_neg(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 2070 "./src/pmc/bignum.pmc"

    bignum_neg(interp, _self, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 1983 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_i_subtract(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            Parrot_BigNum_multi_i_subtract_BigNum(interp, _self, value);
            break;
        case enum_class_Integer:
            Parrot_BigNum_multi_i_subtract_Integer(interp, _self, value);
            break;
        case enum_class_Float:
            Parrot_BigNum_multi_i_subtract_Float(interp, _self, value);
            break;
        case enum_class_core_max:
            Parrot_mmd_multi_dispatch_from_c_args(interp, "i_subtract", "PP->", _self, value);
            break;
        default:
            Parrot_BigNum_multi_i_subtract_DEFAULT(interp, _self, value);
            break;

    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_BigNum_i_subtract_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 1786 "./src/pmc/bignum.pmc"

    bignum_sub_bignum_float(interp, _self, value, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 2019 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_i_subtract_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 1782 "./src/pmc/bignum.pmc"

    bignum_sub_bignum_int(interp, _self, value, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 2028 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_increment(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1652 "./src/pmc/bignum.pmc"

    bignum_add_bignum_int(interp, _self, 1, _self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 2037 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1440 "./src/pmc/bignum.pmc"

    bignum_init(interp, _self);
    PObj_custom_destroy_SET(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 2047 "./src/pmc/bignum.c"
}
static  INTVAL
Parrot_BigNum_is_equal(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_is_equal_BigNum(interp, _self, value);
            break;
        case enum_class_Integer:
            return Parrot_BigNum_multi_is_equal_Integer(interp, _self, value);
            break;
        case enum_class_core_max:
            {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "is_equal", "PP->I", _self, value, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_BigNum_multi_is_equal_DEFAULT(interp, _self, value);
            break;

    }
}
static  PMC *
Parrot_BigNum_multiply(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_multiply_BigNum_PMC(interp, _self, value, dest);
            break;
        case enum_class_Integer:
            return Parrot_BigNum_multi_multiply_Integer_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "multiply", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_BigNum_multi_multiply_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC  *
Parrot_BigNum_multiply_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest)
{
#line 1818 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    bignum_mul_bignum_int(interp, _self, value, dest);
    return dest;
#line 2112 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_neg(PARROT_INTERP, ARGMOD(PMC *_self), PMC *dest)
{
#line 2063 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    bignum_neg(interp, _self, dest);
    return dest;
#line 2123 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 1463 "./src/pmc/bignum.pmc"

    bignum_set_si(interp, _self, (long)value);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 2132 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_set_number_native(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 1477 "./src/pmc/bignum.pmc"

    bignum_set_double(interp, _self, (double)value);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 2141 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_set_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1513 "./src/pmc/bignum.pmc"

    bignum_set_self(interp, _self, bignum_get_self(interp, value));
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 2150 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_set_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL base, STRING *value)
{
#line 1500 "./src/pmc/bignum.pmc"

    bignum_set_str(interp, _self, value, base);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 2159 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_set_string_native(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value)
{
#line 1496 "./src/pmc/bignum.pmc"

    bignum_set_str(interp, _self, value, 10);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 2168 "./src/pmc/bignum.c"
}
static  PMC *
Parrot_BigNum_subtract(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_BigNum:
            return Parrot_BigNum_multi_subtract_BigNum_PMC(interp, _self, value, dest);
            break;
        case enum_class_Integer:
            return Parrot_BigNum_multi_subtract_Integer_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "subtract", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_BigNum_multi_subtract_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC  *
Parrot_BigNum_subtract_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest)
{
#line 1758 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    bignum_sub_bignum_int(interp, _self, value, dest);
    return dest;
#line 2206 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_nci_version(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 1429 "./src/pmc/bignum.pmc"

    STRING *version;
#ifdef PARROT_HAS_GMP
    UNUSED(_self)
    version = Parrot_str_new(interp, gmp_version, 0);
#else
    version = Parrot_str_new(interp, "0.0.0", 5);
#endif
    #line 2235 "./src/pmc/bignum.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)version);
        
        return;
     }
#line 1437 "./src/pmc/bignum.pmc"

#line 2243 "./src/pmc/bignum.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  PMC  *
Parrot_BigNum_multi_add_BigNum_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1678 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    bignum_add_bignum(interp, _self, value, dest);
    return dest;
#line 2261 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_add_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1685 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    bignum_add_bignum_int(interp, _self, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 2272 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_add_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest))
{
#line 1692 "./src/pmc/bignum.pmc"
    NO_MULTIPLE_DISPATCH("add");
#line 2279 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_add_BigNum(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1705 "./src/pmc/bignum.pmc"

    bignum_add_bignum(interp, _self, value, _self);
#line 2287 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_add_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1709 "./src/pmc/bignum.pmc"

    bignum_add_bignum_int(interp, _self, VTABLE_get_integer(interp, value), _self);
#line 2295 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_add_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1713 "./src/pmc/bignum.pmc"

    bignum_add_bignum_float(interp, _self, VTABLE_get_number(interp, value), _self);
#line 2303 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_add_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value)
{
#line 1717 "./src/pmc/bignum.pmc"
    NO_MULTIPLE_DISPATCH("i_add");
#line 2310 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_subtract_BigNum_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1738 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    bignum_sub_bignum(interp, _self, value, dest);
    return dest;
#line 2321 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_subtract_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1745 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    bignum_sub_bignum_int(interp, _self, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 2332 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_subtract_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest))
{
#line 1752 "./src/pmc/bignum.pmc"
    NO_MULTIPLE_DISPATCH("substract");
#line 2339 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_subtract_BigNum(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1765 "./src/pmc/bignum.pmc"

    bignum_sub_bignum(interp, _self, value, _self);
#line 2347 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_subtract_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1769 "./src/pmc/bignum.pmc"

    bignum_sub_bignum_int(interp, _self, VTABLE_get_integer(interp, value), _self);
#line 2355 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_subtract_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1773 "./src/pmc/bignum.pmc"

    bignum_sub_bignum_float(interp, _self, VTABLE_get_number(interp, value), _self);
#line 2363 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_subtract_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value)
{
#line 1777 "./src/pmc/bignum.pmc"
    NO_MULTIPLE_DISPATCH("i_subtract");
#line 2370 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_multiply_BigNum_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1798 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    bignum_mul_bignum(interp, _self, value, dest);
    return dest;
#line 2381 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_multiply_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1805 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    bignum_mul_bignum_int(interp, _self, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 2392 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_multiply_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest))
{
#line 1812 "./src/pmc/bignum.pmc"
    NO_MULTIPLE_DISPATCH("multiply");
#line 2399 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_multiply_BigNum(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1825 "./src/pmc/bignum.pmc"

    bignum_mul_bignum(interp, _self, value, _self);
#line 2407 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_multiply_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1829 "./src/pmc/bignum.pmc"

    bignum_mul_bignum_float(interp, _self, VTABLE_get_number(interp, value), _self);
#line 2415 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_multiply_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1833 "./src/pmc/bignum.pmc"

    bignum_mul_bignum_int(interp, _self, VTABLE_get_integer(interp, value), _self);
#line 2423 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_multiply_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value)
{
#line 1837 "./src/pmc/bignum.pmc"
    NO_MULTIPLE_DISPATCH("i_multiply");
#line 2430 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_nci_pow(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    PMC* value;
    
    const INTVAL arity = 2; /* "PiP" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    value = VTABLE_get_pmc_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 1864 "./src/pmc/bignum.pmc"

    /* only Integer RHS currently. TODO: check number and bignum types */
    const INTVAL r = VTABLE_get_integer(interp, value);
    PMC * const dest = Parrot_pmc_new(interp, _self->vtable->base_type);

    bignum_pow_bignum_int(interp, _self, r, dest);
    #line 2459 "./src/pmc/bignum.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)dest);
        
        return;
     }
#line 1870 "./src/pmc/bignum.pmc"

#line 2467 "./src/pmc/bignum.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  PMC  *
Parrot_BigNum_multi_divide_BigNum_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1881 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    bignum_div_bignum(interp, _self, value, dest);
    return dest;
#line 2485 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_divide_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1888 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    bignum_div_bignum_int(interp, _self, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 2496 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_divide_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest))
{
#line 1895 "./src/pmc/bignum.pmc"
    NO_MULTIPLE_DISPATCH("divide");
#line 2503 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_divide_BigNum(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1915 "./src/pmc/bignum.pmc"

    bignum_div_bignum(interp, _self, value, _self);
#line 2511 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_divide_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1918 "./src/pmc/bignum.pmc"

    bignum_div_bignum_int(interp, _self, VTABLE_get_integer(interp, value), _self);
#line 2519 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_divide_Float(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1921 "./src/pmc/bignum.pmc"

    bignum_div_bignum_float(interp, _self, VTABLE_get_number(interp, value), _self);
#line 2527 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_divide_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value)
{
#line 1924 "./src/pmc/bignum.pmc"
    NO_MULTIPLE_DISPATCH("i_divide");
#line 2534 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_floor_divide_BigNum_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1941 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    bignum_fdiv_bignum(interp, _self, value, dest);
    return dest;
#line 2545 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_floor_divide_Integer_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1948 "./src/pmc/bignum.pmc"

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    bignum_fdiv_bignum_int(interp, _self, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 2556 "./src/pmc/bignum.c"
}
static  PMC  *
Parrot_BigNum_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, SHIM(PMC *_self), PMC *value, SHIM(PMC *dest))
{
#line 1955 "./src/pmc/bignum.pmc"
    NO_MULTIPLE_DISPATCH("floor_divide");
#line 2563 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_floor_divide_BigNum(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1968 "./src/pmc/bignum.pmc"

    bignum_fdiv_bignum(interp, _self, value, _self);
#line 2571 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_floor_divide_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1972 "./src/pmc/bignum.pmc"

    bignum_fdiv_bignum_int(interp, _self, VTABLE_get_integer(interp, value), _self);
#line 2579 "./src/pmc/bignum.c"
}
static  void 
Parrot_BigNum_multi_i_floor_divide_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value)
{
#line 1976 "./src/pmc/bignum.pmc"
    NO_MULTIPLE_DISPATCH("i_floor_divide");
#line 2586 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_multi_cmp_BigNum(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1993 "./src/pmc/bignum.pmc"

    return bignum_cmp(interp, _self, value);
#line 2594 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_multi_cmp_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1997 "./src/pmc/bignum.pmc"

    return bignum_cmp_int(interp, _self, VTABLE_get_integer(interp, value));
#line 2602 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_multi_cmp_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value)
{
#line 2001 "./src/pmc/bignum.pmc"
    NO_MULTIPLE_DISPATCH("cmp");
#line 2609 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_multi_is_equal_BigNum(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 2014 "./src/pmc/bignum.pmc"

    return bignum_cmp(interp, _self, value) == 0;
#line 2617 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_multi_is_equal_Integer(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 2018 "./src/pmc/bignum.pmc"

    return bignum_cmp_int(interp, _self, VTABLE_get_integer(interp, value)) == 0;
#line 2625 "./src/pmc/bignum.c"
}
static  INTVAL 
Parrot_BigNum_multi_is_equal_DEFAULT(PARROT_INTERP, SHIM(PMC *_self), PMC *value)
{
#line 2022 "./src/pmc/bignum.pmc"
    NO_MULTIPLE_DISPATCH("is_equal");
#line 2632 "./src/pmc/bignum.c"
}
static  void
Parrot_BigNum_multi_add_BigNum_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigNum_multi_add_BigNum_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigNum_multi_add_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigNum_multi_add_Integer_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigNum_multi_add_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigNum_multi_add_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigNum_multi_i_add_BigNum_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigNum_multi_i_add_BigNum(interp, _self, value);
}
static  void
Parrot_BigNum_multi_i_add_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigNum_multi_i_add_Integer(interp, _self, value);
}
static  void
Parrot_BigNum_multi_i_add_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigNum_multi_i_add_Float(interp, _self, value);
}
static  void
Parrot_BigNum_multi_i_add_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigNum_multi_i_add_DEFAULT(interp, _self, value);
}
static  void
Parrot_BigNum_multi_subtract_BigNum_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigNum_multi_subtract_BigNum_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigNum_multi_subtract_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigNum_multi_subtract_Integer_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigNum_multi_subtract_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigNum_multi_subtract_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigNum_multi_i_subtract_BigNum_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigNum_multi_i_subtract_BigNum(interp, _self, value);
}
static  void
Parrot_BigNum_multi_i_subtract_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigNum_multi_i_subtract_Integer(interp, _self, value);
}
static  void
Parrot_BigNum_multi_i_subtract_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigNum_multi_i_subtract_Float(interp, _self, value);
}
static  void
Parrot_BigNum_multi_i_subtract_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigNum_multi_i_subtract_DEFAULT(interp, _self, value);
}
static  void
Parrot_BigNum_multi_multiply_BigNum_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigNum_multi_multiply_BigNum_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigNum_multi_multiply_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigNum_multi_multiply_Integer_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigNum_multi_multiply_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigNum_multi_multiply_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigNum_multi_i_multiply_BigNum_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigNum_multi_i_multiply_BigNum(interp, _self, value);
}
static  void
Parrot_BigNum_multi_i_multiply_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigNum_multi_i_multiply_Float(interp, _self, value);
}
static  void
Parrot_BigNum_multi_i_multiply_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigNum_multi_i_multiply_Integer(interp, _self, value);
}
static  void
Parrot_BigNum_multi_i_multiply_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigNum_multi_i_multiply_DEFAULT(interp, _self, value);
}
static  void
Parrot_BigNum_multi_divide_BigNum_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigNum_multi_divide_BigNum_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigNum_multi_divide_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigNum_multi_divide_Integer_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigNum_multi_divide_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigNum_multi_divide_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigNum_multi_i_divide_BigNum_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigNum_multi_i_divide_BigNum(interp, _self, value);
}
static  void
Parrot_BigNum_multi_i_divide_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigNum_multi_i_divide_Integer(interp, _self, value);
}
static  void
Parrot_BigNum_multi_i_divide_Float_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigNum_multi_i_divide_Float(interp, _self, value);
}
static  void
Parrot_BigNum_multi_i_divide_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigNum_multi_i_divide_DEFAULT(interp, _self, value);
}
static  void
Parrot_BigNum_multi_floor_divide_BigNum_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigNum_multi_floor_divide_BigNum_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigNum_multi_floor_divide_Integer_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigNum_multi_floor_divide_Integer_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigNum_multi_floor_divide_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_BigNum_multi_floor_divide_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_BigNum_multi_i_floor_divide_BigNum_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigNum_multi_i_floor_divide_BigNum(interp, _self, value);
}
static  void
Parrot_BigNum_multi_i_floor_divide_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigNum_multi_i_floor_divide_Integer(interp, _self, value);
}
static  void
Parrot_BigNum_multi_i_floor_divide_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_BigNum_multi_i_floor_divide_DEFAULT(interp, _self, value);
}
static  void
Parrot_BigNum_multi_cmp_BigNum_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_BigNum_multi_cmp_BigNum(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
static  void
Parrot_BigNum_multi_cmp_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_BigNum_multi_cmp_Integer(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
static  void
Parrot_BigNum_multi_cmp_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_BigNum_multi_cmp_DEFAULT(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
static  void
Parrot_BigNum_multi_is_equal_BigNum_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_BigNum_multi_is_equal_BigNum(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
static  void
Parrot_BigNum_multi_is_equal_Integer_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_BigNum_multi_is_equal_Integer(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
static  void
Parrot_BigNum_multi_is_equal_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_BigNum_multi_is_equal_DEFAULT(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_BigNum_update_vtable(VTABLE *vt) {
    vt->absolute = Parrot_BigNum_absolute;
    vt->add = Parrot_BigNum_add;
    vt->add_int = Parrot_BigNum_add_int;
    vt->clone = Parrot_BigNum_clone;
    vt->cmp = Parrot_BigNum_cmp;
    vt->decrement = Parrot_BigNum_decrement;
    vt->destroy = Parrot_BigNum_destroy;
    vt->divide = Parrot_BigNum_divide;
    vt->divide_float = Parrot_BigNum_divide_float;
    vt->divide_int = Parrot_BigNum_divide_int;
    vt->floor_divide = Parrot_BigNum_floor_divide;
    vt->floor_divide_int = Parrot_BigNum_floor_divide_int;
    vt->get_bool = Parrot_BigNum_get_bool;
    vt->get_integer = Parrot_BigNum_get_integer;
    vt->get_number = Parrot_BigNum_get_number;
    vt->get_repr = Parrot_BigNum_get_repr;
    vt->get_string = Parrot_BigNum_get_string;
    vt->get_string_keyed_int = Parrot_BigNum_get_string_keyed_int;
    vt->i_absolute = Parrot_BigNum_i_absolute;
    vt->i_add = Parrot_BigNum_i_add;
    vt->i_add_float = Parrot_BigNum_i_add_float;
    vt->i_add_int = Parrot_BigNum_i_add_int;
    vt->i_divide = Parrot_BigNum_i_divide;
    vt->i_divide_int = Parrot_BigNum_i_divide_int;
    vt->i_floor_divide = Parrot_BigNum_i_floor_divide;
    vt->i_floor_divide_int = Parrot_BigNum_i_floor_divide_int;
    vt->i_multiply = Parrot_BigNum_i_multiply;
    vt->i_multiply_float = Parrot_BigNum_i_multiply_float;
    vt->i_multiply_int = Parrot_BigNum_i_multiply_int;
    vt->i_neg = Parrot_BigNum_i_neg;
    vt->i_subtract = Parrot_BigNum_i_subtract;
    vt->i_subtract_float = Parrot_BigNum_i_subtract_float;
    vt->i_subtract_int = Parrot_BigNum_i_subtract_int;
    vt->increment = Parrot_BigNum_increment;
    vt->init = Parrot_BigNum_init;
    vt->is_equal = Parrot_BigNum_is_equal;
    vt->multiply = Parrot_BigNum_multiply;
    vt->multiply_int = Parrot_BigNum_multiply_int;
    vt->neg = Parrot_BigNum_neg;
    vt->set_integer_native = Parrot_BigNum_set_integer_native;
    vt->set_number_native = Parrot_BigNum_set_number_native;
    vt->set_pmc = Parrot_BigNum_set_pmc;
    vt->set_string_keyed_int = Parrot_BigNum_set_string_keyed_int;
    vt->set_string_native = Parrot_BigNum_set_string_native;
    vt->subtract = Parrot_BigNum_subtract;
    vt->subtract_int = Parrot_BigNum_subtract_int;
    vt->attr_size = sizeof(Parrot_BigNum_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_BigNum_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->absolute = Parrot_BigNum_absolute;
    vt->add = Parrot_BigNum_add;
    vt->add_int = Parrot_BigNum_add_int;
    vt->clone = Parrot_BigNum_clone;
    vt->cmp = Parrot_BigNum_cmp;
    vt->destroy = Parrot_BigNum_destroy;
    vt->divide = Parrot_BigNum_divide;
    vt->divide_float = Parrot_BigNum_divide_float;
    vt->divide_int = Parrot_BigNum_divide_int;
    vt->floor_divide = Parrot_BigNum_floor_divide;
    vt->floor_divide_int = Parrot_BigNum_floor_divide_int;
    vt->get_bool = Parrot_BigNum_get_bool;
    vt->get_integer = Parrot_BigNum_get_integer;
    vt->get_number = Parrot_BigNum_get_number;
    vt->get_repr = Parrot_BigNum_get_repr;
    vt->get_string = Parrot_BigNum_get_string;
    vt->get_string_keyed_int = Parrot_BigNum_get_string_keyed_int;
    vt->is_equal = Parrot_BigNum_is_equal;
    vt->multiply = Parrot_BigNum_multiply;
    vt->multiply_int = Parrot_BigNum_multiply_int;
    vt->neg = Parrot_BigNum_neg;
    vt->subtract = Parrot_BigNum_subtract;
    vt->subtract_int = Parrot_BigNum_subtract_int;
    vt->attr_size = sizeof(Parrot_BigNum_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_BigNum_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_BigNum_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_BigNum_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_BigNum_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_BigNum_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "BigNum"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_BigNum_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "BigNum")), PMCNULL);
    return isa;
}

void
Parrot_BigNum_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":bn ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_BigNum_get_vtable(interp);
        vt->base_type      = enum_class_BigNum;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "BigNum");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_BigNum_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_BigNum_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_BigNum;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_BigNum_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "version");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_BigNum_nci_version),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "pow");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_BigNum_nci_pow),
                method_name, signature);
        }
        {
            STRING * const mfl_0 = CONST_STRING_GEN(interp, "add");
            STRING * const mfl_1 = CONST_STRING_GEN(interp, "BigNum,BigNum,PMC");
            STRING * const mfl_2 = CONST_STRING_GEN(interp, "BigNum");
            STRING * const mfl_3 = CONST_STRING_GEN(interp, "BigNum,Integer,PMC");
            STRING * const mfl_4 = CONST_STRING_GEN(interp, "BigNum,DEFAULT,PMC");
            STRING * const mfl_5 = CONST_STRING_GEN(interp, "i_add");
            STRING * const mfl_6 = CONST_STRING_GEN(interp, "BigNum,BigNum");
            STRING * const mfl_7 = CONST_STRING_GEN(interp, "BigNum,Integer");
            STRING * const mfl_8 = CONST_STRING_GEN(interp, "BigNum,Float");
            STRING * const mfl_9 = CONST_STRING_GEN(interp, "BigNum,DEFAULT");
            STRING * const mfl_10 = CONST_STRING_GEN(interp, "subtract");
            STRING * const mfl_11 = CONST_STRING_GEN(interp, "i_subtract");
            STRING * const mfl_12 = CONST_STRING_GEN(interp, "multiply");
            STRING * const mfl_13 = CONST_STRING_GEN(interp, "i_multiply");
            STRING * const mfl_14 = CONST_STRING_GEN(interp, "divide");
            STRING * const mfl_15 = CONST_STRING_GEN(interp, "i_divide");
            STRING * const mfl_16 = CONST_STRING_GEN(interp, "floor_divide");
            STRING * const mfl_17 = CONST_STRING_GEN(interp, "i_floor_divide");
            STRING * const mfl_18 = CONST_STRING_GEN(interp, "cmp");
            STRING * const mfl_19 = CONST_STRING_GEN(interp, "is_equal");
        PMC *_temp_func;
_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_add_BigNum_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_add_Integer_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_add_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_i_add_BigNum_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_5, mfl_6, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_i_add_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_5, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_i_add_Float_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_5, mfl_8, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_i_add_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_5, mfl_9, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_subtract_BigNum_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_10, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_subtract_Integer_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_10, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_subtract_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_10, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_i_subtract_BigNum_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_11, mfl_6, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_i_subtract_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_11, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_i_subtract_Float_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_11, mfl_8, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_i_subtract_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_11, mfl_9, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_multiply_BigNum_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_12, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_multiply_Integer_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_12, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_multiply_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_12, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_i_multiply_BigNum_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_13, mfl_6, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_i_multiply_Float_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_13, mfl_8, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_i_multiply_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_13, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_i_multiply_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_13, mfl_9, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_divide_BigNum_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_14, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_divide_Integer_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_14, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_divide_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_14, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_i_divide_BigNum_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_15, mfl_6, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_i_divide_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_15, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_i_divide_Float_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_15, mfl_8, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_i_divide_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_15, mfl_9, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_floor_divide_BigNum_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_16, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_floor_divide_Integer_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_16, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_floor_divide_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_16, mfl_4, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_i_floor_divide_BigNum_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_17, mfl_6, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_i_floor_divide_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_17, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_i_floor_divide_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_17, mfl_9, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_cmp_BigNum_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_18, mfl_6, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_cmp_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_18, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_cmp_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_18, mfl_9, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_is_equal_BigNum_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_19, mfl_6, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_is_equal_Integer_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_19, mfl_7, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_BigNum_multi_is_equal_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_19, mfl_9, _temp_func);

        }
    } /* pass */
} /* Parrot_BigNum_class_init */

#line 2073 "./src/pmc/bignum.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
