/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/continuation.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_continuation.h"
#include "pmc_default.h"
#include "continuation.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/continuation.pmc"
/*
Copyright (C) 2001-2014, Parrot Foundation.

=head1 NAME

src/pmc/continuation.pmc - Continuation PMC

=head1 DESCRIPTION

A C<Continuation> has a copy of the interpreter's context at the location where
the Continuation was constructed.  See the L<Glossary|docs/glossary.pod> for
more information.

=head2 Functions

=over 4

=cut

*/


#include "parrot/oplib/ops.h"
#include "pmc/pmc_sub.h"

/*

=back

=head2 Methods

=over 4

=cut

*/

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */


/*
 * A Continuation (and an ExceptionHandler) has in its context a pointer
 * to the register frame, which contains active objects.
 * Additionally ct->current_cont has the continuation of the caller.
 */
#line 71 "./src/pmc/continuation.c"
static  PMC  * Parrot_Continuation_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_Continuation_defined(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC *  Parrot_Continuation_get_attr_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *attr);
static  INTVAL  Parrot_Continuation_get_bool(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  * Parrot_Continuation_get_pointer(PARROT_INTERP, ARGMOD(PMC *_self));
static  STRING  * Parrot_Continuation_get_string(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Continuation_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Continuation_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *values);
static  opcode_t  * Parrot_Continuation_invoke(PARROT_INTERP, ARGMOD(PMC *_self), SHIM(void *next));
static  void  Parrot_Continuation_mark(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Continuation_set_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *src);
static  void  Parrot_Continuation_set_pointer(PARROT_INTERP, ARGMOD(PMC *_self), void *value);
static  void Parrot_Continuation_nci_rid(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Continuation_nci_caller(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Continuation_nci_continuation(PARROT_INTERP, ARGMOD(PMC *_self));
void    Parrot_Continuation_class_init(PARROT_INTERP, int, int);
void    Parrot_Continuation_ro_class_init(PARROT_INTERP, int, int);
static  PMC  *
Parrot_Continuation_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 188 "./src/pmc/continuation.pmc"

    /* Start to prepare for subclassable continuations */
    return Parrot_pmc_new_init(interp, _self->vtable->base_type, _self);
#line 96 "./src/pmc/continuation.c"
}
static  INTVAL 
Parrot_Continuation_defined(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 255 "./src/pmc/continuation.pmc"

    opcode_t          *address;

    GETATTR_Continuation_address(interp, _self, address);
    return address != NULL;
#line 107 "./src/pmc/continuation.c"
}
static  PMC * 
Parrot_Continuation_get_attr_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *attr)
{
#line 152 "./src/pmc/continuation.pmc"

    PMC * val = PMCNULL;
    INTVAL ival;
    /*if (STRING_equal(interp, attr, CONST_STRING(interp, "seg")))
        GETATTR_Continuation_seg(interp, _self, val);*/
    if (STRING_equal(interp, attr, CONST_STRING(interp, "to_ctx")))
        GETATTR_Continuation_to_ctx(interp, _self, val);
    else if (STRING_equal(interp, attr, CONST_STRING(interp, "to_call_object")))
        GETATTR_Continuation_to_call_object(interp, _self, val);
    else if (STRING_equal(interp, attr, CONST_STRING(interp, "from_ctx")))
        GETATTR_Continuation_from_ctx(interp, _self, val);
    else if (STRING_equal(interp, attr, CONST_STRING(interp, "runloop_id"))) {
        GETATTR_Continuation_runloop_id(interp, _self, ival);
        val = Parrot_pmc_box_integer(interp, ival);
    }
    else if (STRING_equal(interp, attr, CONST_STRING(interp, "invoked"))) {
        GETATTR_Continuation_invoked(interp, _self, ival);
        val = Parrot_pmc_box_integer(interp, ival);
    }
    else
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ATTRIB_NOT_FOUND,
            "%Ss: Attribute %Ss not found", VTABLE_name(interp, _self), attr);
    return val;
#line 136 "./src/pmc/continuation.c"
}
static  INTVAL 
Parrot_Continuation_get_bool(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 263 "./src/pmc/continuation.pmc"

    opcode_t          *address;

    GETATTR_Continuation_address(interp, _self, address);
    return address != NULL;
#line 147 "./src/pmc/continuation.c"
}
static  void  *
Parrot_Continuation_get_pointer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 235 "./src/pmc/continuation.pmc"

    opcode_t          *address;

    GETATTR_Continuation_address(interp, _self, address);
    return address;
#line 158 "./src/pmc/continuation.c"
}
static  STRING  *
Parrot_Continuation_get_string(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 316 "./src/pmc/continuation.pmc"

    PMC *to_ctx;

    GETATTR_Continuation_to_ctx(interp, _self, to_ctx);
    return Parrot_sub_Context_infostr(interp, to_ctx, 0);
#line 169 "./src/pmc/continuation.c"
}
static  void 
Parrot_Continuation_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 70 "./src/pmc/continuation.pmc"

    PMC * const to_ctx = CURRENT_CONTEXT(interp);

    SETATTR_Continuation_to_ctx(interp, _self, to_ctx);
    SETATTR_Continuation_to_call_object(interp, _self, Parrot_pcc_get_signature(interp, to_ctx));
    SETATTR_Continuation_from_ctx(interp, _self, CURRENT_CONTEXT(interp));
    SETATTR_Continuation_runloop_id(interp, _self, 0);
    SETATTR_Continuation_seg(interp, _self, interp->code);
    SETATTR_Continuation_address(interp, _self, NULL);

    PObj_custom_mark_SET(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 187 "./src/pmc/continuation.c"
}
static  void 
Parrot_Continuation_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *values)
{
#line 96 "./src/pmc/continuation.pmc"

    PMC               *to_ctx;
    opcode_t          *address;
    PackFile_ByteCode *seg;

    GETATTR_Continuation_to_ctx(interp, values, to_ctx);
    SETATTR_Continuation_to_ctx(interp, _self, to_ctx);
    SETATTR_Continuation_to_call_object(interp, _self, Parrot_pcc_get_signature(interp, to_ctx));

    SETATTR_Continuation_from_ctx(interp, _self, CURRENT_CONTEXT(interp));
    SETATTR_Continuation_runloop_id(interp, _self, 0);

    GETATTR_Continuation_seg(interp, values, seg);
    SETATTR_Continuation_seg(interp, _self, seg);

    GETATTR_Continuation_address(interp, values, address);
    SETATTR_Continuation_address(interp, _self, address);

    PObj_custom_mark_SET(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 213 "./src/pmc/continuation.c"
}
static  opcode_t  *
Parrot_Continuation_invoke(PARROT_INTERP, ARGMOD(PMC *_self), SHIM(void *next))
{
#line 282 "./src/pmc/continuation.pmc"
    PMC * const        from_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
    opcode_t          *pc;
    PackFile_ByteCode *seg;

    GETATTR_Continuation_seg(interp, _self, seg);
    GETATTR_Continuation_address(interp, _self, pc);
    SETATTR_Continuation_invoked(interp, _self, 1);

    Parrot_sub_continuation_check(interp, _self);
    Parrot_sub_continuation_rewind_environment(interp, _self);

    if (!PMC_IS_NULL(from_obj))
        Parrot_pcc_set_signature(interp, CURRENT_CONTEXT(interp), from_obj);

    /* switch segment */
    if (interp->code != seg)
        Parrot_switch_to_cs(interp, seg, 1);

    return pc;
#line 238 "./src/pmc/continuation.c"
}
static  void 
Parrot_Continuation_mark(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 128 "./src/pmc/continuation.pmc"

    Parrot_Continuation_attributes * const cont = PARROT_CONTINUATION(_self);

    /* If Continuation wasn't fully constructed yet */
    if (!cont) return;

    if (cont->to_ctx)         Parrot_gc_mark_PMC_alive(interp, cont->to_ctx);
    if (cont->to_call_object) Parrot_gc_mark_PMC_alive(interp, cont->to_call_object);
    if (cont->from_ctx)       Parrot_gc_mark_PMC_alive(interp, cont->from_ctx);

    if (cont->seg && ! Interp_flags_TEST(interp, PARROT_IS_THREAD))
        Parrot_gc_mark_PMC_alive(interp, cont->seg->base.pf->view);
#line 256 "./src/pmc/continuation.c"
}
static  void 
Parrot_Continuation_set_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *src)
{
#line 203 "./src/pmc/continuation.pmc"

    STRUCT_COPY(PMC_data_typed(_self, Parrot_Continuation_attributes *),
                PMC_data_typed(src,  Parrot_Continuation_attributes *));
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 266 "./src/pmc/continuation.c"
}
static  void 
Parrot_Continuation_set_pointer(PARROT_INTERP, ARGMOD(PMC *_self), void *value)
{
#line 219 "./src/pmc/continuation.pmc"

    SETATTR_Continuation_address(interp, _self, (opcode_t *)value);
    SETATTR_Continuation_runloop_id(interp, _self, interp->current_runloop_id);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 276 "./src/pmc/continuation.c"
}
static  void
Parrot_Continuation_nci_rid(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 334 "./src/pmc/continuation.pmc"

    INTVAL runloop_id;
    GETATTR_Continuation_runloop_id(interp, _self, runloop_id);
    #line 300 "./src/pmc/continuation.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)runloop_id);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 337 "./src/pmc/continuation.pmc"

#line 308 "./src/pmc/continuation.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Continuation_nci_caller(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 350 "./src/pmc/continuation.pmc"

    PMC *to_ctx, *caller;

    GETATTR_Continuation_to_ctx(interp, _self, to_ctx);

    caller = Parrot_pcc_get_sub(interp, to_ctx);

    if (!caller)
        caller = PMCNULL;
    else {
        Parrot_Sub_attributes *sub;
        PMC_get_sub(interp, caller, sub);
        if (!sub->seg)
            caller = PMCNULL;
    }

    #line 352 "./src/pmc/continuation.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)caller);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 366 "./src/pmc/continuation.pmc"


#line 361 "./src/pmc/continuation.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Continuation_nci_continuation(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 381 "./src/pmc/continuation.pmc"

    PMC *to_ctx, *cont;

    GETATTR_Continuation_to_ctx(interp, _self, to_ctx);

    cont = Parrot_pcc_get_continuation(interp, to_ctx);

    if (cont)
        #line 397 "./src/pmc/continuation.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)cont);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 389 "./src/pmc/continuation.pmc"


    #line 406 "./src/pmc/continuation.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)PMCNULL);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 391 "./src/pmc/continuation.pmc"

#line 414 "./src/pmc/continuation.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Continuation_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_Continuation_clone;
    vt->defined = Parrot_Continuation_defined;
    vt->get_attr_str = Parrot_Continuation_get_attr_str;
    vt->get_bool = Parrot_Continuation_get_bool;
    vt->get_pointer = Parrot_Continuation_get_pointer;
    vt->get_string = Parrot_Continuation_get_string;
    vt->init = Parrot_Continuation_init;
    vt->init_pmc = Parrot_Continuation_init_pmc;
    vt->invoke = Parrot_Continuation_invoke;
    vt->mark = Parrot_Continuation_mark;
    vt->set_pmc = Parrot_Continuation_set_pmc;
    vt->set_pointer = Parrot_Continuation_set_pointer;
    vt->attr_size = sizeof(Parrot_Continuation_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Continuation_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_Continuation_clone;
    vt->defined = Parrot_Continuation_defined;
    vt->get_attr_str = Parrot_Continuation_get_attr_str;
    vt->get_bool = Parrot_Continuation_get_bool;
    vt->get_pointer = Parrot_Continuation_get_pointer;
    vt->get_string = Parrot_Continuation_get_string;
    vt->invoke = Parrot_Continuation_invoke;
    vt->mark = Parrot_Continuation_mark;
    vt->attr_size = sizeof(Parrot_Continuation_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Continuation_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Continuation_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Continuation_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Continuation_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Continuation_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "Continuation"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Continuation_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Continuation")), PMCNULL);
    return isa;
}

void
Parrot_Continuation_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":seg :address Fto_ctx Fto_call_object Ffrom_ctx Irunloop_id Iinvoked ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Continuation_get_vtable(interp);
        vt->base_type      = enum_class_Continuation;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Continuation");
        vt->provides_str = CONST_STRING_GEN(interp, "invokable");
        vt->isa_hash     = Parrot_Continuation_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_Continuation_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_Continuation;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Continuation_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "rid");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Continuation_nci_rid),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "caller");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Continuation_nci_caller),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "continuation");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Continuation_nci_continuation),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_Continuation_class_init */

#line 392 "./src/pmc/continuation.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
