/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/env.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_env.h"
#include "pmc_default.h"
#include "env.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/env.pmc"
/*
Copyright (C) 2001-2014, Parrot Foundation.

=head1 NAME

src/pmc/env.pmc - Env PMC

=head1 DESCRIPTION

C<Env> is a singleton class which provides access to the system environment.

=head2 Methods

=over 4

=cut

*/

/* array of environment variables,
   speced in POSIX.1, but not in ISO-C
   MS C compilers know about environ, as it is declared in stdlib.h.
   OS X doesn't allow access to "environ" from within shared libraries.
*/
#ifndef WIN32
#  ifdef __APPLE_CC__
#    include <crt_externs.h>
#    define environ (*_NSGetEnviron())
#  else /* !__APPLE_CC__ */
extern char **environ;
#  endif /* __APPLE_CC__ */
#endif /* !WIN32 */

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */


static PMC *Env_PMC;
#line 62 "./src/pmc/env.c"
static  void  Parrot_Env_delete_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  INTVAL  Parrot_Env_elements(SHIM_INTERP, SHIM(PMC *_self));
static  INTVAL  Parrot_Env_exists_keyed(PARROT_INTERP, SHIM(PMC *_self), PMC *pmckey);
static  INTVAL  Parrot_Env_get_bool(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_Env_get_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_Env_get_iter(PARROT_INTERP, ARGMOD(PMC *_self));
static  FLOATVAL  Parrot_Env_get_number(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_Env_get_pmc_keyed(PARROT_INTERP, SHIM(PMC *_self), PMC *key);
static  void  * Parrot_Env_get_pointer(SHIM_INTERP, SHIM(PMC *_self));
static  STRING  * Parrot_Env_get_string_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  STRING  * Parrot_Env_get_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL pos);
static  STRING  * Parrot_Env_get_string_keyed_str(PARROT_INTERP, SHIM(PMC *_self), STRING *key);
static  void  Parrot_Env_set_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, PMC *value);
static  void  Parrot_Env_set_pointer(PARROT_INTERP, ARGMOD(PMC *_self), void *ptr);
static  void  Parrot_Env_set_string_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, STRING *value);
void    Parrot_Env_class_init(PARROT_INTERP, int, int);
static  void 
Parrot_Env_delete_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 300 "./src/pmc/env.pmc"

    STRING * const keyname = VTABLE_get_string(interp, key);
    /**/UNUSED(_self)

    if (!STRING_IS_EMPTY(keyname)) {
        const STRING * const val = Parrot_getenv(interp, keyname);

        if (!STRING_IS_NULL(val))
            Parrot_unsetenv(interp, keyname);
    }
#line 93 "./src/pmc/env.c"
}
static  INTVAL 
Parrot_Env_elements(SHIM_INTERP, SHIM(PMC *_self))
{
#line 98 "./src/pmc/env.pmc"

    INTVAL rv = 0;

    while (environ[rv] != NULL)
        ++rv;

    return rv;
#line 106 "./src/pmc/env.c"
}
static  INTVAL 
Parrot_Env_exists_keyed(PARROT_INTERP, SHIM(PMC *_self), PMC *pmckey)
{
#line 276 "./src/pmc/env.pmc"

    STRING * const keyname = VTABLE_get_string(interp, pmckey);

    if (!STRING_IS_EMPTY(keyname)) {
        const STRING * const val = Parrot_getenv(interp, keyname);

        if (!STRING_IS_NULL(val))
            return 1;
    }

    return 0;
#line 123 "./src/pmc/env.c"
}
static  INTVAL 
Parrot_Env_get_bool(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 118 "./src/pmc/env.pmc"

    return VTABLE_elements(interp, _self) ? 1 : 0;
#line 131 "./src/pmc/env.c"
}
static  INTVAL 
Parrot_Env_get_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 132 "./src/pmc/env.pmc"

    return VTABLE_elements(interp, _self);
#line 139 "./src/pmc/env.c"
}
static  PMC  *
Parrot_Env_get_iter(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 83 "./src/pmc/env.pmc"

    return Parrot_pmc_new_init(interp, enum_class_ArrayIterator, _self);
#line 147 "./src/pmc/env.c"
}
static  FLOATVAL 
Parrot_Env_get_number(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 145 "./src/pmc/env.pmc"

    return VTABLE_elements(interp, _self);
#line 155 "./src/pmc/env.c"
}
static  PMC  *
Parrot_Env_get_pmc_keyed(PARROT_INTERP, SHIM(PMC *_self), PMC *key)
{
#line 209 "./src/pmc/env.pmc"

    STRING * const keyname = VTABLE_get_string(interp, key);

    STRING *retval  = NULL;
    PMC    *return_pmc;

    if (!STRING_IS_EMPTY(keyname)) {
        retval = Parrot_getenv(interp, keyname);
    }

    if (STRING_IS_NULL(retval))
        retval = CONST_STRING(interp, "");

    return_pmc = Parrot_pmc_new(interp, enum_class_String);

    VTABLE_set_string_native(interp, return_pmc, retval);
    return return_pmc;
#line 178 "./src/pmc/env.c"
}
static  void  *
Parrot_Env_get_pointer(SHIM_INTERP, SHIM(PMC *_self))
{
#line 60 "./src/pmc/env.pmc"
    return Env_PMC;
#line 185 "./src/pmc/env.c"
}
static  STRING  *
Parrot_Env_get_string_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 172 "./src/pmc/env.pmc"

    return VTABLE_get_string_keyed_str(interp, _self, VTABLE_get_string(interp, key));
#line 193 "./src/pmc/env.c"
}
static  STRING  *
Parrot_Env_get_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL pos)
{
#line 188 "./src/pmc/env.pmc"

    if (pos < 0 || pos >= VTABLE_elements(interp, _self)) {
        return CONST_STRING(interp, "");
    }
    else {
        STRING * const envp  = Parrot_str_from_platform_cstring(interp, environ[pos]);
        const INTVAL   delim = STRING_index(interp, envp, CONST_STRING(interp, "="), 0);
        return STRING_substr(interp, envp, 0, delim);
    }
#line 208 "./src/pmc/env.c"
}
static  STRING  *
Parrot_Env_get_string_keyed_str(PARROT_INTERP, SHIM(PMC *_self), STRING *key)
{
#line 159 "./src/pmc/env.pmc"
    if (!STRING_IS_EMPTY(key)) {
        STRING * const val = Parrot_getenv(interp, key);

        if (!STRING_IS_NULL(val)) {
            return val;
        }
    }

    return CONST_STRING(interp, "");
#line 223 "./src/pmc/env.c"
}
static  void 
Parrot_Env_set_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, PMC *value)
{
#line 257 "./src/pmc/env.pmc"

    STRING * const keyname   = VTABLE_get_string(interp, key);
    STRING * const str_value = VTABLE_get_string(interp, value);
    /**/UNUSED(_self)

    if (keyname && str_value)
        Parrot_setenv(interp, keyname, str_value);
#line 236 "./src/pmc/env.c"
}
static  void 
Parrot_Env_set_pointer(PARROT_INTERP, ARGMOD(PMC *_self), void *ptr)
{
#line 66 "./src/pmc/env.pmc"

    /**/UNUSED(interp)
    /**/UNUSED(_self)
    Env_PMC = (PMC *)ptr;
#line 246 "./src/pmc/env.c"
}
static  void 
Parrot_Env_set_string_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, STRING *value)
{
#line 239 "./src/pmc/env.pmc"

    STRING * const keyname = VTABLE_get_string(interp, key);
    /**/UNUSED(_self)

    if (keyname && value)
        Parrot_setenv(interp, keyname, value);
#line 258 "./src/pmc/env.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Env_update_vtable(VTABLE *vt) {
    vt->delete_keyed = Parrot_Env_delete_keyed;
    vt->elements = Parrot_Env_elements;
    vt->exists_keyed = Parrot_Env_exists_keyed;
    vt->get_bool = Parrot_Env_get_bool;
    vt->get_integer = Parrot_Env_get_integer;
    vt->get_iter = Parrot_Env_get_iter;
    vt->get_number = Parrot_Env_get_number;
    vt->get_pmc_keyed = Parrot_Env_get_pmc_keyed;
    vt->get_pointer = Parrot_Env_get_pointer;
    vt->get_string_keyed = Parrot_Env_get_string_keyed;
    vt->get_string_keyed_int = Parrot_Env_get_string_keyed_int;
    vt->get_string_keyed_str = Parrot_Env_get_string_keyed_str;
    vt->set_pmc_keyed = Parrot_Env_set_pmc_keyed;
    vt->set_pointer = Parrot_Env_set_pointer;
    vt->set_string_keyed = Parrot_Env_set_string_keyed;

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Env_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->elements = Parrot_Env_elements;
    vt->exists_keyed = Parrot_Env_exists_keyed;
    vt->get_bool = Parrot_Env_get_bool;
    vt->get_integer = Parrot_Env_get_integer;
    vt->get_iter = Parrot_Env_get_iter;
    vt->get_number = Parrot_Env_get_number;
    vt->get_pmc_keyed = Parrot_Env_get_pmc_keyed;
    vt->get_pointer = Parrot_Env_get_pointer;
    vt->get_string_keyed = Parrot_Env_get_string_keyed;
    vt->get_string_keyed_int = Parrot_Env_get_string_keyed_int;
    vt->get_string_keyed_str = Parrot_Env_get_string_keyed_str;

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Env_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Env_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Env_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Env_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Env_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "Env"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Env_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Env")), PMCNULL);
    return isa;
}

static void thispmc_class_init(PARROT_INTERP, int entry)
{
    
        UNUSED(interp)
        UNUSED(entry)
        Env_PMC = NULL;

}
void
Parrot_Env_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Env_get_vtable(interp);
        vt->base_type      = enum_class_Env;
        vt->flags          = 0|VTABLE_PMC_IS_SINGLETON;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Env");
        vt->provides_str = CONST_STRING_GEN(interp, "hash");
        vt->isa_hash     = Parrot_Env_get_isa(interp, NULL);
    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Env_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);

        /* class_init */
        thispmc_class_init(interp, entry);


        {
        }
    } /* pass */
} /* Parrot_Env_class_init */

#line 310 "./src/pmc/env.pmc"


/*

=back

=head1 SEE ALSO

PDD -
L<http://docs.parrot.org/parrot/latest/html/docs/pdds/pdd17_pmc.pod.html#Hash_types>

Environment in Perl 6 - L<http://dev.perl.org/perl6/rfc/318.html>

Module for Perl 5 - L<http://search.cpan.org/~stas/Env-C-0.06/>

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
