/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/iterator.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_iterator.h"
#include "pmc_default.h"
#include "iterator.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/iterator.pmc"
/*
Copyright (C) 2001-2014, Parrot Foundation.

=head1 NAME

src/pmc/iterator.pmc - Iterator PMC

=head1 DESCRIPTION

These are the vtable functions for the Iterator base class. Iterators are
used in combination with other classes(mainly aggregates) to visit all entries
in that aggregate.

=head1 SYNOPSIS

=head2 default usage

    .local pmc iterator, array, entry
    iterator = iter array
  iter_loop:
    unless iterator, iter_end  # while (more values)
    entry = shift iterator     # get an entry
    ...
    goto iter_loop
  iter_end:

=head2 iterate from the end, for arrays

    .local pmc iterator, array, entry
    iterator = iter array
    iterator = .ITERATE_FROM_END
  iter_loop:
    unless iterator, iter_end  # while (more values)
    entry = pop iterator     # get an entry
    ...
    goto iter_loop
  iter_end:

=head2 iterate over a hash

    .local pmc iterator, hash, key, entry
    iterator = iter hash
  iter_loop:
    unless iterator, iter_end  # while (more values)
    key   = shift iterator     # get the key..
    entry = hash[key]
    ...
    goto iter_loop
  iter_end:

=head1 Methods

=over 4

=cut

*/

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */
#line 85 "./src/pmc/iterator.c"
static  INTVAL  Parrot_Iterator_defined(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_Iterator_defined_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  INTVAL  Parrot_Iterator_exists_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  INTVAL  Parrot_Iterator_get_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  PMC  * Parrot_Iterator_get_iter(SHIM_INTERP, ARGMOD(PMC *_self));
static  FLOATVAL  Parrot_Iterator_get_number_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  PMC  * Parrot_Iterator_get_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  STRING  * Parrot_Iterator_get_string_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  void  Parrot_Iterator_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Iterator_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *aggregate);
static  void  Parrot_Iterator_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), SHIM(INTVAL value));
static  void Parrot_Iterator_nci_next(PARROT_INTERP, ARGMOD(PMC *_self));
void    Parrot_Iterator_class_init(PARROT_INTERP, int, int);
void    Parrot_Iterator_ro_class_init(PARROT_INTERP, int, int);
static  INTVAL 
Parrot_Iterator_defined(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 175 "./src/pmc/iterator.pmc"

    return (INTVAL)(VTABLE_get_pmc(interp, _self) != PMCNULL);
#line 106 "./src/pmc/iterator.c"
}
static  INTVAL 
Parrot_Iterator_defined_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 187 "./src/pmc/iterator.pmc"

    return VTABLE_defined_keyed(interp, VTABLE_get_pmc(interp, _self), key);
#line 114 "./src/pmc/iterator.c"
}
static  INTVAL 
Parrot_Iterator_exists_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 161 "./src/pmc/iterator.pmc"

    return VTABLE_exists_keyed(interp, VTABLE_get_pmc(interp, _self), key);
#line 122 "./src/pmc/iterator.c"
}
static  INTVAL 
Parrot_Iterator_get_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 108 "./src/pmc/iterator.pmc"

    return VTABLE_get_integer_keyed(interp, VTABLE_get_pmc(interp, _self), key);
#line 130 "./src/pmc/iterator.c"
}
static  PMC  *
Parrot_Iterator_get_iter(SHIM_INTERP, ARGMOD(PMC *_self))
{
#line 192 "./src/pmc/iterator.pmc"
    return _self;
#line 137 "./src/pmc/iterator.c"
}
static  FLOATVAL 
Parrot_Iterator_get_number_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 120 "./src/pmc/iterator.pmc"

    return VTABLE_get_number_keyed(interp, VTABLE_get_pmc(interp, _self), key);
#line 145 "./src/pmc/iterator.c"
}
static  PMC  *
Parrot_Iterator_get_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 147 "./src/pmc/iterator.pmc"

    return VTABLE_get_pmc_keyed(interp, VTABLE_get_pmc(interp, _self), key);
#line 153 "./src/pmc/iterator.c"
}
static  STRING  *
Parrot_Iterator_get_string_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 133 "./src/pmc/iterator.pmc"

    return VTABLE_get_string_keyed(interp, VTABLE_get_pmc(interp, _self), key);
#line 161 "./src/pmc/iterator.c"
}
static  void 
Parrot_Iterator_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 75 "./src/pmc/iterator.pmc"

    /**/UNUSED(_self)
    Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_INVALID_OPERATION,
            "Iterator init without aggregate");
#line 171 "./src/pmc/iterator.c"
}
static  void 
Parrot_Iterator_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), SHIM(PMC *aggregate))
{
#line 92 "./src/pmc/iterator.pmc"

    /**/UNUSED(_self)
    Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_INVALID_OPERATION,
            "Direct creation of Iterator");
#line 181 "./src/pmc/iterator.c"
}
static  void 
Parrot_Iterator_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), SHIM(INTVAL value))
{
#line 213 "./src/pmc/iterator.pmc"
    /**/UNUSED(_self)
    PARROT_FAILURE("Iterator: implementation has to override this method");
    Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_UNIMPLEMENTED,
            "Iterator: unimplemented method");
#line 191 "./src/pmc/iterator.c"
}
static  void
Parrot_Iterator_nci_next(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 199 "./src/pmc/iterator.pmc"

    PMC * const next = VTABLE_shift_pmc(interp, _self);
    #line 214 "./src/pmc/iterator.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)next);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 201 "./src/pmc/iterator.pmc"

#line 222 "./src/pmc/iterator.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Iterator_update_vtable(VTABLE *vt) {
    vt->defined = Parrot_Iterator_defined;
    vt->defined_keyed = Parrot_Iterator_defined_keyed;
    vt->exists_keyed = Parrot_Iterator_exists_keyed;
    vt->get_integer_keyed = Parrot_Iterator_get_integer_keyed;
    vt->get_iter = Parrot_Iterator_get_iter;
    vt->get_number_keyed = Parrot_Iterator_get_number_keyed;
    vt->get_pmc_keyed = Parrot_Iterator_get_pmc_keyed;
    vt->get_string_keyed = Parrot_Iterator_get_string_keyed;
    vt->init = Parrot_Iterator_init;
    vt->init_pmc = Parrot_Iterator_init_pmc;
    vt->set_integer_native = Parrot_Iterator_set_integer_native;
    vt->attr_size = 0;

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Iterator_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->defined = Parrot_Iterator_defined;
    vt->defined_keyed = Parrot_Iterator_defined_keyed;
    vt->exists_keyed = Parrot_Iterator_exists_keyed;
    vt->get_integer_keyed = Parrot_Iterator_get_integer_keyed;
    vt->get_iter = Parrot_Iterator_get_iter;
    vt->get_number_keyed = Parrot_Iterator_get_number_keyed;
    vt->get_pmc_keyed = Parrot_Iterator_get_pmc_keyed;
    vt->get_string_keyed = Parrot_Iterator_get_string_keyed;
    vt->attr_size = 0;

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Iterator_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Iterator_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Iterator_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Iterator_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Iterator_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "Iterator"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Iterator_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Iterator")), PMCNULL);
    return isa;
}

void
Parrot_Iterator_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Iterator_get_vtable(interp);
        vt->base_type      = enum_class_Iterator;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Iterator");
        vt->provides_str = CONST_STRING_GEN(interp, "iterator");
        vt->isa_hash     = Parrot_Iterator_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_Iterator_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_Iterator;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Iterator_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "next");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Iterator_nci_next),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_Iterator_class_init */

#line 219 "./src/pmc/iterator.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
