/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/lexpad.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_lexpad.h"
#include "pmc_default.h"
#include "lexpad.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/lexpad.pmc"
/*
Copyright (C) 2007-2014, Parrot Foundation.

=head1 NAME

src/pmc/lexpad.pmc - LexPad PMC

=head1 DESCRIPTION

These are the vtable functions for the lexpad PMC.

LexPad provides a Hash interface for lexical fetch/store
needed:

    struct_val ... Context *ctx
    pmc_val    ... LexInfo

=head2 Functions

=over 4

=cut

*/


/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

PARROT_INLINE
PARROT_CAN_RETURN_NULL
static HashBucket * register_bucket(PARROT_INTERP,
    ARGMOD(PMC *info),
    ARGIN(STRING *name))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        FUNC_MODIFIES(*info);

static INTVAL register_number_for_get(PARROT_INTERP,
    ARGMOD(PMC *info),
    ARGIN(STRING *name),
    INTVAL reg_type)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        FUNC_MODIFIES(*info);

static INTVAL register_number_for_set(PARROT_INTERP,
    ARGMOD(PMC *info),
    ARGMOD(STRING *name),
    INTVAL reg_type)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        FUNC_MODIFIES(*info)
        FUNC_MODIFIES(*name);

PARROT_DOES_NOT_RETURN
static void throw_lexical_not_found(PARROT_INTERP, ARGIN(STRING *name))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

PARROT_DOES_NOT_RETURN
static void throw_wrong_register_type(PARROT_INTERP, ARGIN(STRING *name))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

#define ASSERT_ARGS_register_bucket __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(info) \
    , PARROT_ASSERT_ARG(name))
#define ASSERT_ARGS_register_number_for_get __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(info) \
    , PARROT_ASSERT_ARG(name))
#define ASSERT_ARGS_register_number_for_set __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(info) \
    , PARROT_ASSERT_ARG(name))
#define ASSERT_ARGS_throw_lexical_not_found __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(name))
#define ASSERT_ARGS_throw_wrong_register_type __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(name))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */


/*

=item C<static void throw_wrong_register_type(PARROT_INTERP, STRING *name)>

=item C<static void throw_lexical_not_found(PARROT_INTERP, STRING *name)>

Helper functions for common exceptions.

=cut

*/

PARROT_DOES_NOT_RETURN
static void
throw_wrong_register_type(PARROT_INTERP, ARGIN(STRING *name))
{
    ASSERT_ARGS(throw_wrong_register_type)
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LEX_NOT_FOUND,
            "Lexical '%Ss' is of wrong register type in lexical lookup", name);
}

PARROT_DOES_NOT_RETURN
static void
throw_lexical_not_found(PARROT_INTERP, ARGIN(STRING *name))
{
    ASSERT_ARGS(throw_lexical_not_found)
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LEX_NOT_FOUND,
            "Lexical '%Ss' not found", name);
}

/*

=item C<static HashBucket * register_bucket(PARROT_INTERP, PMC *info, STRING
*name)>

Helper for register_number_ functions.

=cut

*/

PARROT_INLINE
PARROT_CAN_RETURN_NULL
static HashBucket *
register_bucket(PARROT_INTERP, ARGMOD(PMC *info), ARGIN(STRING *name))
{
    ASSERT_ARGS(register_bucket)
    const Hash * const hash = (const Hash *)VTABLE_get_pointer(interp, info);
    return hash->entries ?
            Parrot_hash_get_bucket(interp, hash, name) :
            NULL;
}

/*

=item C<static INTVAL register_number_for_get(PARROT_INTERP, PMC *info, STRING
*name, INTVAL reg_type)>

Locates the register number for getting the specified name
and type of lexical.

=cut

*/

static INTVAL
register_number_for_get(PARROT_INTERP, ARGMOD(PMC *info), ARGIN(STRING *name),
        INTVAL reg_type)
{
    ASSERT_ARGS(register_number_for_get)

    const HashBucket * const b = register_bucket(interp, info, name);
    if (!b)
        return -1;
    if (((INTVAL)b->value & 3) != reg_type)
        throw_wrong_register_type(interp, name);

    return ((INTVAL)b->value) >> 2;
}

/*

=item C<static INTVAL register_number_for_set(PARROT_INTERP, PMC *info, STRING
*name, INTVAL reg_type)>

Locates the register number for setting the specified name
and type of lexical.

=cut

*/

static INTVAL
register_number_for_set(PARROT_INTERP, ARGMOD(PMC *info), ARGMOD(STRING *name),
        INTVAL reg_type)
{
    ASSERT_ARGS(register_number_for_set)

    const HashBucket * const b = register_bucket(interp, info, name);
    if (!b)
        throw_lexical_not_found(interp, name);
    if (((INTVAL)b->value & 3) != reg_type)
        throw_wrong_register_type(interp, name);

    return ((INTVAL)b->value) >> 2;
}
#line 221 "./src/pmc/lexpad.c"
static  INTVAL  Parrot_LexPad_elements(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_LexPad_exists_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *name);
static  INTVAL  Parrot_LexPad_exists_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name);
static  INTVAL  Parrot_LexPad_get_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *name);
static  INTVAL  Parrot_LexPad_get_integer_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name);
static  PMC  * Parrot_LexPad_get_iter(PARROT_INTERP, ARGMOD(PMC *_self));
static  FLOATVAL  Parrot_LexPad_get_number_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *name);
static  FLOATVAL  Parrot_LexPad_get_number_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name);
static  PMC  * Parrot_LexPad_get_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *name);
static  PMC  * Parrot_LexPad_get_pmc_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name);
static  STRING  * Parrot_LexPad_get_string_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *name);
static  STRING  * Parrot_LexPad_get_string_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name);
static  void  Parrot_LexPad_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_LexPad_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *lexinfo);
static  void  Parrot_LexPad_set_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *name, INTVAL value);
static  void  Parrot_LexPad_set_integer_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name, INTVAL value);
static  void  Parrot_LexPad_set_number_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *name, FLOATVAL value);
static  void  Parrot_LexPad_set_number_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name, FLOATVAL value);
static  void  Parrot_LexPad_set_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *name, PMC *value);
static  void  Parrot_LexPad_set_pmc_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name, PMC *value);
static  void  Parrot_LexPad_set_pointer(PARROT_INTERP, ARGMOD(PMC *_self), void *ctx);
static  void  Parrot_LexPad_set_string_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *name, STRING *value);
static  void  Parrot_LexPad_set_string_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name, STRING *value);
static  void Parrot_LexPad_nci_get_lexinfo(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_LexPad_nci_register_type(PARROT_INTERP, ARGMOD(PMC *_self));
void    Parrot_LexPad_class_init(PARROT_INTERP, int, int);
void    Parrot_LexPad_ro_class_init(PARROT_INTERP, int, int);
static  INTVAL 
Parrot_LexPad_elements(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 260 "./src/pmc/lexpad.pmc"

    PMC *info;
    GETATTR_LexPad_lexinfo(interp, _self, info);
    return Parrot_hash_size(interp,
            (Hash *)VTABLE_get_pointer(interp, info));
#line 258 "./src/pmc/lexpad.c"
}
static  INTVAL 
Parrot_LexPad_exists_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *name)
{
#line 278 "./src/pmc/lexpad.pmc"

    STRING * const s = VTABLE_get_string(interp, name);
    return VTABLE_exists_keyed_str(interp, _self, s);
#line 267 "./src/pmc/lexpad.c"
}
static  INTVAL 
Parrot_LexPad_exists_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name)
{
#line 267 "./src/pmc/lexpad.pmc"

    PMC  *info;
    const Hash *hash;
    GETATTR_LexPad_lexinfo(interp, _self, info);
    hash = (const Hash *)VTABLE_get_pointer(interp, info);

    return hash->entries
        ? (Parrot_hash_get_bucket(interp, hash, name) != 0)
        : 0;
#line 282 "./src/pmc/lexpad.c"
}
static  INTVAL 
Parrot_LexPad_get_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *name)
{
#line 344 "./src/pmc/lexpad.pmc"

    STRING * const s = VTABLE_get_string(interp, name);
    return VTABLE_get_integer_keyed_str(interp, _self, s);
#line 291 "./src/pmc/lexpad.c"
}
static  INTVAL 
Parrot_LexPad_get_integer_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name)
{
#line 297 "./src/pmc/lexpad.pmc"

    PMC    *info;
    PMC    *ctx;
    INTVAL  reg;

    GETATTR_LexPad_lexinfo(interp, _self, info);
    reg = register_number_for_get(interp, info, name, REGNO_INT);
    if (reg < 0)
        throw_lexical_not_found(interp, name);

    GETATTR_LexPad_ctx(interp, _self, ctx);
    return CTX_REG_INT(interp, ctx, reg);
#line 309 "./src/pmc/lexpad.c"
}
static  PMC  *
Parrot_LexPad_get_iter(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 442 "./src/pmc/lexpad.pmc"

    PMC    *info;
    PMC    *ctx;
    PMC    *info_iter;
    PMC    *value_map = Parrot_pmc_new(interp, enum_class_Hash);
    Hash   *hash;
    PMC    *iter;

    GETATTR_LexPad_lexinfo(interp, _self, info);
    GETATTR_LexPad_ctx(interp, _self, ctx);

    info_iter = VTABLE_get_iter(interp, info);
    hash = (Hash *)VTABLE_get_pointer(interp, info);

    while (VTABLE_get_bool(interp, info_iter)) {
        STRING * const name = VTABLE_shift_string(interp, info_iter);
        HashBucket * const b = Parrot_hash_get_bucket(interp, hash, name);
        INTVAL reg_type = (INTVAL)b->value & 3;
        INTVAL reg_idx = ((INTVAL)b->value) >> 2;
        PMC * value;
        switch (reg_type) {
            case REGNO_PMC:
                value = CTX_REG_PMC(interp, ctx, reg_idx);
                VTABLE_set_pmc_keyed_str(interp, value_map, name, value);
                break;
            case REGNO_INT: {
                const INTVAL ivalue = CTX_REG_INT(interp, ctx, reg_idx);
                value = Parrot_pmc_box_integer(interp, ivalue);
                VTABLE_set_pmc_keyed_str(interp, value_map, name, value);
                break;
            }
            case REGNO_STR: {
                STRING * const svalue = CTX_REG_STR(interp, ctx, reg_idx);
                value = Parrot_pmc_box_string(interp, svalue);
                VTABLE_set_pmc_keyed_str(interp, value_map, name, value);
                break;
            }
            case REGNO_NUM: {
                FLOATVAL fvalue = CTX_REG_NUM(interp, ctx, reg_idx);
                value = Parrot_pmc_box_number(interp, fvalue);
                VTABLE_set_pmc_keyed_str(interp, value_map, name, value);
                break;
            }
            default:
                throw_wrong_register_type(interp, name);
        }
    }
    return VTABLE_get_iter(interp, value_map);
#line 363 "./src/pmc/lexpad.c"
}
static  FLOATVAL 
Parrot_LexPad_get_number_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *name)
{
#line 349 "./src/pmc/lexpad.pmc"

    STRING * const s = VTABLE_get_string(interp, name);
    return VTABLE_get_number_keyed_str(interp, _self, s);
#line 372 "./src/pmc/lexpad.c"
}
static  FLOATVAL 
Parrot_LexPad_get_number_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name)
{
#line 311 "./src/pmc/lexpad.pmc"

    PMC    *info;
    PMC    *ctx;
    INTVAL  reg;

    GETATTR_LexPad_lexinfo(interp, _self, info);
    reg = register_number_for_get(interp, info, name, REGNO_NUM);
    if (reg < 0)
        throw_lexical_not_found(interp, name);

    GETATTR_LexPad_ctx(interp, _self, ctx);
    return CTX_REG_NUM(interp, ctx, reg);
#line 390 "./src/pmc/lexpad.c"
}
static  PMC  *
Parrot_LexPad_get_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *name)
{
#line 339 "./src/pmc/lexpad.pmc"

    STRING * const s = VTABLE_get_string(interp, name);
    return VTABLE_get_pmc_keyed_str(interp, _self, s);
#line 399 "./src/pmc/lexpad.c"
}
static  PMC  *
Parrot_LexPad_get_pmc_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name)
{
#line 283 "./src/pmc/lexpad.pmc"

    PMC    *info;
    PMC    *ctx;
    INTVAL  reg;

    GETATTR_LexPad_lexinfo(interp, _self, info);
    reg = register_number_for_get(interp, info, name, REGNO_PMC);
    if (reg < 0)
        return PMCNULL;

    GETATTR_LexPad_ctx(interp, _self, ctx);
    return CTX_REG_PMC(interp, ctx, reg);
#line 417 "./src/pmc/lexpad.c"
}
static  STRING  *
Parrot_LexPad_get_string_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *name)
{
#line 354 "./src/pmc/lexpad.pmc"

    STRING * const s = VTABLE_get_string(interp, name);
    return VTABLE_get_string_keyed_str(interp, _self, s);
#line 426 "./src/pmc/lexpad.c"
}
static  STRING  *
Parrot_LexPad_get_string_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name)
{
#line 325 "./src/pmc/lexpad.pmc"

    PMC    *info;
    PMC    *ctx;
    INTVAL  reg;

    GETATTR_LexPad_lexinfo(interp, _self, info);
    reg = register_number_for_get(interp, info, name, REGNO_STR);
    if (reg < 0)
        throw_lexical_not_found(interp, name);

    GETATTR_LexPad_ctx(interp, _self, ctx);
    return CTX_REG_STR(interp, ctx, reg);
#line 444 "./src/pmc/lexpad.c"
}
static  void 
Parrot_LexPad_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 204 "./src/pmc/lexpad.pmc"

    /**/UNUSED(_self)
    Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_INVALID_OPERATION,
        "Cannot create a LexPad PMC without an initializer");
#line 454 "./src/pmc/lexpad.c"
}
static  void 
Parrot_LexPad_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *lexinfo)
{
#line 252 "./src/pmc/lexpad.pmc"

    SETATTR_LexPad_lexinfo(interp, _self, lexinfo);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 463 "./src/pmc/lexpad.c"
}
static  void 
Parrot_LexPad_set_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *name, INTVAL value)
{
#line 412 "./src/pmc/lexpad.pmc"

    STRING * const s = VTABLE_get_string(interp, name);
    VTABLE_set_integer_keyed_str(interp, _self, s, value);
#line 472 "./src/pmc/lexpad.c"
}
static  void 
Parrot_LexPad_set_integer_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name, INTVAL value)
{
#line 371 "./src/pmc/lexpad.pmc"

    PMC    *info;
    PMC    *ctx;
    INTVAL  reg;

    GETATTR_LexPad_lexinfo(interp, _self, info);
    reg = register_number_for_set(interp, info, name, REGNO_INT);

    GETATTR_LexPad_ctx(interp, _self, ctx);
    CTX_REG_INT(interp, ctx, reg) = value;
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 489 "./src/pmc/lexpad.c"
}
static  void 
Parrot_LexPad_set_number_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *name, FLOATVAL value)
{
#line 417 "./src/pmc/lexpad.pmc"

    STRING * const s = VTABLE_get_string(interp, name);
    VTABLE_set_number_keyed_str(interp, _self, s, value);
#line 498 "./src/pmc/lexpad.c"
}
static  void 
Parrot_LexPad_set_number_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name, FLOATVAL value)
{
#line 383 "./src/pmc/lexpad.pmc"

    PMC    *info;
    PMC    *ctx;
    INTVAL  reg;

    GETATTR_LexPad_lexinfo(interp, _self, info);
    reg = register_number_for_set(interp, info, name, REGNO_NUM);

    GETATTR_LexPad_ctx(interp, _self, ctx);
    CTX_REG_NUM(interp, ctx, reg) = value;
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 515 "./src/pmc/lexpad.c"
}
static  void 
Parrot_LexPad_set_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *name, PMC *value)
{
#line 407 "./src/pmc/lexpad.pmc"

    STRING * const s = VTABLE_get_string(interp, name);
    VTABLE_set_pmc_keyed_str(interp, _self, s, value);
#line 524 "./src/pmc/lexpad.c"
}
static  void 
Parrot_LexPad_set_pmc_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name, PMC *value)
{
#line 359 "./src/pmc/lexpad.pmc"

    PMC    *info;
    PMC    *ctx;
    INTVAL  reg;

    GETATTR_LexPad_lexinfo(interp, _self, info);
    reg = register_number_for_set(interp, info, name, REGNO_PMC);

    GETATTR_LexPad_ctx(interp, _self, ctx);
    CTX_REG_PMC(interp, ctx, reg) = value;
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 541 "./src/pmc/lexpad.c"
}
static  void 
Parrot_LexPad_set_pointer(PARROT_INTERP, ARGMOD(PMC *_self), void *ctx)
{
#line 256 "./src/pmc/lexpad.pmc"

    SETATTR_LexPad_ctx(interp, _self, (PMC *)ctx);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 550 "./src/pmc/lexpad.c"
}
static  void 
Parrot_LexPad_set_string_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *name, STRING *value)
{
#line 422 "./src/pmc/lexpad.pmc"

    STRING * const s = VTABLE_get_string(interp, name);
    VTABLE_set_string_keyed_str(interp, _self, s, value);
#line 559 "./src/pmc/lexpad.c"
}
static  void 
Parrot_LexPad_set_string_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *name, STRING *value)
{
#line 395 "./src/pmc/lexpad.pmc"

    PMC    *info;
    PMC    *ctx;
    INTVAL  reg;

    GETATTR_LexPad_lexinfo(interp, _self, info);
    reg = register_number_for_set(interp, info, name, REGNO_STR);

    GETATTR_LexPad_ctx(interp, _self, ctx);
    CTX_REG_STR(interp, ctx, reg) = value;
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 576 "./src/pmc/lexpad.c"
}
static  void
Parrot_LexPad_nci_get_lexinfo(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 427 "./src/pmc/lexpad.pmc"

    PMC *lexinfo;
    GETATTR_LexPad_lexinfo(interp, _self, lexinfo);
    #line 600 "./src/pmc/lexpad.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)lexinfo);
        
        return;
     }
#line 430 "./src/pmc/lexpad.pmc"

#line 608 "./src/pmc/lexpad.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_LexPad_nci_register_type(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* name;
    
    const INTVAL arity = 2; /* "PiS" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    name = VTABLE_get_string_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 516 "./src/pmc/lexpad.pmc"

    PMC *info;
    HashBucket *b;
    INTVAL ret = -1;

    GETATTR_LexPad_lexinfo(interp, _self, info);
    b = register_bucket(interp, info, name);
    if (b)
        ret = (INTVAL) b->value & 3;
    #line 647 "./src/pmc/lexpad.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)ret);
        
        return;
     }
#line 525 "./src/pmc/lexpad.pmc"

#line 655 "./src/pmc/lexpad.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_LexPad_update_vtable(VTABLE *vt) {
    vt->elements = Parrot_LexPad_elements;
    vt->exists_keyed = Parrot_LexPad_exists_keyed;
    vt->exists_keyed_str = Parrot_LexPad_exists_keyed_str;
    vt->get_integer_keyed = Parrot_LexPad_get_integer_keyed;
    vt->get_integer_keyed_str = Parrot_LexPad_get_integer_keyed_str;
    vt->get_iter = Parrot_LexPad_get_iter;
    vt->get_number_keyed = Parrot_LexPad_get_number_keyed;
    vt->get_number_keyed_str = Parrot_LexPad_get_number_keyed_str;
    vt->get_pmc_keyed = Parrot_LexPad_get_pmc_keyed;
    vt->get_pmc_keyed_str = Parrot_LexPad_get_pmc_keyed_str;
    vt->get_string_keyed = Parrot_LexPad_get_string_keyed;
    vt->get_string_keyed_str = Parrot_LexPad_get_string_keyed_str;
    vt->init = Parrot_LexPad_init;
    vt->init_pmc = Parrot_LexPad_init_pmc;
    vt->set_integer_keyed = Parrot_LexPad_set_integer_keyed;
    vt->set_integer_keyed_str = Parrot_LexPad_set_integer_keyed_str;
    vt->set_number_keyed = Parrot_LexPad_set_number_keyed;
    vt->set_number_keyed_str = Parrot_LexPad_set_number_keyed_str;
    vt->set_pmc_keyed = Parrot_LexPad_set_pmc_keyed;
    vt->set_pmc_keyed_str = Parrot_LexPad_set_pmc_keyed_str;
    vt->set_pointer = Parrot_LexPad_set_pointer;
    vt->set_string_keyed = Parrot_LexPad_set_string_keyed;
    vt->set_string_keyed_str = Parrot_LexPad_set_string_keyed_str;
    vt->attr_size = sizeof(Parrot_LexPad_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_LexPad_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->elements = Parrot_LexPad_elements;
    vt->exists_keyed = Parrot_LexPad_exists_keyed;
    vt->exists_keyed_str = Parrot_LexPad_exists_keyed_str;
    vt->get_integer_keyed = Parrot_LexPad_get_integer_keyed;
    vt->get_integer_keyed_str = Parrot_LexPad_get_integer_keyed_str;
    vt->get_iter = Parrot_LexPad_get_iter;
    vt->get_number_keyed = Parrot_LexPad_get_number_keyed;
    vt->get_number_keyed_str = Parrot_LexPad_get_number_keyed_str;
    vt->get_pmc_keyed = Parrot_LexPad_get_pmc_keyed;
    vt->get_pmc_keyed_str = Parrot_LexPad_get_pmc_keyed_str;
    vt->get_string_keyed = Parrot_LexPad_get_string_keyed;
    vt->get_string_keyed_str = Parrot_LexPad_get_string_keyed_str;
    vt->attr_size = sizeof(Parrot_LexPad_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_LexPad_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_LexPad_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_LexPad_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_LexPad_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_LexPad_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "LexPad"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_LexPad_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "LexPad")), PMCNULL);
    return isa;
}

void
Parrot_LexPad_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Flexinfo Fctx ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_LexPad_get_vtable(interp);
        vt->base_type      = enum_class_LexPad;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "LexPad");
        vt->provides_str = CONST_STRING_GEN(interp, "hash");
        vt->isa_hash     = Parrot_LexPad_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_LexPad_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_LexPad;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_LexPad_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "get_lexinfo");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_LexPad_nci_get_lexinfo),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "register_type");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_LexPad_nci_register_type),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_LexPad_class_init */

#line 527 "./src/pmc/lexpad.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd20_lexical_vars.pod>, F<src/pmc/lexinfo.pmc>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
