/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/mappedbytearray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_mappedbytearray.h"
#include "pmc_default.h"
#include "mappedbytearray.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/mappedbytearray.pmc"
/*
Copyright (C) 2010-2014, Parrot Foundation.

=head1 NAME

src/pmc/mappedbytearray.pmc - MappedByteArray PMC

=head1 DESCRIPTION

A memory mapped file or shared memory segment accessible as array of bytes.

Bare minimal functionality available, currently only for posix platforms
with <sys/mman.h> available, or on mingw32.

=cut

*/

#include "parrot/parrot.h"
#include "../src/io/io_private.h"

#define CAN_READ  1
#define CAN_WRITE 2

#ifdef PARROT_HAS_HEADER_SYSMMAN
#  include <sys/mman.h>
#  define ENABLED
#else
#  ifdef __MINGW32__
#    define ENABLED
#    define MAPW32
#    include <Windows.h>
#  endif
#endif

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

PARROT_CANNOT_RETURN_NULL
static STRING * build_string(PARROT_INTERP,
    ARGIN_NULLOK(const unsigned char *content),
    INTVAL size,
    ARGIN(const STR_VTABLE *encoding))
        __attribute__nonnull__(1)
        __attribute__nonnull__(4);

PARROT_CANNOT_RETURN_NULL
static STRING * get_encoded_chars(PARROT_INTERP,
    ARGIN(PMC *self),
    INTVAL pos,
    INTVAL length,
    ARGIN(const STR_VTABLE *encoding))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(5);

PARROT_CAN_RETURN_NULL
static void * mapfromfilehandle(
    PIOHANDLE handle,
    unsigned long size,
    int flag);

PARROT_CAN_RETURN_NULL
static void * mapfromfilename(PARROT_INTERP,
    ARGIN(STRING *name),
    ARGMOD(unsigned long *size),
    int flag)
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        FUNC_MODIFIES(*size);

PARROT_DOES_NOT_RETURN
static void unavailable(PARROT_INTERP, ARGIN(const char *msg))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

#define ASSERT_ARGS_build_string __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(encoding))
#define ASSERT_ARGS_get_encoded_chars __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(encoding))
#define ASSERT_ARGS_mapfromfilehandle __attribute__unused__ int _ASSERT_ARGS_CHECK = (0)
#define ASSERT_ARGS_mapfromfilename __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(name) \
    , PARROT_ASSERT_ARG(size))
#define ASSERT_ARGS_unavailable __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(msg))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */
#line 119 "./src/pmc/mappedbytearray.c"
static  void  Parrot_MappedByteArray_destroy(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_MappedByteArray_elements(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_MappedByteArray_get_bool(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_MappedByteArray_get_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL pos);
static  void  Parrot_MappedByteArray_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_MappedByteArray_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *init);
static  void  Parrot_MappedByteArray_set_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL pos, INTVAL value);
static  void Parrot_MappedByteArray_nci_supported(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_MappedByteArray_nci_open(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_MappedByteArray_nci_close(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_MappedByteArray_nci_get_string(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_MappedByteArray_nci_get_chars(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_MappedByteArray_nci_get_utf8(PARROT_INTERP, ARGMOD(PMC *_self));
void    Parrot_MappedByteArray_class_init(PARROT_INTERP, int, int);
void    Parrot_MappedByteArray_ro_class_init(PARROT_INTERP, int, int);
static  void 
Parrot_MappedByteArray_destroy(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 155 "./src/pmc/mappedbytearray.pmc"

    #ifdef ENABLED
    unsigned char *buffer;
    UINTVAL size;
    GETATTR_MappedByteArray_size(interp, _self, size);
    GETATTR_MappedByteArray_buffer(interp, _self, buffer);
    if (size > 0) {
    #  ifdef MAPW32
        UnmapViewOfFile(buffer);
    #  else
        munmap(buffer, size);
    #  endif
    }
    #endif
#line 153 "./src/pmc/mappedbytearray.c"
}
static  INTVAL 
Parrot_MappedByteArray_elements(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 202 "./src/pmc/mappedbytearray.pmc"

    #ifdef ENABLED
    UINTVAL size;
    GETATTR_MappedByteArray_size(interp, _self, size);
    return size;
    #else
    return 0;
    #endif
#line 167 "./src/pmc/mappedbytearray.c"
}
static  INTVAL 
Parrot_MappedByteArray_get_bool(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 181 "./src/pmc/mappedbytearray.pmc"

    #ifdef ENABLED
    unsigned char *buffer;
    GETATTR_MappedByteArray_buffer(interp, _self, buffer);
    return buffer != NULL;
    #else
    return 0;
    #endif
#line 181 "./src/pmc/mappedbytearray.c"
}
static  INTVAL 
Parrot_MappedByteArray_get_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL pos)
{
#line 227 "./src/pmc/mappedbytearray.pmc"

    INTVAL size;
    unsigned char *buffer;
    GETATTR_MappedByteArray_size(interp, _self, size);
    if (size <= 0)
        Parrot_ex_throw_from_c_noargs(interp,
                EXCEPTION_INVALID_OPERATION, "not mapped");
    if (pos < 0 || pos >= size)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "index out of bounds");
    GETATTR_MappedByteArray_buffer(interp, _self, buffer);
    return buffer[pos];
#line 199 "./src/pmc/mappedbytearray.c"
}
static  void 
Parrot_MappedByteArray_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 125 "./src/pmc/mappedbytearray.pmc"

    #ifdef ENABLED
    PObj_custom_destroy_SET(_self);
    #endif
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 210 "./src/pmc/mappedbytearray.c"
}
static  void 
Parrot_MappedByteArray_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *init)
{
#line 131 "./src/pmc/mappedbytearray.pmc"

    #ifdef ENABLED
    void *mapping = NULL;
    PObj_custom_destroy_SET(_self);
    if (VTABLE_isa(interp, init, CONST_STRING(interp, "String"))) {
        unsigned long length = 0;
        STRING * const name = VTABLE_get_string(interp, init);
        mapping = mapfromfilename(interp, name, &length, CAN_READ);
        if (mapping == 0 || mapping == (void *)-1)
            Parrot_ex_throw_from_c_args(interp, NULL,
                    EXCEPTION_INVALID_OPERATION,
                    "mmap failed: %s", strerror(errno));
        PObj_custom_destroy_SET(_self);
        SETATTR_MappedByteArray_size(interp, _self, length);
        SETATTR_MappedByteArray_buffer(interp, _self, (unsigned char*)mapping);
    }
    else {
        unavailable(interp, "*feature unknown or not implemented yet*");
    }
    #else
    unavailable(interp, "MappedByteArray");
    #endif
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 239 "./src/pmc/mappedbytearray.c"
}
static  void 
Parrot_MappedByteArray_set_integer_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL pos, INTVAL value)
{
#line 241 "./src/pmc/mappedbytearray.pmc"

    INTVAL size;
    unsigned char *buffer;
    GETATTR_MappedByteArray_size(interp, _self, size);
    if (size <= 0)
        Parrot_ex_throw_from_c_noargs(interp,
                EXCEPTION_INVALID_OPERATION, "not mapped");
    if (pos < 0 || pos >= size)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "index out of bounds");
    GETATTR_MappedByteArray_buffer(interp, _self, buffer);
    buffer[pos] = value;
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 258 "./src/pmc/mappedbytearray.c"
}
static  void
Parrot_MappedByteArray_nci_supported(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 272 "./src/pmc/mappedbytearray.pmc"

    #ifdef ENABLED
    #line 281 "./src/pmc/mappedbytearray.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)1);
        
        return;
     }
#line 274 "./src/pmc/mappedbytearray.pmc"

    #else
    #line 290 "./src/pmc/mappedbytearray.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)0);
        
        return;
     }
#line 276 "./src/pmc/mappedbytearray.pmc"

    #endif
#line 299 "./src/pmc/mappedbytearray.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_MappedByteArray_nci_open(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    STRING* filename;
    STRING* mode;
    
    const INTVAL arity = 2; /* "PiSSo" */
    const INTVAL arity_opt  = 1;
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count < arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too few arguments: %d passed, %d expected",
                                    param_count, arity);
    if (param_count > arity + arity_opt)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "too many arguments: %d passed, %d expected",
                                    param_count, arity + arity_opt);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    filename = VTABLE_get_string_keyed_int(interp, _call_object, 1);
    if (param_count > 2) {
        mode = VTABLE_get_string_keyed_int(interp, _call_object, 2);
    }
    else {
        mode = STRINGNULL;
    }

    { /* BEGIN PMETHOD BODY */
#line 291 "./src/pmc/mappedbytearray.pmc"

    #ifdef ENABLED
    unsigned long length = 0;
    int flag = 0;
    void *mapping;
    if (STRING_IS_NULL(mode))
        flag = CAN_READ;
    else {
        const INTVAL len = Parrot_str_length(interp, mode);
        INTVAL i;
        for (i = 0; i < len; ++i) {
            switch (STRING_ord(interp, mode, i)) {
              case 'r':
                flag |= CAN_READ;
                break;
              case 'w':
                flag |= CAN_WRITE;
                break;
              default:
                Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_INVALID_OPERATION,
                        "invalid open mapped mode");
            }
        }
    }
    mapping = mapfromfilename(interp, filename, &length, flag);
    if (mapping == 0 || mapping == (void *)-1)
        Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "mmap failed: %s", strerror(errno));
    SETATTR_MappedByteArray_size(interp, _self, length);
    SETATTR_MappedByteArray_buffer(interp, _self, (unsigned char*)mapping);
    #endif
    #line 374 "./src/pmc/mappedbytearray.c"
    {
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
    }
#line 323 "./src/pmc/mappedbytearray.pmc"

#line 381 "./src/pmc/mappedbytearray.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_MappedByteArray_nci_close(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 337 "./src/pmc/mappedbytearray.pmc"

    INTVAL result = 1;
    #ifdef ENABLED
    unsigned char *buffer;
    GETATTR_MappedByteArray_buffer(interp, _self, buffer);
    if (buffer) {
        INTVAL size;
        GETATTR_MappedByteArray_size(interp, _self, size);
    #  ifdef MAPW32
        result = ! UnmapViewOfFile(buffer);
    #  else
        result = munmap(buffer, size);
    #  endif
        if (result == 0) {
            buffer = NULL;
            SETATTR_MappedByteArray_buffer(interp, _self, buffer);
            SETATTR_MappedByteArray_size(interp, _self, 0);
        }
    }
    #endif
    #line 429 "./src/pmc/mappedbytearray.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)result);
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
     }
#line 357 "./src/pmc/mappedbytearray.pmc"

#line 437 "./src/pmc/mappedbytearray.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_MappedByteArray_nci_get_string(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    INTVAL pos;
    INTVAL bytelength;
    STRING* encodingname;
    
    const INTVAL arity = 4; /* "PiIIS" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    pos = VTABLE_get_integer_keyed_int(interp, _call_object, 1);
    bytelength = VTABLE_get_integer_keyed_int(interp, _call_object, 2);
    encodingname = VTABLE_get_string_keyed_int(interp, _call_object, 3);

    { /* BEGIN PMETHOD BODY */
#line 370 "./src/pmc/mappedbytearray.pmc"

    #ifdef ENABLED
    STRING *result;
    unsigned char *buffer;
    INTVAL size;
    const STR_VTABLE * const encoding = Parrot_find_encoding_by_string(interp, encodingname);
    GETATTR_MappedByteArray_buffer(interp, _self, buffer);
    GETATTR_MappedByteArray_size(interp, _self, size);
    if (pos < 0 || bytelength < 0 || size < 0 || pos + bytelength > size)
        Parrot_ex_throw_from_c_noargs(interp,
                EXCEPTION_OUT_OF_BOUNDS, "index out of bounds");
    result = build_string(interp, buffer + pos, bytelength, encoding);
    #line 483 "./src/pmc/mappedbytearray.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)result);
        
        return;
     }
#line 382 "./src/pmc/mappedbytearray.pmc"

    #endif
#line 492 "./src/pmc/mappedbytearray.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_MappedByteArray_nci_get_chars(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    INTVAL pos;
    INTVAL length;
    STRING* encodingname;
    
    const INTVAL arity = 4; /* "PiIIS" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    pos = VTABLE_get_integer_keyed_int(interp, _call_object, 1);
    length = VTABLE_get_integer_keyed_int(interp, _call_object, 2);
    encodingname = VTABLE_get_string_keyed_int(interp, _call_object, 3);

    { /* BEGIN PMETHOD BODY */
#line 397 "./src/pmc/mappedbytearray.pmc"

    #ifdef ENABLED
    STRING * const result = get_encoded_chars(interp, _self, pos, length,
                Parrot_find_encoding_by_string(interp, encodingname));
    #line 530 "./src/pmc/mappedbytearray.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)result);
        
        return;
     }
#line 401 "./src/pmc/mappedbytearray.pmc"

    #endif
#line 539 "./src/pmc/mappedbytearray.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_MappedByteArray_nci_get_utf8(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    INTVAL pos;
    INTVAL length;
    
    const INTVAL arity = 3; /* "PiII" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    pos = VTABLE_get_integer_keyed_int(interp, _call_object, 1);
    length = VTABLE_get_integer_keyed_int(interp, _call_object, 2);

    { /* BEGIN PMETHOD BODY */
#line 416 "./src/pmc/mappedbytearray.pmc"

    #ifdef ENABLED
    STRING * const result = get_encoded_chars(interp, _self, pos, length,
                Parrot_utf8_encoding_ptr);
    #line 575 "./src/pmc/mappedbytearray.c"
     {
        VTABLE_set_string_keyed_int(interp, _call_object, 0, (STRING*)result);
        
        return;
     }
#line 420 "./src/pmc/mappedbytearray.pmc"

    #endif
#line 584 "./src/pmc/mappedbytearray.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_MappedByteArray_update_vtable(VTABLE *vt) {
    vt->destroy = Parrot_MappedByteArray_destroy;
    vt->elements = Parrot_MappedByteArray_elements;
    vt->get_bool = Parrot_MappedByteArray_get_bool;
    vt->get_integer_keyed_int = Parrot_MappedByteArray_get_integer_keyed_int;
    vt->init = Parrot_MappedByteArray_init;
    vt->init_pmc = Parrot_MappedByteArray_init_pmc;
    vt->set_integer_keyed_int = Parrot_MappedByteArray_set_integer_keyed_int;
    vt->attr_size = sizeof(Parrot_MappedByteArray_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_MappedByteArray_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->destroy = Parrot_MappedByteArray_destroy;
    vt->elements = Parrot_MappedByteArray_elements;
    vt->get_bool = Parrot_MappedByteArray_get_bool;
    vt->get_integer_keyed_int = Parrot_MappedByteArray_get_integer_keyed_int;
    vt->attr_size = sizeof(Parrot_MappedByteArray_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_MappedByteArray_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_MappedByteArray_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_MappedByteArray_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_MappedByteArray_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_MappedByteArray_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "MappedByteArray"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_MappedByteArray_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "MappedByteArray")), PMCNULL);
    return isa;
}

void
Parrot_MappedByteArray_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":buffer :size ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_MappedByteArray_get_vtable(interp);
        vt->base_type      = enum_class_MappedByteArray;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "MappedByteArray");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_MappedByteArray_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_MappedByteArray_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_MappedByteArray;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_MappedByteArray_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "supported");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_MappedByteArray_nci_supported),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "open");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_MappedByteArray_nci_open),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "close");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_MappedByteArray_nci_close),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "get_string");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_MappedByteArray_nci_get_string),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "get_chars");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_MappedByteArray_nci_get_chars),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "get_utf8");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_MappedByteArray_nci_get_utf8),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_MappedByteArray_class_init */

#line 423 "./src/pmc/mappedbytearray.pmc"
 /* pmclass end */

/*

=back

=head2 Helper functions

=over 4

=item C<static void unavailable(PARROT_INTERP, const char *msg)>

Throws appropriately for functionality not available in the current platform.

=item C<static void * mapfromfilehandle(PIOHANDLE handle, unsigned long size,
int flag)>

Maps a file by its OS handle.

=item C<static void * mapfromfilename(PARROT_INTERP, STRING *name, unsigned long
*size, int flag)>

Maps a file by its filename, throw if the file can't be opened.

=cut

*/

PARROT_DOES_NOT_RETURN
static void
unavailable(PARROT_INTERP, ARGIN(const char *msg))
{
    ASSERT_ARGS(unavailable)

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
            "%s not implemented in this platform", msg);
}

PARROT_CAN_RETURN_NULL
static void *
mapfromfilehandle(PIOHANDLE handle, unsigned long size, int flag)
{
    ASSERT_ARGS(mapfromfilehandle)

    void *mapping = (void *)-1;
    #ifdef ENABLED
    #  ifdef MAPW32
    HANDLE hmapping;
    DWORD prot, access;
    if (flag & CAN_WRITE) {
        prot = PAGE_READWRITE;
        access = FILE_MAP_WRITE;
    }
    else {
        prot = PAGE_READONLY;
        access = FILE_MAP_READ;
    }
    hmapping = CreateFileMapping(handle, NULL, prot, 0, size, NULL);
    if (hmapping != NULL) {
        mapping = MapViewOfFile(hmapping, access, 0, 0, size);
        CloseHandle(hmapping);
    }
    #  else
    int prot = 0;
    if (flag & CAN_READ) prot |= PROT_READ;
    if (flag & CAN_WRITE) prot |= PROT_WRITE;
    mapping = mmap(0, size, prot, MAP_SHARED, handle, 0);
    #  endif
    #endif
    return mapping;
}

PARROT_CAN_RETURN_NULL
static void *
mapfromfilename(PARROT_INTERP, ARGIN(STRING *name), ARGMOD(unsigned long *size), int flag)
{
    ASSERT_ARGS(mapfromfilename)

    void *mapping = (void *)-1;
    #ifdef ENABLED
    PIOHANDLE handle;
    #  ifdef MAPW32
    DWORD openmode = 0;
    switch (flag & (CAN_READ | CAN_WRITE)) {
      case CAN_READ:
        openmode = GENERIC_READ;
        break;
      case CAN_READ | CAN_WRITE:
      case CAN_WRITE:
        openmode = GENERIC_READ | GENERIC_WRITE;
        break;
      default:
        /* Should never happen, invalid modes must be caught before
         * calling this function.
         */
        Parrot_ex_throw_from_c_noargs(interp,
            EXCEPTION_INTERNAL_NOT_IMPLEMENTED, "invalid mmap mode");
    }
    {
        char * const name_str = Parrot_str_to_cstring(interp, name);
        handle = CreateFile(name_str, openmode, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL,
            OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
        Parrot_str_free_cstring(name_str);
    }
    #  else
    int openmode = 0;
    switch (flag & (CAN_READ | CAN_WRITE)) {
      case CAN_READ:
        openmode = O_RDONLY;
        break;
      case CAN_READ | CAN_WRITE:
      case CAN_WRITE:
        openmode = O_RDWR;
        break;
      default:
        /* Should never happen, invalid modes must be caught before
         * calling this function.
         */
        Parrot_ex_throw_from_c_noargs(interp,
            EXCEPTION_INTERNAL_NOT_IMPLEMENTED, "invalid mmap mode");
    }
    {
        char * const name_str = Parrot_str_to_cstring(interp, name);
        handle = open(name_str, openmode);
        Parrot_str_free_cstring(name_str);
    }
    #  endif
    if (handle == PIO_INVALID_HANDLE)
        Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION, "cannot open file '%Ss'", name);
    if (*size == 0) {
    #  ifdef MAPW32
        *size = (unsigned long)GetFileSize(handle, NULL);
    #  else
        *size = lseek(handle, 0, SEEK_END);
    #  endif
    }
    mapping = mapfromfilehandle(handle, *size, flag);

    #endif

    return mapping;
}

/*

=item C<static STRING * build_string(PARROT_INTERP, const unsigned char
*content, INTVAL size, const STR_VTABLE *encoding)>

Build a string from the buffer content with the encoding specified.

=cut

*/

PARROT_CANNOT_RETURN_NULL
static STRING *
build_string(PARROT_INTERP, ARGIN_NULLOK(const unsigned char *content),
        INTVAL size,
        ARGIN(const STR_VTABLE *encoding))
{
    ASSERT_ARGS(build_string)
    if (encoding == NULL)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_INVALID_ENCODING,
                "Invalid encoding");
    else
        return Parrot_str_new_init(interp,
                (const char *)content, size, encoding, 0);
}

/*

=item C<static STRING * get_encoded_chars(PARROT_INTERP, PMC *self, INTVAL pos,
INTVAL length, const STR_VTABLE *encoding)>

Return the characters starting at pos in the specified encoding.

=cut

*/

PARROT_CANNOT_RETURN_NULL
static STRING *
get_encoded_chars(PARROT_INTERP, ARGIN(PMC *self), INTVAL pos, INTVAL length,
        ARGIN(const STR_VTABLE *encoding))
{
    ASSERT_ARGS(get_encoded_chars)
    unsigned char        *buffer;
    INTVAL                size;

    GETATTR_MappedByteArray_buffer(interp, self, buffer);
    GETATTR_MappedByteArray_size(interp, self, size);

    if (pos < 0 || pos > size)
        Parrot_ex_throw_from_c_noargs(interp,
                EXCEPTION_OUT_OF_BOUNDS, "index out of bounds");

    return Parrot_str_extract_chars(interp, (char *)buffer + pos, size - pos,
                length, encoding);
}

/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
