/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/packfileannotations.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_packfileannotations.h"
#include "pmc_packfilesegment.h"
#include "pmc_default.h"
#include "packfileannotations.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/packfileannotations.pmc"
/*
Copyright (C) 2001-2014, Parrot Foundation.

=head1 NAME

src/pmc/packfileannotations.pmc - PackfileAnnotations PMC

=head1 DESCRIPTION

This class implements a PackfileAnnotations object, a segment of the .pbc data
file used for listing annotations.  It is a container for PackfileAnnotation
objects.

See packfile.pmc for the toplevel Packfile interface, see packfilesegment.pmc
for the list of common methods every packfile segment pmc must implement; see
PDD13 for the design spec.

To works properly PackfileAnnotations has to be added to PackfileDirectory with
PackfileConstantTable. Otherwise PackfileAnnotationKey can't be created.

=head2 Methods

=over 4

=cut

*/

#include "pmc/pmc_packfileannotation.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* HEADERIZER END: static */
#line 58 "./src/pmc/packfileannotations.c"
static  INTVAL  Parrot_PackfileAnnotations_elements(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_PackfileAnnotations_get_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL index);
static  void  * Parrot_PackfileAnnotations_get_pointer(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_PackfileAnnotations_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_PackfileAnnotations_mark(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_PackfileAnnotations_set_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL index, PMC *annotation);
static  void  Parrot_PackfileAnnotations_set_pointer(PARROT_INTERP, ARGMOD(PMC *_self), void *pointer);
static  void Parrot_PackfileAnnotations_nci_set_directory(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileAnnotations_nci_type(PARROT_INTERP, ARGMOD(PMC *_self));
void    Parrot_PackfileAnnotations_class_init(PARROT_INTERP, int, int);
void    Parrot_PackfileAnnotations_ro_class_init(PARROT_INTERP, int, int);
static  INTVAL 
Parrot_PackfileAnnotations_elements(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 95 "./src/pmc/packfileannotations.pmc"

    return VTABLE_elements(interp,
            PARROT_PACKFILEANNOTATIONS(_self)->annotations);
#line 77 "./src/pmc/packfileannotations.c"
}
static  PMC  *
Parrot_PackfileAnnotations_get_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL index)
{
#line 110 "./src/pmc/packfileannotations.pmc"

    return VTABLE_get_pmc_keyed_int(interp,
            PARROT_PACKFILEANNOTATIONS(_self)->annotations, index);
#line 86 "./src/pmc/packfileannotations.c"
}
static  void  *
Parrot_PackfileAnnotations_get_pointer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 268 "./src/pmc/packfileannotations.pmc"

    Parrot_PackfileAnnotations_attributes * const attrs =
            PARROT_PACKFILEANNOTATIONS(_self);
    PackFile_Annotations * const res =
        mem_gc_allocate_zeroed_typed(interp, PackFile_Annotations);
    INTVAL                i, num;
    PMC                  *keys;             /* Temporary representation of Keys */
    INTVAL                name_id;
    INTVAL                value_id;

    res->base.type = PF_ANNOTATIONS_SEG;

    /*
        Create keys. Hash will be created in next structure:
        keys => {
            name => [
                $int_key_id,
                $str_key_id,
                $num_key_id,
            ]
        }

        Each key has name from ConstantTable. We store them in names Array.
        names => [
            $constant_id_1,
            $contsant_id_2,
            ...
        ]
    */
    keys        = Parrot_pmc_new(interp, enum_class_Hash);

    /* Iterate over stored annotations and create Key if required. */
    num = VTABLE_elements(interp, attrs->annotations);
    for (i = 0; i < num; ++i) {
        PMC  * const entity = VTABLE_get_pmc_keyed_int(interp, attrs->annotations, i);
        const Parrot_PackfileAnnotation_attributes * const entity_attrs =
            PARROT_PACKFILEANNOTATION(entity);

        /* Handle creating of Key */
        PMC * key_array = VTABLE_get_pmc_keyed_str(interp, keys, entity_attrs->name);
        if (PMC_IS_NULL(key_array)) {
            /* Never see this name before. Create new FIA and add to keys. */
            key_array = Parrot_pmc_new_init_int(interp, enum_class_FixedIntegerArray, 3);
            VTABLE_set_integer_keyed_int(interp, key_array, 0, -1);
            VTABLE_set_integer_keyed_int(interp, key_array, 1, -1);
            VTABLE_set_integer_keyed_int(interp, key_array, 2, -1);

            VTABLE_set_pmc_keyed_str(interp, keys, entity_attrs->name, key_array);
        }

        /* lookup constant for name. */
        Parrot_mmd_multi_dispatch_from_c_args(interp, "get_or_create_constant",
                    "PS->I", attrs->const_table, entity_attrs->name, &name_id);

        /* lookup value */
        switch (entity_attrs->value_type) {
            case PF_ANNOTATION_KEY_TYPE_INT:
                value_id = entity_attrs->int_value;
                break;
            case PF_ANNOTATION_KEY_TYPE_STR:
                Parrot_mmd_multi_dispatch_from_c_args(interp, "get_or_create_constant",
                        "PS->I", attrs->const_table, entity_attrs->str_value,
                        &value_id);
                break;
            case PF_ANNOTATION_KEY_TYPE_PMC:
                Parrot_mmd_multi_dispatch_from_c_args(interp, "get_or_create_constant",
                        "PP->I", attrs->const_table, entity_attrs->pmc_value,
                        &value_id);
                break;
            default:
                Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_MALFORMED_PACKFILE,
                        "Unknown value type in PackfileAnnotation");
        }

        /* store entity */
        PackFile_Annotations_add_entry(interp, res, entity_attrs->offset, name_id,
                entity_attrs->value_type, value_id);

    }

    return res;
#line 173 "./src/pmc/packfileannotations.c"
}
static  void 
Parrot_PackfileAnnotations_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 51 "./src/pmc/packfileannotations.pmc"

    Parrot_PackfileAnnotations_attributes * const attrs =
            PMC_data_typed(_self, Parrot_PackfileAnnotations_attributes*);

    interp->vtables[enum_class_PackfileSegment]->init(interp, _self);
    attrs->annotations = Parrot_pmc_new(interp, enum_class_ResizablePMCArray);
    /*
    Don't initialize C<const_table>. It will be set to NULL bu auto_attrs
    handling. And should be set to proper PMC in set_directory.
    */

    PObj_custom_mark_SET(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 192 "./src/pmc/packfileannotations.c"
}
static  void 
Parrot_PackfileAnnotations_mark(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 75 "./src/pmc/packfileannotations.pmc"

    Parrot_PackfileAnnotations_attributes * const attrs =
            PARROT_PACKFILEANNOTATIONS(_self);

    Parrot_gc_mark_PMC_alive(interp, attrs->const_table);
    Parrot_gc_mark_PMC_alive(interp, attrs->annotations);

    interp->vtables[enum_class_PackfileSegment]->mark(interp, _self);
#line 206 "./src/pmc/packfileannotations.c"
}
static  void 
Parrot_PackfileAnnotations_set_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL index, PMC *annotation)
{
#line 140 "./src/pmc/packfileannotations.pmc"

    const Parrot_PackfileAnnotations_attributes * const attrs =
            PARROT_PACKFILEANNOTATIONS(_self);
    const Parrot_PackfileAnnotation_attributes  * const entity_attrs =
            PARROT_PACKFILEANNOTATION(annotation);
    INTVAL dummy;

    /* TODO: add checks described above */
    VTABLE_set_pmc_keyed_int(interp, attrs->annotations, index, annotation);

    /* Add required constants */
    Parrot_mmd_multi_dispatch_from_c_args(interp,
        "get_or_create_constant", "PS->I", attrs->const_table,
        entity_attrs->name, &dummy);

    switch (entity_attrs->value_type) {
        case PF_ANNOTATION_KEY_TYPE_STR:
            Parrot_mmd_multi_dispatch_from_c_args(interp,
                "get_or_create_constant", "PS->I", attrs->const_table,
                entity_attrs->str_value, &dummy);
            break;

        default:
            /* Do nothing. If value_type if INT it will be stored directly */
            break;
    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 239 "./src/pmc/packfileannotations.c"
}
static  void 
Parrot_PackfileAnnotations_set_pointer(PARROT_INTERP, ARGMOD(PMC *_self), void *pointer)
{
#line 209 "./src/pmc/packfileannotations.pmc"

    PackFile_Annotations * const a = (PackFile_Annotations*)pointer;
    Parrot_PackfileAnnotations_attributes * const attrs =
            PARROT_PACKFILEANNOTATIONS(_self);
    Parrot_PackfileAnnotation_attributes *annotation_attrs;
    opcode_t i;

    if (!attrs->const_table)
        Parrot_ex_throw_from_c_noargs(interp,
                EXCEPTION_MALFORMED_PACKFILE, "No constant table");


    /* Copy annotations to own array */
    VTABLE_set_integer_native(interp, attrs->annotations, 0); /* truncate */
    for (i = 0; i < a->num_keys; ++i) {
        PackFile_Annotations_Key * const key = &a->keys[i];
        opcode_t j;

        for (j = 0; j < (opcode_t)key->len; j++) {
            PMC * const annotation = Parrot_pmc_new(interp, enum_class_PackfileAnnotation);
            const opcode_t offs = a->base.data[(key->start + j) * 2 + ANN_ENTRY_OFF];
            const opcode_t val  = a->base.data[(key->start + j) * 2 + ANN_ENTRY_VAL];

            /* Poke directly to annotation attributes. */
            annotation_attrs         = PARROT_PACKFILEANNOTATION(annotation);
            annotation_attrs->offset = offs;
            annotation_attrs->name   = VTABLE_get_string_keyed_int(interp,
                                        attrs->const_table, key->name);
            switch (key->type) {
                case PF_ANNOTATION_KEY_TYPE_INT:
                    VTABLE_set_integer_native(interp, annotation, val);
                    break;
                case PF_ANNOTATION_KEY_TYPE_STR:
                    VTABLE_set_string_native(interp, annotation,
                        VTABLE_get_string_keyed_int(interp, attrs->const_table, val));
                    break;
                case PF_ANNOTATION_KEY_TYPE_PMC:
                    VTABLE_set_pmc(interp, annotation,
                        VTABLE_get_pmc_keyed_int(interp, attrs->const_table, val));
                    break;
                default:
                    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_MALFORMED_PACKFILE,
                            "Unknown value type %d in PackfileAnnotations", key->type);
            }

            VTABLE_push_pmc(interp, attrs->annotations, annotation);
        }
    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 294 "./src/pmc/packfileannotations.c"
}
static  void
Parrot_PackfileAnnotations_nci_set_directory(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    PMC* directory;
    
    const INTVAL arity = 2; /* "PiP" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    directory = VTABLE_get_pmc_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 181 "./src/pmc/packfileannotations.pmc"

    Parrot_PackfileAnnotations_attributes * const attrs =
            PARROT_PACKFILEANNOTATIONS(_self);
    PMC * const iter = VTABLE_get_iter(interp, directory);

    /* This should be SUPER(directory), but that doesn't work. */
    attrs->directory = directory;

    while (VTABLE_get_bool(interp, iter)) {
        STRING * const name = VTABLE_shift_string(interp, iter);
        PMC * const segment = VTABLE_get_pmc_keyed_str(interp, directory, name);
        if (VTABLE_isa(interp, segment,
                Parrot_str_new_constant(interp, "PackfileConstantTable"))) {
            attrs->const_table = segment;
            break;
        }
    }
#line 334 "./src/pmc/packfileannotations.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileAnnotations_nci_type(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 361 "./src/pmc/packfileannotations.pmc"

    #line 363 "./src/pmc/packfileannotations.c"
     {
        VTABLE_set_integer_keyed_int(interp, _call_object, 0, (INTVAL)PF_ANNOTATIONS_SEG);
        
        return;
     }
#line 362 "./src/pmc/packfileannotations.pmc"

#line 371 "./src/pmc/packfileannotations.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_PackfileAnnotations_update_vtable(VTABLE *vt) {
    vt->elements = Parrot_PackfileAnnotations_elements;
    vt->get_pmc_keyed_int = Parrot_PackfileAnnotations_get_pmc_keyed_int;
    vt->get_pointer = Parrot_PackfileAnnotations_get_pointer;
    vt->init = Parrot_PackfileAnnotations_init;
    vt->mark = Parrot_PackfileAnnotations_mark;
    vt->set_pmc_keyed_int = Parrot_PackfileAnnotations_set_pmc_keyed_int;
    vt->set_pointer = Parrot_PackfileAnnotations_set_pointer;
    vt->attr_size = sizeof(Parrot_PackfileAnnotations_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_PackfileAnnotations_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->elements = Parrot_PackfileAnnotations_elements;
    vt->get_pmc_keyed_int = Parrot_PackfileAnnotations_get_pmc_keyed_int;
    vt->get_pointer = Parrot_PackfileAnnotations_get_pointer;
    vt->mark = Parrot_PackfileAnnotations_mark;
    vt->attr_size = sizeof(Parrot_PackfileAnnotations_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_PackfileAnnotations_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_PackfileSegment_get_vtable(interp);
    Parrot_PackfileAnnotations_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_PackfileAnnotations_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_PackfileSegment_ro_get_vtable(interp);
    Parrot_PackfileAnnotations_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_PackfileAnnotations_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_PackfileSegment_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "PackfileAnnotations"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_PackfileAnnotations_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    isa = Parrot_PackfileSegment_get_isa(interp, isa);
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "PackfileAnnotations")), PMCNULL);
    return isa;
}

void
Parrot_PackfileAnnotations_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Fdirectory Fconst_table Fannotations ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_PackfileAnnotations_get_vtable(interp);
        vt->base_type      = enum_class_PackfileAnnotations;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "PackfileAnnotations");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_PackfileAnnotations_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_PackfileAnnotations_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_PackfileAnnotations;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_PackfileAnnotations_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "set_directory");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileAnnotations_nci_set_directory),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "type");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileAnnotations_nci_type),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_PackfileAnnotations_class_init */

#line 364 "./src/pmc/packfileannotations.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
