/* ex: set ro ft=c: -*- buffer-read-only:t -*-
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/resizablepmcarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_resizablepmcarray.h"
#include "pmc_fixedpmcarray.h"
#include "pmc_default.h"
#include "resizablepmcarray.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/resizablepmcarray.pmc"
/*
Copyright (C) 2001-2014, Parrot Foundation.

=head1 NAME

src/pmc/resizablepmcarray.pmc - ResizablePMCArray PMC

=head1 DESCRIPTION

This class, ResizablePMCArray, implements an resizable array which stores PMCs.
It puts things into Integer, Float, or String PMCs as appropriate.

=head2 Internal Functions

=over 4

=cut

*/

#define PMC_size(x)      ((Parrot_ResizablePMCArray_attributes *)PMC_data(x))->size
#define PMC_array(x)     ((Parrot_ResizablePMCArray_attributes *)PMC_data(x))->pmc_array
#define PMC_threshold(x) ((Parrot_ResizablePMCArray_attributes *)PMC_data(x))->resize_threshold

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

PARROT_INLINE
static void do_shift(ARGIN(PMC *arr))
        __attribute__nonnull__(1);

PARROT_INLINE
static void do_unshift(PARROT_INTERP, ARGIN(PMC *arr), ARGIN(PMC *val))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3);

PARROT_DOES_NOT_RETURN
PARROT_INLINE
static void throw_pop_empty(PARROT_INTERP)
        __attribute__nonnull__(1);

PARROT_DOES_NOT_RETURN
PARROT_INLINE
static void throw_shift_empty(PARROT_INTERP)
        __attribute__nonnull__(1);

#define ASSERT_ARGS_do_shift __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(arr))
#define ASSERT_ARGS_do_unshift __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(arr) \
    , PARROT_ASSERT_ARG(val))
#define ASSERT_ARGS_throw_pop_empty __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
#define ASSERT_ARGS_throw_shift_empty __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*

=item C<static void do_shift(PMC *arr)>

Removes and returns an item from the start of the array.
Moves the whole rest of the array around.

=cut

*/
PARROT_INLINE
static void
do_shift(ARGIN(PMC *arr))
{
    ASSERT_ARGS(do_shift)
    INTVAL    size = PMC_size(arr);
    PMC ** const item = PMC_array(arr);

    PMC_size(arr) = --size;
    memmove(item, item + 1, size * sizeof (PMC *));
    item[size] = PMCNULL;
}

/*

=item C<static void do_unshift(PARROT_INTERP, PMC *arr, PMC *val)>

Adds an item at the start of the array.
Moves the whole rest of the array around.

=cut

*/
PARROT_INLINE
static void
do_unshift(PARROT_INTERP, ARGIN(PMC *arr), ARGIN(PMC *val))
{
    ASSERT_ARGS(do_unshift)
    const INTVAL size = PMC_size(arr);
    PMC        **item;

    VTABLE_set_integer_native(interp, arr, size + 1);
    item = PMC_array(arr);
    memmove(item + 1, item, size * sizeof (PMC *));
    item[0] = val;
}
/*

=back

=head1 Vtable Functions

=over

=cut

*/
#line 143 "./src/pmc/resizablepmcarray.c"
static  PMC  * Parrot_ResizablePMCArray_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_ResizablePMCArray_defined_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  void  Parrot_ResizablePMCArray_delete_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  void  Parrot_ResizablePMCArray_delete_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  INTVAL  Parrot_ResizablePMCArray_exists_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  INTVAL  Parrot_ResizablePMCArray_exists_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  PMC  * Parrot_ResizablePMCArray_get_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  STRING  * Parrot_ResizablePMCArray_get_repr(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ResizablePMCArray_init_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL size);
static  FLOATVAL  Parrot_ResizablePMCArray_pop_float(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_ResizablePMCArray_pop_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_ResizablePMCArray_pop_pmc(PARROT_INTERP, ARGMOD(PMC *_self));
static  STRING  * Parrot_ResizablePMCArray_pop_string(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ResizablePMCArray_push_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_ResizablePMCArray_push_integer(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_ResizablePMCArray_push_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_ResizablePMCArray_push_string(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value);
static  void  Parrot_ResizablePMCArray_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL size);
static  void  Parrot_ResizablePMCArray_set_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_ResizablePMCArray_set_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, PMC *src);
static  void  Parrot_ResizablePMCArray_set_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, PMC *src);
static  FLOATVAL  Parrot_ResizablePMCArray_shift_float(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_ResizablePMCArray_shift_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC  * Parrot_ResizablePMCArray_shift_pmc(PARROT_INTERP, ARGMOD(PMC *_self));
static  STRING  * Parrot_ResizablePMCArray_shift_string(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_ResizablePMCArray_splice(PARROT_INTERP, ARGMOD(PMC *_self), PMC *from, INTVAL offset, INTVAL count);
static  void  Parrot_ResizablePMCArray_unshift_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_ResizablePMCArray_unshift_integer(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_ResizablePMCArray_unshift_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_ResizablePMCArray_unshift_string(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value);
static  void Parrot_ResizablePMCArray_nci_append(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ResizablePMCArray_nci_shift(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ResizablePMCArray_nci_pop(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ResizablePMCArray_nci_unshift(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_ResizablePMCArray_nci_push(PARROT_INTERP, ARGMOD(PMC *_self));
void    Parrot_ResizablePMCArray_class_init(PARROT_INTERP, int, int);
void    Parrot_ResizablePMCArray_ro_class_init(PARROT_INTERP, int, int);
static  PMC  *
Parrot_ResizablePMCArray_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 630 "./src/pmc/resizablepmcarray.pmc"

    PMC * const copy = interp->vtables[enum_class_FixedPMCArray]->clone(interp, _self);

    /* copy trimmed extra space */
    PMC_threshold(copy) = PMC_size(_self);

    return copy;
#line 192 "./src/pmc/resizablepmcarray.c"
}
static  INTVAL 
Parrot_ResizablePMCArray_defined_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 438 "./src/pmc/resizablepmcarray.pmc"

    PMC *val;

    if (key < 0)
        key += PMC_size(_self);

    if (key < 0 || key >= PMC_size(_self))
        return 0;

    val = VTABLE_get_pmc_keyed_int(interp, _self, key);

    if (PMC_IS_NULL(val)) {
        return 0;
    }

    return VTABLE_defined(interp, val);
#line 214 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_delete_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 383 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL idx  = VTABLE_get_integer(interp, key);
    VTABLE_delete_keyed_int(interp, _self, idx);
#line 223 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_delete_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 388 "./src/pmc/resizablepmcarray.pmc"

    PMC ** const data = PMC_array(_self);
    const INTVAL  n   = PMC_size(_self);
    INTVAL  i;

    for (i = key; i < n - 1; ++i)
        data[i] = data[i + 1];

    --PMC_size(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 239 "./src/pmc/resizablepmcarray.c"
}
static  INTVAL 
Parrot_ResizablePMCArray_exists_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 423 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL ix = VTABLE_get_integer(interp, key);
    return VTABLE_exists_keyed_int(interp, _self, ix);
#line 248 "./src/pmc/resizablepmcarray.c"
}
static  INTVAL 
Parrot_ResizablePMCArray_exists_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 410 "./src/pmc/resizablepmcarray.pmc"

    PMC **data;
    PARROT_GC_WRITE_BARRIER(interp, _self);
    if (key < 0)
        key += PMC_size(_self);

    if (key < 0 || key >= PMC_size(_self))
        return 0;

    data = PMC_array(_self);
    return !PMC_IS_NULL(data[key]);
#line 265 "./src/pmc/resizablepmcarray.c"
}
static  PMC  *
Parrot_ResizablePMCArray_get_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 292 "./src/pmc/resizablepmcarray.pmc"

    PMC **data;
    INTVAL    size;
    GETATTR_ResizablePMCArray_size(interp, _self, size);

    if (key < 0)
        key += size;
    if (key < 0)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
            "index out of bounds");
    if (key >= size)
        return PMCNULL;

    data = PMC_array(_self);
    if (PMC_IS_NULL(data[key]))
        return PMCNULL;

    return data[key];
#line 289 "./src/pmc/resizablepmcarray.c"
}
static  STRING  *
Parrot_ResizablePMCArray_get_repr(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 649 "./src/pmc/resizablepmcarray.pmc"

    INTVAL  j;
    const INTVAL n = VTABLE_elements(interp, _self);
    STRING *res = CONST_STRING(interp, "[ ");
    STRING *ret;

    for (j = 0; j < n; ++j) {
        PMC * const val = VTABLE_get_pmc_keyed_int(interp, _self, j);
        res      = Parrot_str_concat(interp, res, VTABLE_get_repr(interp, val));

        if (j < n - 1)
            res = Parrot_str_concat(interp, res, CONST_STRING(interp, ", "));
    }

    ret = Parrot_str_concat(interp, res, CONST_STRING(interp, " ]"));
    return ret;
#line 311 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_init_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL size)
{
#line 133 "./src/pmc/resizablepmcarray.pmc"

    if (size < 0)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "illegal argument");
    interp->vtables[enum_class_FixedPMCArray]->init_int(interp, _self, size);
    if (size > 0) {
        PMC_threshold(_self) = size;
        PARROT_GC_WRITE_BARRIER(interp, _self);
    }
#line 326 "./src/pmc/resizablepmcarray.c"
}
static  FLOATVAL 
Parrot_ResizablePMCArray_pop_float(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 526 "./src/pmc/resizablepmcarray.pmc"

    INTVAL   size = PMC_size(_self);
    PMC     *data;

    if (0 == size)
        throw_pop_empty(interp);

    data           = PMC_array(_self)[--size];
    PMC_size(_self) = size;

    PARROT_GC_WRITE_BARRIER(interp, _self);
    return VTABLE_get_number(interp, data);
#line 344 "./src/pmc/resizablepmcarray.c"
}
static  INTVAL 
Parrot_ResizablePMCArray_pop_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 540 "./src/pmc/resizablepmcarray.pmc"

    INTVAL  size = PMC_size(_self);
    PMC    *data;

    if (0 == size)
        throw_pop_empty(interp);

    data           = PMC_array(_self)[--size];
    PMC_size(_self) = size;

    PARROT_GC_WRITE_BARRIER(interp, _self);
    return VTABLE_get_integer(interp, data);
#line 362 "./src/pmc/resizablepmcarray.c"
}
static  PMC  *
Parrot_ResizablePMCArray_pop_pmc(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 554 "./src/pmc/resizablepmcarray.pmc"

    INTVAL size = PMC_size(_self);
    PMC   *data;

    if (0 == size)
        throw_pop_empty(interp);

    data           = PMC_array(_self)[--size];
    PMC_size(_self) = size;

    PARROT_GC_WRITE_BARRIER(interp, _self);
    return data;
#line 380 "./src/pmc/resizablepmcarray.c"
}
static  STRING  *
Parrot_ResizablePMCArray_pop_string(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 568 "./src/pmc/resizablepmcarray.pmc"

    INTVAL  size = PMC_size(_self);
    PMC    *data;

    if (0 == size)
        throw_pop_empty(interp);

    data           = PMC_array(_self)[--size];
    PMC_size(_self) = size;

    PARROT_GC_WRITE_BARRIER(interp, _self);
    return VTABLE_get_string(interp, data);
#line 398 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_push_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 473 "./src/pmc/resizablepmcarray.pmc"


    const INTVAL size = PMC_size(_self);
    PMC   * const val = Parrot_pmc_new(interp, enum_class_Float);

    VTABLE_set_number_native(interp, val, value);
    VTABLE_set_pmc_keyed_int(interp, _self, size, val);
#line 411 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_push_integer(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 482 "./src/pmc/resizablepmcarray.pmc"


    const INTVAL size = PMC_size(_self);
    PMC   * const val = Parrot_pmc_new_init_int(interp, enum_class_Integer, value);

    VTABLE_set_pmc_keyed_int(interp, _self, size, val);
#line 423 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_push_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 490 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL size   = PMC_size(_self);
    const INTVAL thresh = PMC_threshold(_self);

    if (PMC_array(_self) && size < thresh)
        PMC_size(_self) = size + 1;
    else {
        VTABLE_set_integer_native(interp, _self, size + 1);
    }
    ((PMC **)PMC_array(_self))[size] = value;
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 440 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_push_string(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value)
{
#line 502 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL size = PMC_size(_self);
    PMC   * const val = Parrot_pmc_new(interp, enum_class_String);

    VTABLE_assign_string_native(interp, val, value);
    VTABLE_set_pmc_keyed_int(interp, _self, size, val);
#line 452 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL size)
{
#line 154 "./src/pmc/resizablepmcarray.pmc"

    if (size < 0)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "illegal argument");

    if (!PMC_array(_self)) {
        /* empty - used fixed routine */
        if (size < 8) {

            interp->vtables[enum_class_FixedPMCArray]->set_integer_native(interp, _self, 8);
            PMC_size(_self)      = size;
            PMC_threshold(_self) = 8;

        }
        else {
            interp->vtables[enum_class_FixedPMCArray]->set_integer_native(interp, _self, size);
            PMC_threshold(_self) = size;
        }
    }
    else if (size == PMC_size(_self)) {
        return;
    }
    else if (size <= PMC_threshold(_self)) {

        PMC_size(_self) = size;
        PARROT_GC_WRITE_BARRIER(interp, _self);
        /* we could shrink here if necessary */
        return;
    }
    else {
        INTVAL i, cur;
        i = cur = PMC_threshold(_self);
        if (cur < 8192)
            cur = (size < 2 * cur) ? (2 * cur) : size;
        else {
            const INTVAL needed = size - cur;
            cur   += needed + 4096;
            cur   &= ~0xfff;
        }

        if (cur < 8)
            cur = 8;

        PMC_array(_self) = mem_gc_realloc_n_typed_zeroed(interp,
                PMC_array(_self), cur, i, PMC *);

        for (; i < cur; ++i) {
            (PMC_array(_self))[i] = PMCNULL;
        }

        PMC_threshold(_self) = cur;
        PMC_size(_self)      = size;
    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 512 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_set_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 347 "./src/pmc/resizablepmcarray.pmc"

    INTVAL size;
    INTVAL i;

    if (_self == value)
        return;

    if (!VTABLE_does(interp, value, CONST_STRING(interp, "array")))
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "Can't set self from this type");

    if (PMC_array(_self))
        mem_gc_free(interp, PMC_array(_self));

    size            = PMC_size(_self) = VTABLE_elements(interp, value);
    PMC_array(_self) = mem_gc_allocate_n_typed(interp, size, PMC *);

    for (i = 0; i < size; ++i)
        (PMC_array(_self))[i] = VTABLE_get_pmc_keyed_int(interp, value, i);

    PObj_custom_mark_destroy_SETALL(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 540 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_set_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, PMC *src)
{
#line 343 "./src/pmc/resizablepmcarray.pmc"

    interp->vtables[enum_class_FixedPMCArray]->set_pmc_keyed(interp, _self, key, src);
#line 548 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_set_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, PMC *src)
{
#line 326 "./src/pmc/resizablepmcarray.pmc"

    PMC **data;

    if (key < 0)
        key += PMC_size(_self);

    if (key < 0)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
            "index out of bounds");

    if (key >= PMC_size(_self))
        VTABLE_set_integer_native(interp, _self, key+1);

    data      = PMC_array(_self);
    data[key] = src;
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 570 "./src/pmc/resizablepmcarray.c"
}
static  FLOATVAL 
Parrot_ResizablePMCArray_shift_float(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 229 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL size = PMC_size(_self);
    FLOATVAL value;

    if (0 == size)
        throw_shift_empty(interp);

    value = VTABLE_get_number(interp, PMC_array(_self)[0]);
    do_shift(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);

    return value;
#line 588 "./src/pmc/resizablepmcarray.c"
}
static  INTVAL 
Parrot_ResizablePMCArray_shift_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 242 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL size = PMC_size(_self);
    INTVAL value;

    if (0 == size)
        throw_shift_empty(interp);

    value = VTABLE_get_integer(interp, PMC_array(_self)[0]);
    do_shift(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);

    return value;
#line 606 "./src/pmc/resizablepmcarray.c"
}
static  PMC  *
Parrot_ResizablePMCArray_shift_pmc(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 255 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL size = PMC_size(_self);
    PMC   *data;

    if (0 == size)
        throw_shift_empty(interp);

    data = PMC_array(_self)[0];
    do_shift(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);

    return data;
#line 624 "./src/pmc/resizablepmcarray.c"
}
static  STRING  *
Parrot_ResizablePMCArray_shift_string(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 268 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL size = PMC_size(_self);
    STRING  *value;

    if (0 == size)
        throw_shift_empty(interp);

    value = VTABLE_get_string(interp, PMC_array(_self)[0]);
    do_shift(_self);
    PARROT_GC_WRITE_BARRIER(interp, _self);

    return value;
#line 642 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_splice(PARROT_INTERP, ARGMOD(PMC *_self), PMC *from, INTVAL offset, INTVAL count)
{
#line 680 "./src/pmc/resizablepmcarray.pmc"

    const INTVAL elems0 = VTABLE_elements(interp, _self);
    const INTVAL elems1 = VTABLE_elements(interp, from);

    PMC **item = 0;
    INTVAL tail;
    INTVAL i;

    /* start from end? */
    if (offset < 0)
        offset += elems0;
    if (count < 0)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "illegal argument");
    if (offset < 0)
        Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
                "index out of bounds");

    /* number of elements to the right of the splice (the "tail") */
    tail = elems0 - offset - count;
    if (tail < 0) tail = 0;

    item = PMC_array(_self);
    if (tail > 0 && count > elems1) {
        /* we're shrinking the array, so first move the tail left */
        memmove(item + offset + elems1, item + offset + count,
             tail * sizeof (PMC *));
    }

    /* now resize the array */
    VTABLE_set_integer_native(interp, _self, offset + elems1 + tail);

    item = PMC_array(_self);
    if (tail > 0 && count < elems1) {
        /* the array grew, so move the tail to the right */
        memmove(item + offset + elems1, item + offset + count,
             tail * sizeof (PMC *));
    }

    /* now copy C<from>'s elements into _self */
    if (elems1 > 0) {
        PMC *iter = VTABLE_get_iter(interp, from);
        for (i = 0; i < elems1; i++)
            item[offset + i] = VTABLE_shift_pmc(interp, iter);
    }
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 694 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_unshift_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 599 "./src/pmc/resizablepmcarray.pmc"

    PMC * const val = Parrot_pmc_new(interp, enum_class_Float);
    VTABLE_set_number_native(interp, val, value);
    do_unshift(interp, _self, val);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 705 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_unshift_integer(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 605 "./src/pmc/resizablepmcarray.pmc"

    PMC * const val = Parrot_pmc_new_init_int(interp, enum_class_Integer, value);
    do_unshift(interp, _self, val);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 715 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_unshift_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 610 "./src/pmc/resizablepmcarray.pmc"

    do_unshift(interp, _self, value);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 724 "./src/pmc/resizablepmcarray.c"
}
static  void 
Parrot_ResizablePMCArray_unshift_string(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value)
{
#line 614 "./src/pmc/resizablepmcarray.pmc"

    PMC * const val = Parrot_pmc_new(interp, enum_class_String);
    VTABLE_set_string_native(interp, val, value);
    do_unshift(interp, _self, val);
    PARROT_GC_WRITE_BARRIER(interp, _self);
#line 735 "./src/pmc/resizablepmcarray.c"
}
static  void
Parrot_ResizablePMCArray_nci_append(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    PMC* other;
    
    const INTVAL arity = 2; /* "PiP" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    other = VTABLE_get_pmc_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 743 "./src/pmc/resizablepmcarray.pmc"


    const INTVAL n = VTABLE_elements(interp, _self);
    const INTVAL m = VTABLE_elements(interp, other);

    if (!m)
        return;

    /* pre-size it */
    VTABLE_set_integer_native(interp, _self, n + m);

    if (other->vtable->base_type == _self->vtable->base_type
    ||  other->vtable->base_type == enum_class_FixedPMCArray) {
        PMC ** const other_data = PMC_array(other);
        PMC ** const this_data  = PMC_array(_self);

        /* libc is faster at copying data than a manual loop here */
        memmove(this_data + n, other_data, m  * sizeof (PMC *));
    }
    else {
        PMC ** const this_data = PMC_array(_self);
        INTVAL i;

        for (i = 0; i < m; ++i)
            this_data[n + i] = VTABLE_get_pmc_keyed_int(interp, other, i);
    }

    #line 785 "./src/pmc/resizablepmcarray.c"
    {
        PARROT_GC_WRITE_BARRIER(interp, _self);
        return;
    }
#line 770 "./src/pmc/resizablepmcarray.pmc"

#line 792 "./src/pmc/resizablepmcarray.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_ResizablePMCArray_nci_shift(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 786 "./src/pmc/resizablepmcarray.pmc"

    PMC * const value = VTABLE_shift_pmc(interp, _self);
    #line 822 "./src/pmc/resizablepmcarray.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)value);
        
        return;
     }
#line 788 "./src/pmc/resizablepmcarray.pmc"

#line 830 "./src/pmc/resizablepmcarray.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_ResizablePMCArray_nci_pop(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    
    const INTVAL arity = 1; /* "Pi" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);

    { /* BEGIN PMETHOD BODY */
#line 791 "./src/pmc/resizablepmcarray.pmc"

    PMC * const value = VTABLE_pop_pmc(interp, _self);
    #line 860 "./src/pmc/resizablepmcarray.c"
     {
        VTABLE_set_pmc_keyed_int(interp, _call_object, 0, (PMC*)value);
        
        return;
     }
#line 793 "./src/pmc/resizablepmcarray.pmc"

#line 868 "./src/pmc/resizablepmcarray.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_ResizablePMCArray_nci_unshift(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    PMC* value;
    
    const INTVAL arity = 2; /* "PiP" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    value = VTABLE_get_pmc_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 808 "./src/pmc/resizablepmcarray.pmc"

    VTABLE_unshift_pmc(interp, _self, value);
#line 900 "./src/pmc/resizablepmcarray.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_ResizablePMCArray_nci_push(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    /* BEGIN PARAMS SCOPE */
    PMC* value;
    
    const INTVAL arity = 2; /* "PiP" */
    INTVAL param_count = VTABLE_elements(interp, _call_object);
    if (param_count != arity)
        Parrot_ex_throw_from_c_args(interp, NULL,
                                    EXCEPTION_INVALID_OPERATION,
                                    "wrong number of arguments: %d passed, %d expected",
                                    param_count, arity);
    _self = VTABLE_get_pmc_keyed_int(interp, _call_object, 0);
    value = VTABLE_get_pmc_keyed_int(interp, _call_object, 1);

    { /* BEGIN PMETHOD BODY */
#line 812 "./src/pmc/resizablepmcarray.pmc"

    VTABLE_push_pmc(interp, _self, value);
#line 932 "./src/pmc/resizablepmcarray.c"

    } /* END PMETHOD BODY */

    

    /* END PARAMS SCOPE */
    return;
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_ResizablePMCArray_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_ResizablePMCArray_clone;
    vt->defined_keyed_int = Parrot_ResizablePMCArray_defined_keyed_int;
    vt->delete_keyed = Parrot_ResizablePMCArray_delete_keyed;
    vt->delete_keyed_int = Parrot_ResizablePMCArray_delete_keyed_int;
    vt->exists_keyed = Parrot_ResizablePMCArray_exists_keyed;
    vt->exists_keyed_int = Parrot_ResizablePMCArray_exists_keyed_int;
    vt->get_pmc_keyed_int = Parrot_ResizablePMCArray_get_pmc_keyed_int;
    vt->get_repr = Parrot_ResizablePMCArray_get_repr;
    vt->init_int = Parrot_ResizablePMCArray_init_int;
    vt->pop_float = Parrot_ResizablePMCArray_pop_float;
    vt->pop_integer = Parrot_ResizablePMCArray_pop_integer;
    vt->pop_pmc = Parrot_ResizablePMCArray_pop_pmc;
    vt->pop_string = Parrot_ResizablePMCArray_pop_string;
    vt->push_float = Parrot_ResizablePMCArray_push_float;
    vt->push_integer = Parrot_ResizablePMCArray_push_integer;
    vt->push_pmc = Parrot_ResizablePMCArray_push_pmc;
    vt->push_string = Parrot_ResizablePMCArray_push_string;
    vt->set_integer_native = Parrot_ResizablePMCArray_set_integer_native;
    vt->set_pmc = Parrot_ResizablePMCArray_set_pmc;
    vt->set_pmc_keyed = Parrot_ResizablePMCArray_set_pmc_keyed;
    vt->set_pmc_keyed_int = Parrot_ResizablePMCArray_set_pmc_keyed_int;
    vt->shift_float = Parrot_ResizablePMCArray_shift_float;
    vt->shift_integer = Parrot_ResizablePMCArray_shift_integer;
    vt->shift_pmc = Parrot_ResizablePMCArray_shift_pmc;
    vt->shift_string = Parrot_ResizablePMCArray_shift_string;
    vt->splice = Parrot_ResizablePMCArray_splice;
    vt->unshift_float = Parrot_ResizablePMCArray_unshift_float;
    vt->unshift_integer = Parrot_ResizablePMCArray_unshift_integer;
    vt->unshift_pmc = Parrot_ResizablePMCArray_unshift_pmc;
    vt->unshift_string = Parrot_ResizablePMCArray_unshift_string;
    vt->attr_size = sizeof(Parrot_ResizablePMCArray_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_ResizablePMCArray_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_ResizablePMCArray_clone;
    vt->defined_keyed_int = Parrot_ResizablePMCArray_defined_keyed_int;
    vt->exists_keyed = Parrot_ResizablePMCArray_exists_keyed;
    vt->exists_keyed_int = Parrot_ResizablePMCArray_exists_keyed_int;
    vt->get_pmc_keyed_int = Parrot_ResizablePMCArray_get_pmc_keyed_int;
    vt->get_repr = Parrot_ResizablePMCArray_get_repr;
    vt->attr_size = sizeof(Parrot_ResizablePMCArray_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ResizablePMCArray_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_FixedPMCArray_get_vtable(interp);
    Parrot_ResizablePMCArray_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_ResizablePMCArray_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_FixedPMCArray_ro_get_vtable(interp);
    Parrot_ResizablePMCArray_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_ResizablePMCArray_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_FixedPMCArray_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "ResizablePMCArray"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_ResizablePMCArray_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    isa = Parrot_FixedPMCArray_get_isa(interp, isa);
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "ResizablePMCArray")), PMCNULL);
    return isa;
}

void
Parrot_ResizablePMCArray_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Isize :pmc_array Iresize_threshold ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_ResizablePMCArray_get_vtable(interp);
        vt->base_type      = enum_class_ResizablePMCArray;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "ResizablePMCArray");
        vt->provides_str = CONST_STRING_GEN(interp, "array");
        vt->isa_hash     = Parrot_ResizablePMCArray_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_ResizablePMCArray_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_ResizablePMCArray;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_ResizablePMCArray_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "append");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ResizablePMCArray_nci_append),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "shift");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ResizablePMCArray_nci_shift),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "pop");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ResizablePMCArray_nci_pop),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "unshift");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ResizablePMCArray_nci_unshift),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "push");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_ResizablePMCArray_nci_push),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_ResizablePMCArray_class_init */

#line 815 "./src/pmc/resizablepmcarray.pmc"


/*

=back

=head2 Auxiliar functions

=over 4

=item C<static void do_shift(PMC *arr)>

Common part for shift operations.

=item C<static void do_unshift(PARROT_INTERP, PMC *arr, PMC *val)>

Common part for unshift operations.

=item C<static void throw_shift_empty(PARROT_INTERP)>

=item C<static void throw_pop_empty(PARROT_INTERP)>

Throws with the appropriate message.

=cut

*/

PARROT_DOES_NOT_RETURN
PARROT_INLINE
static void
throw_shift_empty(PARROT_INTERP)
{
    ASSERT_ARGS(throw_shift_empty)
    Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
            "Can't shift from an empty array");
}

PARROT_DOES_NOT_RETURN
PARROT_INLINE
static void
throw_pop_empty(PARROT_INTERP)
{
    ASSERT_ARGS(throw_pop_empty)
    Parrot_ex_throw_from_c_noargs(interp, EXCEPTION_OUT_OF_BOUNDS,
            "Can't pop from an empty array");
}

/*

=back

=head1 See also

F<docs/pdds/pdd17_basic_types.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
